/*
Barre d'Outils OGSPY, extension firefox d'aide aux mise à jour de serveurs OGSPY

OGSPY Toolbar, a firefox plugin for helping players in updating OGSPY servers game datas

Copyright (C) 2006-2007 Naqdazar (ajdr@free.fr)

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
au titre des clauses de la Licence Publique Générale GNU, telle que publiée par la
Free Software Foundation ; soit la version 2 de la Licence.
Ce programme est distribué dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ;
 sans mÛme une garantie implicite de COMMERCIABILITE ou DE CONFORMITE A UNE UTILISATION PARTICULIERE.

 Voir la Licence Publique Générale GNU pour plus de détails.

 Vous devriez avoir reþu un exemplaire de la Licence Publique Générale GNU avec ce programme ;
  si ce n'est pas le cas, écrivez Ó la Free Software Foundation Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

This program is free software; you can redistribute it and/or modify it under the
terms of the GNU General Public licence as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details.

You should have received a copy of the GNU General Public licence along with this program;
 if not, write to the Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/**
 * #################### Variables globale pour Ogame / E-Univers ####################
 **/
 
 // Encodage UTF-8 nécessaires pour que les expressions régulières foncitonnent


var OGPlugin_selectedTyp = -1;
var OGPlugin_selectedWho = -1;
var OGPlugin_selectedGalaxy = -1;
var OGPlugin_selectedSystem = -1;
var OGPlugin_selectedRanks = -1;
var ogs_buff_statusviewline="";


var AllyTAGFound=""; // TAG du groupe Alliance(tableau)
var PlanetNameWithCoords; // ex Terria [1:415:5] ou  Terrania (Lune) [1:74:5]
// ================================== GESTION DES TAMPONS ===================================
var GalViewsBuffer="";
var Curr_GalViewBufCount=0;
var StatsArrayBuffer= new Array(new Array("","",""),new Array("","","")); // tampons de données classement Ogame
var Curr_StatBufCount = new Array(new Array(0,0,0),new Array(0,0,0)); // indicateurs des tampons stats Ogame
var StatsWhoTabNames = new Array("", ""); // eg Joueurs, Alliances
var StatsTypeTabNames = new Array("", "", ""); // eg Points, Vaisseaux, Recherche

// tableau de constante pour l'indication du type de classement copié
var ogs_stats_who_tags = new Array("joueur" , "alliance");
var ogs_stats_what_tags = new Array("points" ,  "flotte"  , "recherche");

// variable d'envoi de tampon à définir : tous les tampons doivent être simulatnément répertoriés
// pour les tampons stats, nécessiste de récupérer le type stats who/what du header
//var ogs_buffersenttype = 0; // indique le type de tampon
//var ogs_buffersentwhat = 0;
//var ogs_buffersentwhat = 0;

//============================================================================================
var OGPlugin_responsetext = "";

var ogs_ismodecommandant=false; // global, réinit à faux après clic bouton envoyer

var ogs_currentogameuniverse = "";
var ogs_lastnounivers = 0; // stocke le numéro d'univers récupérer à partir du document
var ogs_targetogspyurl = ""; // déplacé de  onPageLoad: function(aEvent) à Ici (global)
var ogs_targetserverid = ""; // déplacé de  onPageLoad: function(aEvent) à Ici (global)
var ogs_timerattente;
var ogs_httprequestinprogress=false;

// données de saubegarde dernières stats(Ogame)
var ogs_LastStatWho = -1; // alliance ou joueur?
var ogs_LastStatTyp = -1; // points, vaisseaux ou recherche?

var ogs_StatusLabelsHistory = new Array(); // tableau historique pour les messages de la barre d'Útat du plugin
var ogs_laststatuslabel = ""; // chaine tampon pour le dernier message affiché sur la barre

//var OGPlugin_autoreport = 0;
//var OGPlugin_handleallystats = 0;



/**
 * Capture des rapports de la page messages à la demande (Ogame - EUnivers)
 * les données capturées sont analogues à un copier-coller.
 * @param reportscat (byte):  1 -> rapport d'espionnage standard
 *                            2 -> rapport d'espionnage ennemi
 *                            4 -> rapport re recyclage
 *                            8 -> libellé de rapport de combat // à revoir, essai!
 * @param partargetdoc : document html ayant répondu à l'événement onload ou autre
 **/
function OGPlugin_GetReportsByCat(reportscat, partargetdoc, dowritestatus) {

        if (partargetdoc==null) alert('partargetdoc indefini pour OGPlugin_GetReportsByCat');
        var raportscaptured = OGPlugin_GetSpyReportsTextSel(partargetdoc);
        // alert(ogs_gametype+"\n"+raportscaptured);
        if (raportscaptured==null || raportscaptured=='') return 'noreports';
        var reportsresultstring = "";
        var finalreports_tab = new Array();
        //=======================================================================
        // masques des rapports d'espionnage directs
        const OgameStdEspioReportRegExp = /\d\d-\d\d\s\d\d\:\d\d\:\d\d[\t\s]+Quartier\sg.n.ral[\t\s]+Espionnage\sde[\W,\w,\d,\[,\],\-,\:,\,,\.,\t,\n,\s]+Probabilité\sde\sdestruction\sde\sla\sflotte\sd'espionnage\s\:\d+%/gi;
        const EUniversStdEspioReportRegExp =/\s\d{2}\/\d{2}\/\d{4}\s\d{2}\:\d{2}\:\d{2}[\s\D]+?Espionnage\sde[\s\S]+?Probabilité\sde\sdestruction\sde\sla\sflotte\sespionnage\s\:\s\d+\s?%/gi; //by jormund
		  /*/\w+\s\d+\s\w+\s\d{2}\:\d{2}\:\d{2}[\t\s]+Tour\sde\scontr.le\sEspionnage\sde\s[\W,\w,\d,\[,\],\-,\:,\,,\.,\!,\t,\n,\s]+Probabilité\sde\sdestruction\sde\sla\sflotte\sespionnage\s\:\s\d+\s?%/gi;*/

        // masques des rapports d'espionnage ennemi
        const OgameEnemyEspioReportRegExp = /\d\d-\d\d\s\d\d\:\d\d\:\d\d[\t\s]+Contrôle\sa.rospatial[\t\s]+Activité\sd'espionnage[\n\t\s]+Une\sflotte\sennemie\sde\sla\splanète\s[\W,\w,\d,\[,\],\-]+\s\[\d+\:\d+\:\d+\]\s(?:\s\(Lune\)\s)?a\sété\saperçue\sà\sproximité\sde\svotre\splanète\s[\W,\w,\d,\[,\],\-]+\s(?:\s\(Lune\)\s)?\[\d+\:\d+\:\d+\]\.\sProbabilité\sde\sdestruction\sde\sla\sflotte\sd'espionnage\s\:\s\d+\s%/gi;
        const EUniversEnemyEspioReportRegExp = /[\t\s]?\w+\s\d+\s\w+\s\d\d\:\d\d\:\d\d[\t\s]+Tour\sde\scontrôle[\t\s]+Activité\sespionnage[\n\t\s]+Une\sflotte\sennemie\sde\sla\splanète\s[\W,\w,\d,\[,\],\-]+\s\[\d+\:\d+\:\d+\]\sa\sété\saperçue\sà\sproximité\sde\svotre\splanète\s[\W,\w,\d,\[,\],\-]+\s\[\d+\:\d+\:\d+\]\.?\sProbabilité\sde\sdestruction\sde\sla\sflotte\sespionnage\s\:\s\d+\s%/gi;

        // masques des rapports de recyclage
        const OgameRecyReportsRegExp = /\d\d-\d\d\s\d\d\:\d\d\:\d\d[\t\s]+Flotte[\t\s]+Rapport\sd'exploitation\sdu\schamp\sde\sdébris\saux\scoordonnées\s\[\d+\:\d+\:\d+\][\n\t\s]+Vos\s\d+\srecycleurs\sont\sune\scapacité\stotale\sde\s\d{1,3}(?:\.\d{3})*\.\s\d{1,3}(?:\.\d{3})*\sunités\sde\smétal\set\s\d{1,3}(?:\.\d{3})*\sunités\sde\scristal\ssont\sdispersées\sdans\sce\schamp\.\sVous\savez\scollecté\s(\d{1,3}(?:\.\d{3})*)\sunités\sde\smétal\set\s(\d{1,3}(?:\.\d{3})*)\sunités\sde\scristal\./gi;
        const EUniversRecyReportsRegExp = /[\t\s]?\w+\s\d+\s\w+\s\d\d\:\d\d\:\d\d[\t\s]+Tour\sde\scontr.le[\t\s]+Recyclage[\n\t\s]+Votre\sflotte\scomposée\sde\s\d+\sCollecteurs?\sayant\sune\scapacitée?\sde\s\d+\s[à|a]\scollectée?\s(\d{1,3}(?:\s\d{3})*)\sde\stitane\set\s(\d{1,3}(?:\s\d{3})*)\sde\scarbone\saux\scoordonnées\ssuivantes\s\:[\s\t\n]+\[?\d+\:\d+\:\d+\]?\.?/gi;

        //=======================================================================

        if ((reportscat & 1) == 1) { /* espionnage direct */
            if (ogs_gametype==ogs_ogametype) var StdEspioReportRegExp = OgameStdEspioReportRegExp;
            else if(ogs_gametype==ogs_euniverstype) var StdEspioReportRegExp = EUniversStdEspioReportRegExp;

				//alert(raportscaptured);
            var stdespioreports_tab = raportscaptured.match(StdEspioReportRegExp);
				//alert(stdespioreports_tab);//by jormund
            //reportsresultstring = stdespioreports_tab.join(ogsseparateur_rapports)+ogsseparateur_rapports;
            if (stdespioreports_tab!=null)
                finalreports_tab = finalreports_tab.concat(stdespioreports_tab);
            else //alert("Aucun rapport d'espionnage d\u00e9tect\u00e9!");
             if (dowritestatus) OGPlugin_SetStatusViewLabel("failure", "Envoi s\u00e9lectif de rapports: Aucun rapport d'espionnage d\u00e9tect\u00e9!");
        }
        if ((reportscat & 2) == 2) { // a & b == opération binaire /* espionnage ennemi */
            if (ogs_gametype==ogs_ogametype) var EnemyEspioReportRegExp = OgameEnemyEspioReportRegExp;
            else if(ogs_gametype==ogs_euniverstype) var EnemyEspioReportRegExp = EUniversEnemyEspioReportRegExp;

            var enemyespioreports_tab = raportscaptured.match(EnemyEspioReportRegExp);
            //alert(raportscaptured.match(EnemyEspioReportRegExp));
            //reportsresultstring = enemyespioreports_tab.join(ogsseparateur_rapports)+ogsseparateur_rapports;
            if (enemyespioreports_tab!=null)
                finalreports_tab = finalreports_tab.concat(enemyespioreports_tab);
            else //alert("Aucun rapport d'espionnage ennemi d\u00e9tect\u00e9!");
            if (dowritestatus) OGPlugin_SetStatusViewLabel("failure", "Envoi s\u00e9lectif de rapports: Aucun rapport d'espionnage ennemi d\u00e9tect\u00e9!");
        }
        if ((reportscat & 4) == 4) { /* rapport de recyclage */
            if (ogs_gametype==ogs_ogametype) var RecyReportsRegExp = OgameRecyReportsRegExp;
            else if(ogs_gametype==ogs_euniverstype) var RecyReportsRegExp = EUniversRecyReportsRegExp;
            
            var recyreports_tab = raportscaptured.match(RecyReportsRegExp);

            //reportsresultstring = recyreports_tab.join(ogsseparateur_rapports)+ogsseparateur_rapports;
            if (recyreports_tab!=null) {

                // retirer rapport avec aucune ressources récupérées(vides)
                i = recyreports_tab.length;
                while (i>0) {
                       if (parseInt(recyreports_tab[1])==0 && parseInt(recyreports_tab[2])==0) // test si chaque ressource nulle
                          recyreports_tab.pop(); // suppression du rapport
                          
                       i--;
                
                }
                
                // ajout du sous-tableau de rapports de recyclages
                finalreports_tab = finalreports_tab.concat(recyreports_tab);
                
            }
            else //alert("Aucun rapport de recyclage d\u00e9tect\u00e9!");
            if (dowritestatus) OGPlugin_SetStatusViewLabel("failure", "Envoi s\u00e9lectif de rapports: Aucun rapport de recyclage d\u00e9tect\u00e9!");
        }
        reportsresultstring = finalreports_tab.join(ogsseparateur_rapports);
			//partargetdoc.body.innerHTML+=reportsresultstring;//by jormund
        if (ogs_getreportsdebug_mode==true) alert('OGPlugin_GetReportsByCat:\n'+reportsresultstring);
        return reportsresultstring;
}

/**
 * Capture les rapports choisis de la page des messages en récupérant le texte
 * puis en filtrant son contenu par catégorie ainsi qu'ne y appliquant les filtres
 * de diverses options.
 * @param partargetdoc document source du navigateur
 * @return retourne les rapports choisis et filtrés
 **/
function OGPlugin_GetMessagesText(partargetdoc) { // à revoir !!!
      /*  reportscat (byte):  1 -> rapport d'espionnage standard
                              2 -> rapport d'espionnage ennemi
                              4 -> rapport re recyclage
                              8 -> message de retour de flotte // à revoir, essai! */
      var reportcats = 0; // on commence à zéro pour les opérations binaires.

      if (OGPlugin_getBoolPref('OGPlugin.settings.handlespyreports', false, '')) reportcats |= 1;
      if (OGPlugin_getBoolPref('OGPlugin.settings.handleenemyspy', false, '')) reportcats |= 2;
      if (OGPlugin_getBoolPref('OGPlugin.settings.handlerecyreports', false, '')) reportcats |= 4;

      var reports_data = OGPlugin_GetReportsByCat(reportcats, partargetdoc);

      // filtrage des rapports suivant les options choisies
      reports_data = OGPlugin_FilterSpyReportsText(reports_data); // à revoir !!!

      //alert(reports_data);
      return reports_data
}

/**
 * Filtre des rapports capturés suivant les options choisies
 * @param parreportsdata chaîne: accepte des rapports balisés
 * @return renvoie les rapports filtrés suivant les options utilisateur
 **/
function OGPlugin_FilterSpyReportsText(parreportsdata) { // à revoir !!!

          var reportsdata_filtered = parreportsdata;

          //FILTRAGE RESSOURCES
          if (OGPlugin_getBoolPref('OGPlugin.settings.filterspyreportressource', false, '')==true)
          {
            if (ogs_gametype==ogs_ogametype) {
                var ogame_ressource_pattern = /Métal\:\t[\d\.]+\s\tCristal:\t[\d\.]+[\n\t]Deutérium:\t[\d\.]+\s\tEnergie\:\t[\d\.]+/gi;
                reportsdata_filtered = reportsdata_filtered.replace(ogame_ressource_pattern, "Métal\:\t0\s\tCristal:\t0[\n\t]Deutérium:\t0\s\tEnergie\:\t0");
            } else if(ogs_gametype==ogs_euniverstype) {
                var eunivers_ressource_pattern = /Titane\:\t[\d\s]+\s\tCarbone\:\t[\d\s]+\nTritium\:\t[\d\s]+/gi;
                reportsdata_filtered = reportsdata_filtered.replace(eunivers_ressource_pattern, "Titane\:\t0 \tCarbone\:\t0\nTritium\:\t0\n");
            }
          }

          //FILTRAGE FLOTTE + FILTRAGE ENERGIE(SATS)
          if (OGPlugin_getBoolPref('OGPlugin.settings.filterspyreportfleet', false, '')==true)
          {


                var ogame_fleet_pattern = /Flotte\n[\w,\d,é,è,à,î,ï,ô,ö,û,\s,\t]+(?=\nDéfense)|Flotte\n[\w,\d,é,è,à,î,ï,ô,ö,û,\s,\t]+(?=\nProbabilité)/gi;
                reportsdata_filtered = reportsdata_filtered.replace(ogame_fleet_pattern, "Flotte\n");

          }

          return reportsdata_filtered;

}

/**
 * Capture le contenu texte de la page/popup rapport de combat
 * @param TargetDoc : référence document navigateur ayant répondu à l'événement onload ou autre
 **/
function OGPlugin_GetCombatReportsTextSel(TargetDoc) {

      // répérage objet html par TAG et propriété largeur 519
	    var pathtospytable = ogs_PathtoCombatTable; // table width="99%">
      var obj = OGPlugin_EvalNode(pathtospytable,TargetDoc);
		  if (obj.snapshotLength == 0) return;

      var Selection = window.getSelection();
      if (Selection==null) {
          return "error";
      }
      if(Selection.rangeCount > 0) Selection.removeAllRanges();

		  var range = TargetDoc.createRange();
	    range.selectNode(obj.snapshotItem(0));
			Selection.addRange(range);


      // ajout des textes des bulles d'aides, caractéristiques de planète, joueurs, etc...
      /*var pathtotooltips = '//div[starts-with(@id,"tOoLtIp")]';
      var obj = OGPlugin_EvalNode(pathtotooltips,TargetDoc);
			for (var i = 0; i < obj.snapshotLength; i++) {
			    var range = TargetDoc.createRange();
			    range.selectNode(obj.snapshotItem(i));
				  Selection.addRange(range);

			} */
			var text = Selection.toString();
			return text;
}

/**
 * Capture du contenu texte de la page Flotte
 * @param TargetDoc : référence document navigateur ayant répondu à l'événement onload ou autre
 **/
function OGPlugin_GetFleetDataTextSel(TargetDoc) {

      // répérage objet tableau flotte html par TAG et propriété largeur 519
	    var pathtofleetvoyaging = ogs_PathtoFleetVoyaging;
      var obj = OGPlugin_EvalNode(pathtofleetvoyaging,TargetDoc);
		  if (obj.snapshotLength == 0) return false;

      var Selection = window.getSelection();
      if (Selection==null) {
          return "error";
      }
			if(Selection.rangeCount > 0) Selection.removeAllRanges();

		  var range = TargetDoc.createRange();
	    range.selectNode(obj.snapshotItem(0));
			Selection.addRange(range);

      range = TargetDoc.createRange();
      range.selectNode(obj.snapshotItem(1));
      Selection.addRange(range);

      //--------------------------
			var text = Selection.toString();
			return text;
}

/**
 * Capture du contenu texte de la page Galaxie
 * @param TargetDoc : référence document navigateur ayant répondu à l'événement onload ou autre
 **/
function OGPlugin_GetGalaxyTextSel(TargetDoc) {


	    var PathtoGalaxyTable = ogs_PathtoGalaxyTable;
      var obj = OGPlugin_EvalNode(PathtoGalaxyTable,TargetDoc);
		  if (obj.snapshotLength == 0) return false;

      var Selection = window.getSelection();
      if (Selection==null) {
          return "error";
      }
			if(Selection.rangeCount > 0) Selection.removeAllRanges();

		  var range = TargetDoc.createRange();
	    range.selectNode(obj.snapshotItem(0));
			Selection.addRange(range);

      //--------------------------
			var text = Selection.toString();
			return text;
}

/**
 * Capture du contenu texte de la page classements Ogame ou EUnivers
 * @param TargetDoc : référence document navigateur ayant répondu à l'événement onload ou autre
 **/
function OGPlugin_GetStatsTextSel(TargetDoc) {

      // répérage objet tableau classement html par TAG et propriété largeur 519
	    var PathtoStatsTable = eun_PathtoStatsTable;
      var obj = OGPlugin_EvalNode(PathtoStatsTable,TargetDoc);
		  if (obj.snapshotLength == 0) return false;

      var Selection = window.getSelection();
      if (Selection==null) {
          return "error";
      }
			if(Selection.rangeCount > 0) Selection.removeAllRanges();

		  var range = TargetDoc.createRange();
	    range.selectNode(obj.snapshotItem(0));
			Selection.addRange(range);

		  // var range = TargetDoc.createRange();
	    range.selectNode(obj.snapshotItem(1));
			Selection.addRange(range);

      //--------------------------
			var text = Selection.toString();
			return text;
}

/**
 * Capture du contenu texte de la page ressources Ogame ou EUnivers
 * @param TargetDoc : référence document navigateur ayant répondu à l'événement onload ou autre
 **/
function OGPlugin_GetResourceDataTextSel(TargetDoc) {

      // répérage objet tableau ressources html par TAG et propriété largeur 550(par défaut)
	    var pathtoresourcetable = ogs_PathtoResourceTable;
      var obj = OGPlugin_EvalNode(pathtoresourcetable,TargetDoc);
		  if (obj.snapshotLength == 0) return false;

      var Selection = window.getSelection();
      if (Selection==null) {
          return "error";
      }
			if(Selection.rangeCount > 0) Selection.removeAllRanges();

		  var range = TargetDoc.createRange();
	    range.selectNode(obj.snapshotItem(0));
			Selection.addRange(range);

      //--------------------------
			var text = Selection.toString();
			return text;
}

/**
 * Capture du contenu texte de la page ressources Ogame ou EUnivers
 * @param TargetDoc : référence document navigateur ayant répondu à l'événement onload ou autre
 **/
function OGPlugin_GetEmpireDataTextSel(TargetDoc) {

      // répérage objet tableau ressources html par TAG et propriété largeur 750(par défaut)
	    var pathtoresourcetable = ogs_PathtoEmpireTable;
      var obj = OGPlugin_EvalNode(pathtoresourcetable,TargetDoc);
		  if (obj.snapshotLength == 0) return false;

      var Selection = window.getSelection();
      if (Selection==null) {
          return "error";
      }
			if(Selection.rangeCount > 0) Selection.removeAllRanges();

		  var range = TargetDoc.createRange();
	    range.selectNode(obj.snapshotItem(0));
			Selection.addRange(range);

      //--------------------------
			var text = Selection.toString();

			return text;
}

/**
 * récupère le contenu texte de la page message comme si c'était un copié/collé
 * @param partargetdoc : référence document navigateur ayant répondu à l'événement onload ou autre
 * @return retourne une chaîne avec retours chariot possible représentant la sélection texte déformaté de la page des messages (espionnage attendu)
 **/
function OGPlugin_GetSpyReportsTextSel(TargetDoc) {

      // répérage objet html par TAG et propriété largeur 519
	    var pathtospytable = ogs_PathtoMessageTable;

      if (ogs_gametype==ogs_ogametype) var pathtospytable = ogs_PathtoMessageTable;
      else if(ogs_gametype==ogs_euniverstype) var pathtospytable = eun_PathtoMessageTable;

      var obj = OGPlugin_EvalNode(pathtospytable,TargetDoc);
		  if (obj.snapshotLength == 0) return;

      var Selection = window.getSelection();
			if(Selection.rangeCount > 0) Selection.removeAllRanges();

		  var range = TargetDoc.createRange();
	    range.selectNode(obj.snapshotItem(0));
			Selection.addRange(range);

      // ajout d'un autre bloc à la sélection
		  var pathtotooltips = '//div[starts-with(@id,"tOoLtIp")]';
      var obj = OGPlugin_EvalNode(pathtotooltips,TargetDoc);
			for (var i = 0; i < obj.snapshotLength; i++) {
			    var range = TargetDoc.createRange();
			    range.selectNode(obj.snapshotItem(i));
				  Selection.addRange(range);

			}
			var text = Selection.toString();
			return text;
}

/**
 * Capture le contenu texte entier de la page affichée(quelconque) Ogame ou EUnivers
 * @param TargetDoc : référence document navigateur ayant répondu à l'événement onload ou autre
 **/
function OGPlugin_GetFullPageText(TargetDoc) {

      // répérage objet tableau classement html par TAG 

      if (ogs_gametype==ogs_ogametype) var PathtoFullPageTable = ogs_PathtoFullPageTable;
      else if(ogs_gametype==ogs_euniverstype) var PathtoFullPageTable = eun_PathtoFullPageTable;
      
      var obj = OGPlugin_EvalNode(PathtoFullPageTable,TargetDoc);
		  if (obj.snapshotLength == 0) return false;

      var Selection = window.getSelection();
      if (Selection==null) {
          return "error";
      }
			if(Selection.rangeCount > 0) Selection.removeAllRanges();

		  var range = TargetDoc.createRange();
		  

		  // var range = TargetDoc.createRange();
	    range.selectNode(obj.snapshotItem(0));
			Selection.addRange(range);

      //--------------------------
			var text = Selection.toString();
			return text;
}
