/*
Barre d'Outils OGSPY, extension firefox d'aide aux mise  jour de serveurs OGSPY

OGSPY Toolbar, a firefox plugin for helping players in updating OGSPY servers game datas

Copyright (C) 2006-2007 Naqdazar (ajdr@free.fr)

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
au titre des clauses de la Licence Publique Gnrale GNU, telle que publie par la
Free Software Foundation ; soit la version 2 de la Licence.
Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ;
 sans mme une garantie implicite de COMMERCIABILITE ou DE CONFORMITE A UNE UTILISATION PARTICULIERE. 
 
 Voir la Licence Publique Gnrale GNU pour plus de dtails. 
 
 Vous devriez avoir reu un exemplaire de la Licence Publique Gnrale GNU avec ce programme ;
  si ce n'est pas le cas, crivez  la Free Software Foundation Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

This program is free software; you can redistribute it and/or modify it under the
terms of the GNU General Public licence as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details.

You should have received a copy of the GNU General Public licence along with this program;
 if not, write to the Free Software Foundation, Inc., 
 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

// Dclarations globales

    var topNformatcolor;
    var friendlyformatcolor;
    var enemyformatcolor;
    var pnaformatcolor;
    var tradingformatcolor;
    //--
  
    //--
    var serverid;
    var ogplayername="", ogallyname="";
    var ogplayerrank=0,ogallyrank=0;
    
// prototype  revoir, f paramtrable pour tests couleurs catgories
// retourne couleur de catgorie newcolor si string element trouv dans liste stringstab sinon retourne defaultcolor
function OGPlugin_ProbeCatColor(colorcattest, stringstab, newcolor, defaultcolor,  stringelement )
{
    if (colorcattest==true && stringstab!=null)
        for(cpt=0;cpt<stringstab.length;cpt++) {                
            if (OGPlugin_IsNCSStringEquals(stringelement, OGPlugin_TrimString(stringstab[cpt]))==true) {
                //alert(stringelement+"-"+stringstab[cpt]+"\nidentiques\n"+newcolor);
                if (newcolor!="")
                return newcolor;                
            }  
        }
    if (defaultcolor!=null && defaultcolor!="")
        return defaultcolor; // motif pas trouv
    else return false;
} 

/**
 * Rcupre les noms de couleurs depuis lex proprits de l'extension
 **/
function OGPlugin_InitStdFormatColors(parserverid) {
    if (parserverid==null) parserverid = '';
    topNformatcolor = OGPlugin_getCharPref('OGPlugin.settings.topNformatcolor'+parserverid,'white','');
    friendlyformatcolor = OGPlugin_getCharPref('OGPlugin.settings.friendlyformatcolor'+parserverid,'white','');
    enemyformatcolor = OGPlugin_getCharPref('OGPlugin.settings.enemyformatcolor'+parserverid,'white','');
    pnaformatcolor = OGPlugin_getCharPref('OGPlugin.settings.pnaformatcolor'+parserverid,'white','');
    tradingformatcolor = OGPlugin_getCharPref('OGPlugin.settings.tradingformatcolor'+parserverid,'white','');
}

function ColorAllyType(alliancetag, alliancecell) {

        const neutralcolor="white";
        var friendlyallyslist = "", enemyallyslist = "", tradingallyslist = "", allycellHTMLTags="";
        var allycellHTMLColor=false;
        
        var colorchanged=false;
        //------------
        // groupes persos alliances
        var dobrightfriendlyally = OGPlugin_getBoolPref("OGPlugin.settings.brightfriendlyally"+serverid, false, '');
        var dobrightenemyally = OGPlugin_getBoolPref("OGPlugin.settings.brightenemyally"+serverid, false, '');
        var dobrighttradingally = OGPlugin_getBoolPref("OGPlugin.settings.brighttradingally"+serverid, false, '');
        //--- 
        // groupes diplomatiques alliances               
        var dobrightogspyfriendlyally = OGPlugin_getBoolPref("OGPlugin.settings.brightogspyfriendlyally"+serverid, false, '');
        var dobrightogspypnaally = OGPlugin_getBoolPref("OGPlugin.settings.brightogspypnaally"+serverid, false, '');
        var dobrightogspyenemyally = OGPlugin_getBoolPref("OGPlugin.settings.brightogspyenemyally"+serverid, false, '');
        var dobrightogspytradingally = OGPlugin_getBoolPref("OGPlugin.settings.brightogspytradingally"+serverid, false, "");
        //------
        var brighuntilrankally = OGPlugin_getBoolPref("OGPlugin.settings.brighuntilrankally"+serverid, false, '');
        var allyranklimit = OGPlugin_getIntPref("OGPlugin.settings.allyranklimit"+serverid, 100 ,'');
        var echorankally = OGPlugin_getBoolPref("OGPlugin.settings.echorankally"+serverid, false, '');
        
        //------ allliances serveurs
        //---
        
        // Initialisation de chanes listes
        var friendlyallies = ""; // alliances amies - perso + diplomatie
        if (dobrightogspyfriendlyally) friendlyallies = decodeURI(OGPlugin_getCharPref("OGPlugin.settings.srvfriendlyallies"+serverid , '' ,''));
        if (dobrightfriendlyally) friendlyallies += (friendlyallies.length>0 ? ';' : '')+decodeURI(OGPlugin_getCharPref("OGPlugin.settings.friendlyallyslist"+serverid , '' ,''));

        var enemyallies = ""; // alliances ennemies - perso + diplomatie
        if (dobrightogspyenemyally) enemyallies = decodeURI(OGPlugin_getCharPref("OGPlugin.settings.srvenemyallies"+serverid , '' ,''));
        if (dobrightenemyally) enemyallies += (enemyallies.length>0 ? ';' : '')+decodeURI(OGPlugin_getCharPref("OGPlugin.settings.enemyallyslist"+serverid , '' ,''));
        
        var pnaallies = ""; // alliances pna - diplomatie
        if (dobrightogspypnaally) pnaallies = decodeURI(OGPlugin_getCharPref("OGPlugin.settings.srvpnaallies"+serverid , '' ,''));

        var tradingallies = ""; // alliances commerantes - perso + diplomatie
        if (dobrightogspytradingally) tradingallies = decodeURI(OGPlugin_getCharPref("OGPlugin.settings.srvtradingallies"+serverid , '' ,''));
        if (dobrighttradingally) tradingallies += (tradingallies.length>0 ? ';' : '')+decodeURI(OGPlugin_getCharPref("OGPlugin.settings.tradingallyslist"+serverid , '' ,''));
        
        //alert("friendlyallies: "+friendlyallies+"\nenemyallies :"+enemyallies+"\npnaallies :"+pnaallies+"\ntradingallies: "+tradingallies);
        //--
        var regsplit=new RegExp(/[;]/g);//", "g")

        var pnaalliestab = Array();
        var tradingalliestab = Array();
        var enemyalliestab = Array();
        var friendlyalliestab = Array();
        //alert(altpnaalliestab+"-"+alttradingallies+"-"+altenemyallies+"-"+altfriendlyallies);

        if (pnaallies.length>0) pnaalliestab  = pnaallies.split(regsplit);
        if (tradingallies.length>0) tradingalliestab  = tradingallies.split(regsplit);
        if (enemyallies.length>0) enemyalliestab = enemyallies.split(regsplit);
        if (friendlyallies.length>0) friendlyalliestab  = friendlyallies.split(regsplit);

        // ----            
        if (brighuntilrankally==true && ogallyrank<=allyranklimit && ogallyrank>0) {
            allycellHTMLColor = topNformatcolor;
            colorchanged=true;
        }                     
                             
        //alert("diplo ally color type");
        // Diplomatique groups
        /*
         1er param de OGPlugin_ProbeCatColor  vrai d'office, les listes ont dj t adapte en consquence
        */
        tmpfunc_result = OGPlugin_ProbeCatColor(true , pnaalliestab, pnaformatcolor, '' /* allycellHTMLColor */, alliancetag  );
        if (tmpfunc_result!==false)  allycellHTMLColor = tmpfunc_result;
        
        tmpfunc_result = OGPlugin_ProbeCatColor(true, tradingalliestab, tradingformatcolor, '' /* allycellHTMLColor */, alliancetag  );
        if (tmpfunc_result!==false)  allycellHTMLColor = tmpfunc_result;
        
        tmpfunc_result = OGPlugin_ProbeCatColor(true, friendlyalliestab, friendlyformatcolor, '' /* allycellHTMLColor */, alliancetag  );
        if (tmpfunc_result!==false)  allycellHTMLColor = tmpfunc_result;
        
        tmpfunc_result = OGPlugin_ProbeCatColor(true, enemyalliestab, enemyformatcolor, '' /* allycellHTMLColor */, alliancetag  );
        if (tmpfunc_result!==false)  allycellHTMLColor = tmpfunc_result;
        
        //=================================================================================

        var allyrankHTMLTags="";
        if (OGPlugin_IsNCSStringEquals(ogallyname, alliancetag) /* ogallyname==alliancetag */ && ogallyrank>0 && ogallyrank<=allyranklimit) {
            if (echorankally==true) allyrankHTMLTags = " <font color='red'>#"+ogallyrank+"</font>";                
        } 
        
        //alert("colorization ColorAllyType");         
        
        var allytagreg= new RegExp(">([\\s,\\n]*"+alliancetag.StringToRegExp()+"[\s,\n]*)<","gi")

        // playercellHTMLColor!==false
        if (allycellHTMLColor !== false /* allycellHTMLColor!==neutralcolor */) {// (colorchanged==true) // allycellHTMLColor != 'white'
           allycellHTMLTags = '<b><font color="'+allycellHTMLColor+'">'+ alliancetag +'</font>'+allyrankHTMLTags+'</b>';
           //allycellHTMLTags = alliancecell.innerHTML.replace(allytagreg, '><b><font color="'+allycellHTMLColor+'">'+alliancetag /* alliancetag */+'</font>'+allyrankHTMLTags+'</b><');
        } else {
              allycellHTMLTags = alliancecell.innerHTML +allyrankHTMLTags;
              //allycellHTMLTags = alliancecell.innerHTML.replace(allytagreg, alliancetag +allyrankHTMLTags); /* alliancetag */+allyrankHTMLTags;
        }
        
        ogallyname="";
        ogallyrank=0;
        // rintgration du lien pour afficher les pages alliance (Ogame 0.74d)
        if (allycellHTMLTags!="" && allycellHTMLColor !== false) {
            if (ogs_gametype==ogs_ogametype) {
                alliancecell.innerHTML = "<a href=\'ainfo.php?allytag="+alliancetag+"\' target=\'_ally\'>\t"+allycellHTMLTags+"</a>";
                //alliancecell.innerHTML = allycellHTMLTags;
            } else alliancecell.innerHTML = allycellHTMLTags;
            //alliancecell.innerHTML = allycellHTMLTags;
            //alert(alliancecell.innerHTML);
        }

}

function ColorPlayerType(parplayername, playercell) {

        var neutralcolor="white";
        var friendlyplayerslist="", enemyplayerslist="", tradingplayerslist="";
        var dobrightfriendlyplayer=false,dobrightenemyplayer=false, dobrighttradingplayer = false, dobrighttopNplayers=false; 
        var playercellHTMLTags="", playercellHTMLColor=false; // aucune nouvelle couleur par dfaut
        var playerranklimit=100;
        var brighuntilrankplayer=false,echorankplayer=false,colorchanged=false;
        
        dobrightfriendlyplayer = OGPlugin_getBoolPref("OGPlugin.settings.brightfriendlyplayer"+serverid, false, '');               
        friendlyplayerslist = decodeURI(OGPlugin_getCharPref("OGPlugin.settings.friendlyplayerslist"+serverid , '' ,''));            
        //-----
        dobrightenemyplayer = OGPlugin_getBoolPref("OGPlugin.settings.brightenemyplayer"+serverid, false, '');            
        enemyplayerslist = decodeURI(OGPlugin_getCharPref("OGPlugin.settings.enemyplayerslist"+serverid , '' ,''));            
            //------
        dobrighttradingplayer = OGPlugin_getBoolPref("OGPlugin.settings.brighttradingplayer"+serverid, false, '');            
        tradingplayerslist = decodeURI(OGPlugin_getCharPref("OGPlugin.settings.tradingplayerslist"+serverid , '' ,''));                                           
        //------
        dobrighttopNplayers = OGPlugin_getBoolPref("OGPlugin.settings.brighttopNplayers"+serverid, false, '');              
        //------
        brighuntilrankplayer = OGPlugin_getBoolPref("OGPlugin.settings.brighuntilrankplayer"+serverid, false, '');
        playerranklimit = OGPlugin_getIntPref("OGPlugin.settings.playerranklimit"+serverid, 0 ,'');
        echorankplayer = OGPlugin_getBoolPref("OGPlugin.settings.echorankplayer"+serverid, false, '');
        //------                                                      
        // bloc en dehors des test/boucles
        var regsplit=new RegExp(/[,;]/g);

        // necessaire liste au moins vides
                
        var friendlyplayerslisttab =  friendlyplayerslist.split(regsplit);            
        var enemyplayerslisttab =  enemyplayerslist.split(regsplit);                
        var tradingplayerslisttab =  tradingplayerslist.split(regsplit);

        if (brighuntilrankplayer==true && ogplayerrank<=playerranklimit && ogplayerrank>0) 
            playercellHTMLColor = topNformatcolor;                            
        //------------------------- 
       //playercellHTMLColor =false
        tmpfunc_result  = OGPlugin_ProbeCatColor(dobrighttradingplayer, tradingplayerslisttab, tradingformatcolor, '', parplayername  );
        if (tmpfunc_result!==false)  playercellHTMLColor = tmpfunc_result;
        tmpfunc_result  = OGPlugin_ProbeCatColor(dobrightfriendlyplayer, friendlyplayerslisttab, friendlyformatcolor, '', parplayername  );
        //alert("tmpfunc_result: "+tmpfunc_result);
        if (tmpfunc_result!==false) playercellHTMLColor = tmpfunc_result;
        tmpfunc_result  = OGPlugin_ProbeCatColor(dobrightenemyplayer, enemyplayerslisttab, enemyformatcolor, '', parplayername  );
        if (tmpfunc_result!==false) playercellHTMLColor = tmpfunc_result;
        //------------------------- ogplayername="", ogplayerrank=0;                        
        var playerrankHTMLTags="";
        //alert('ColorPlayerType: '+ogplayername+'-'+parplayername+'('+playername+')')
        if (OGPlugin_IsNCSStringEquals(ogplayername , parplayername) /*ogplayername==parplayername */ && ogplayerrank>0 && ogplayerrank<=playerranklimit) {
            if (echorankplayer==true) playerrankHTMLTags = " <font color='red'>#"+ogplayerrank+"</font>";                
        } 
        //alert('playercellHTMLColor:'+playercellHTMLColor);
        if (playercellHTMLColor!==false /* playercellHTMLColor!= neutralcolor */)
           playercellHTMLTags = "<b><font color='"+playercellHTMLColor+"'>"+/* playercell.innerHTML */  parplayername +"</font>"+playerrankHTMLTags+"</b>";
        else playercellHTMLTags = parplayername+playerrankHTMLTags;              
        //---------------------------      
        //viter rpercission sur joueur suivant, si infos pas dtermines au joueurs prcdent
        ogplayername=""; ogplayerrank=0;
        if (playercellHTMLTags!="" && playercellHTMLColor!==false || playerrankHTMLTags != '')
            playercell.innerHTML = playercellHTMLTags;                   
}    


function OGPlugin_GalViewsColorTypedNames(docroot, parserverid, foxgame) 
{    
    serverid = parserverid; // serverid ne doit pas dclare locale
    
    OGPlugin_InitStdFormatColors(parserverid);

    // noms rcupr de l'interface par regexp
    // dplac en dbut de script hors fonction(global)
    ogplayername=""; ogallyname="";
    ogplayerrank=0; ogallyrank=0;
    var metal_debris = 0, crystal_debris = 0;
    //alert('parserverid: '+parserverid);
    // Indices de table suivant jeux
    if (ogs_gametype==ogs_ogametype)
        targettablerank = OGPlugin_getIntPref('OGPlugin.settings.galpagetablerank', ogs_GalaxyPageRankTab, '');
    else if(ogs_gametype==ogs_euniverstype)
        targettablerank = OGPlugin_getIntPref('OGPlugin.settings.eunivgalaxytablerank', eun_GalaxyPageRankTab, '') /* 8 */;
            
    //alert(targettablerank);
    var rows = docroot.getElementsByTagName('table')[targettablerank].rows;

    //---------------
    var cells, debrisfield_cell;
    var alliance;
    var onmouseoverth,onmouseovera;
    var onmouseover="";
    var playertabtooltip;
    // var tabtooltip; // = new Array();
    if (ogs_gametype==ogs_ogametype) var playerrankpattern = new RegExp(/Joueur\s(\S[\w,\s,\.,_,@]*\S)\s(?:\,\sclass\u00e9\s)\(?(\d{1,5})\u00e8me\)?/);
    else if(ogs_gametype==ogs_euniverstype) var playerrankpattern = new RegExp(/Joueur\s(\S[\w,\s,\.,_,@]*\S)\s(?:\,\sclass\u00e9\s)?\(?(\d{1,5})\u00e8me\)?/);
    var allyrankpattern = new RegExp(/Alliance\s(\S[\w,\s,\.,_,@]*\S)\s\,\s?class\u00e9e\s(\d{1,5})\u00e8me/);
    var playerrankpatternalt = new RegExp("Joueur\s(\S[\w,\s,\.,_,@]+\S)\s","g");

    var corrector = 0;

    if (ogs_gametype==ogs_euniverstype) foxgame=false;
    // cas foxgame seulement valable sous Ogame
    if (ogs_gametype==ogs_ogametype && foxgame == true) {
        corrector = 1; // foxgame dplace la plante, retirer 1 de la coordonne cellule du tableau
    }

    cells = rows[0].cells;
    
    for(var i = 2; i < 17; i++) {
        // reset data
        alliance = "";
        cells = rows[i].cells;

        // Mise en surbrillance des champs de ruine
        metal_debris = 0;
        crystal_debris = 0;
        try { // capture

            if (ogs_gametype==ogs_ogametype) var tmp = cells[4-corrector].innerHTML.match(RegExpOgamedebris);
            else var tmp = cells[0].getElementsByTagName('a')[0].getAttribute('title').match(RegExpEuniversdebris);
  
            if (tmp != null) {
                metal_debris = parseInt(tmp[1].replace(/\./g,'')) ; //replace(".","").replace(".","").replace(".",""));
                crystal_debris = parseInt(tmp[2].replace(/\./g,'')) ; //.replace(".","").replace(".","").replace(".",""));
            }  
            
        } catch(e) { /* pas de champ de ruine */ }
        // mise en couleur
        
        if (ogs_gametype==ogs_ogametype) debrisfield_cell = cells[4-corrector];
        else debrisfield_cell = cells[2];
        
        if (metal_debris+crystal_debris>OGPlugin_getCharPref("OGPlugin.settings.debrisfieldminvalue"+serverid, '20000', '')) {
            if (OGPlugin_getBoolPref("OGPlugin.settings.docolordebrisfield"+parserverid , true ,''))
                debrisfield_cell.setAttribute("style", "background-color : "+OGPlugin_getCharPref("OGPlugin.settings.debrisfieldcolor"+serverid, 'red', 'OGPlugin-debrisfieldcolor')+"; background-image : none;");
        }
        
        if (ogs_gametype==ogs_ogametype) playercell_rank = 5;
        else if (ogs_gametype==ogs_euniverstype) playercell_rank = 3;
        // --> <--

        playernamecell = cells[playercell_rank-corrector].getElementsByTagName('span')[0];
        
        if (playernamecell!=null) {
            playername = playernamecell.innerHTML.stripHTMLEntities(true); // playername
            
            //alert('joueur: '+playername);
            if (playername!="") {
                //reinit vars og
                ogplayername="", ogplayerrank=0;
                
                onmouseoverth=rows[i].getElementsByTagName('th')[playercell_rank-corrector]; // ok contenu cellule
                onmouseovera=onmouseoverth.getElementsByTagName('a')[0];
                onmouseover=onmouseovera.getAttribute('onmouseover');
                playertabtooltip = onmouseover.match(playerrankpattern);

                if (playertabtooltip) {
                    ogplayername=playertabtooltip[1];
                    ogplayerrank=playertabtooltip[2];
                    //alert(ogplayername+"-"+ogplayerrank);
                }
                //alert("playername: "+playername);
                //else alert("motif pas trouv:\n "+onmouseover);
                if (OGPlugin_IsNCSStringEquals(OGPlugin_getCharPref("OGPlugin.settings.playernick"+parserverid , '' ,''), playername) == false ||
                    ogs_gametype==ogs_ogametype)
                    ColorPlayerType(playername, playernamecell /* cells[5-corrector].getElementsByTagName('span')[0] */ );
            }
        }

        if (ogs_gametype==ogs_ogametype) allycell_rank = 6;
        else if (ogs_gametype==ogs_euniverstype) allycell_rank = 4;

       //try {
        if (ogs_gametype==ogs_ogametype) { // tooltip classement alliance, seulement pour Ogame
            onmouseoverth=rows[i].getElementsByTagName('th')[allycell_rank-corrector]; // ok contenu cellule
            onmouseovera=onmouseoverth.getElementsByTagName('a')[0];
            //.getAttribute('onmouseover');
            if (onmouseovera != null) {
                onmouseover=onmouseovera.getAttribute('onmouseover');
                var allytabtooltip = onmouseover.match(allyrankpattern);
                if (allytabtooltip) {
                    //alert("Classement: "+tabtooltip[1]+"-"+tabtooltip[2]);
                    ogallyname=allytabtooltip[1];
                    ogallyrank=allytabtooltip[2];
                }
            }
        }
    
        var tmpalliancell = null;
        if (ogs_gametype==ogs_ogametype) {

            
            targetcell = cells[allycell_rank-corrector].getElementsByTagName('a')[0];
            if (targetcell != null) {// alliance propre si case alliance non vide
                tmpalliancell = cells[allycell_rank-corrector].getElementsByTagName('a')[0].getElementsByTagName('span')[0];
                if (tmpalliancell == null) // autre alliance
                   tmpalliancell = targetcell;
            }

        } else tmpalliancell = cells[allycell_rank-corrector].getElementsByTagName('a')[0];

        if (tmpalliancell != null) {
            alliance = tmpalliancell.innerHTML.stripHTMLEntities(true); // alliance
            //alert("Alliancell: "+alliance);
            alliance = alliance.replace(/\n+/,"");
            alliance = OGPlugin_TrimString(alliance);

            ColorAllyType(alliance, tmpalliancell);
        } 
        //} catch(e) { /* catch when there is no alliance */ }
    }
}

//------------------------------------------------------------------


function OGPlugin_StatsColorTypedNames(StatWho, StatWhat, docroot, parserverid, foxgame)
{
    // Initialisation des variables couleurs    
    OGPlugin_InitStdFormatColors(parserverid);
    
    serverid = parserverid;

    // noms rcupr de l'interface par regexp
    // dplac en dbut de script hors fonction(global)
    ogplayername=""; ogallyname="";
    ogplayerrank=0; ogallyrank=0;  
    
    if (ogs_gametype==ogs_ogametype)
        targettablerank = OGPlugin_getIntPref('OGPlugin.settings.statspagetablerank', ogs_StatsPageRankTab, '');
    else if(ogs_gametype==ogs_euniverstype) targettablerank = OGPlugin_getIntPref('OGPlugin.settings.eunivstatspagetablerank', eun_StatsPageRankTab, '')/* 6 */;
    
    var rows ; //= docroot.getElementsByTagName('table')[5].rows;
    if (foxgame==true) rows = docroot.getElementsByTagName('table')[targettablerank+1].rows; // Ogame 0.76 [6] -> [7]
    else rows = docroot.getElementsByTagName('table')[targettablerank].rows; // Ogame 0.76 [5] -> [6]

    tab_length = rows.length-1;
    if (tab_length<1) return "statsnodata"; // pas de classement disponible ou donnes vide    
    
    var cells;

    if(StatWho == 0) { //Players
        var ranks = new Array(tab_length);
        var players = new Array(tab_length);
        var pIds = new Array(tab_length);
        var alliances = new Array(tab_length);
        var points = new Array(tab_length);
        var j;
        var pIdRegExp = /messageziel\=(\d+)/;
        for(var i = rows.length - 2; i >= 0; i--) {
            j = 0;
            cells      = rows[i+1].cells;
            tmpplayercell = cells[1];            
            playername = tmpplayercell.innerHTML.stripHTMLEntities(true).trim(); // playername
            
            if (OGPlugin_IsNCSStringEquals(OGPlugin_getCharPref("OGPlugin.settings.playernick"+parserverid , '' ,''), playername) == false)
                ColorPlayerType(playername, tmpplayercell);
            tmpallycell = cells[3];
            // c'est un lien, il faut le dformater
            alliances[i] = tmpallycell.innerHTML.stripHTMLEntities(true).trim();
            //alert(alliances[i]+"-"+playername);
            //=====================                        
            alliance = alliances[i]; // alliance
            //----
            ColorAllyType(alliance, tmpallycell);
            //if (i==50) alert("alliance:"+alliance);
            //===============================           
        }                
        
    } else { //Alliances
        var ranks = new Array(tab_length);
        var alliances = new Array(tab_length);

        var j;
        for(var i = rows.length - 2; i >= 0; i--) {
            j = 0;
            cells = rows[i+1].cells;                    
            tmpallycell = cells[1];
            // c'est un lien, il faut le dformater
            alliance = tmpallycell.innerHTML.stripHTMLEntities(true);
            ColorAllyType(alliance, tmpallycell);   

        }

    }

}
