/*
Barre d'Outils OGSPY, extension firefox d'aide aux mise  jour de serveurs OGSPY

OGSPY Toolbar, a firefox plugin for helping players in updating OGSPY servers game datas

Copyright (C) 2006 Naqdazar (ajdr@free.fr)

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
au titre des clauses de la Licence Publique Gnrale GNU, telle que publie par la
Free Software Foundation ; soit la version 2 de la Licence.
Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ;
 sans mme une garantie implicite de COMMERCIABILITE ou DE CONFORMITE A UNE UTILISATION PARTICULIERE. 
 
 Voir la Licence Publique Gnrale GNU pour plus de dtails. 
 
 Vous devriez avoir reu un exemplaire de la Licence Publique Gnrale GNU avec ce programme ;
  si ce n'est pas le cas, crivez  la Free Software Foundation Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

This program is free software; you can redistribute it and/or modify it under the
terms of the GNU General Public licence as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details.

You should have received a copy of the GNU General Public licence along with this program;
 if not, write to the Free Software Foundation, Inc., 
 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/


/**
 * Fonctions ddies  Ogame: filtrage et corrections de contenu, dtermination de pages
 * Ces fonctions doivent pouvoir accder aux variables et constantes globales de ogsplugin.js
 **/
 
 // fonction de mise en tampon des stats par catgorie, avec vrif des doublons
function OGPlugin_FillInGalBuffer(GalCoord, GalContent) { // e.g GalCoord "2:310"

      if (ogs_bufferingdebug_mode==true)
          alert("GalCoord: "+GalCoord+" / "+GalViewsBuffer.indexOf(GalCoord,0)+"\ntampon :\n"+GalViewsBuffer);
      //if (GalViewsBuffer.search(GalCoord)>-1) {
      // .indexOf
      if (GalViewsBuffer.indexOf(GalCoord,0)>-1) {
          return 0; // donnes existantes
      }

      GalViewsBuffer+=GalContent; // ajout tampon
      Curr_GalViewBufCount++;
      OGPlugin_SetStatusViewLabel("notify",OGPlugin_GetLocString("bufferingsetfor")+OGPlugin_selectedGalaxy+":"+OGPlugin_selectedSystem+" ("+Curr_GalViewBufCount+"/"+OGPlugin_getIntPref("OGPlugin.settings.buffer_numgalview", 0 ,'')+")");
      if (Curr_GalViewBufCount>=OGPlugin_getIntPref("OGPlugin.settings.buffer_numgalview", 0 ,''))
          OGPlugin_SendBuffer(1, true);
      //-------------------
       else OGPlugin_SetFlushButtonState(true);
      //-------------------
      return 1;
}

/**
 * fonction d'envoi
 * @param buffertype entier naturel indiquant le(s) type(s) de tampon(s) concern(s)
 * @param clearonsend boolen: indique si le tampon concern sera vid
 **/
function OGPlugin_SendBuffer(buffertype, clearonsend) {
      if ((buffertype & 1)==1) { // tampon galaxie
          if (Curr_GalViewBufCount>=OGPlugin_getIntPref("OGPlugin.settings.buffer_numgalview", 0 ,'')) {
              OGPlugin_SetStatusViewLabel("notify",OGPlugin_GetLocString("galviewsbuffersent"));
              OGPlugin_result = OGPlugin_sendText("galaxy",GalViewsBuffer,OGPlugin_TrigDoc.location.href);
          }
          if (clearonsend===true) OGPlugin_ClearBuffer(buffertype);
      }
}

/**
 * Fonction de vidage de tampon: mise de l'indice  zro et de la chane tampon  vide
 * @param buffertype entier naturel indiquant le(s) type(s) de tampon(s) concern(s)
 **/
function OGPlugin_ClearBuffer(buffertype) {
      if ((buffertype & 1)==1) { // tampon galaxie
          Curr_GalViewBufCount=0;
          GalViewsBuffer="";
      }
}

/**
 * Mise en tampon des donnes statistiques avec vrification des doublons
 **/
function OGPlugin_FillInStatsBuffer(StatWho, StatTyp, StatContent) { // e.g GalCoord "2:310"

                    if (ogs_bufferingdebug_mode==true) alert("mise en tampon OGPlugin_FillInStatsBuffer!");

                    // A-t-on chang de type de classement? Si oui, vidage tampon concern
                    if ((ogs_LastStatWho!=-1 && ogs_LastStatWho!=StatWho) ||
                        (ogs_LastStatTyp!=-1 && ogs_LastStatTyp!=StatTyp)) { // type classement diffrent?


                        if (OGPlugin_getBoolPref('OGPlugin.settings.flushbufwhenswitching', false, 'OGPlugin-flushbufwhenswitching')==true) {
                            // vider le tampon concern - on garde le CurrentDocUrl courant
                            if (ogs_bufferingdebug_mode==true) alert("Vidage tampon par changement de catgorie!");

                            OGPlugin_SetStatusViewLabel("notify","Changement de classement : Envoi du tampon "+StatsWhoTabNames[ogs_LastStatWho]+'('+StatsTypeTabNames[ogs_LastStatTyp]+')'+" ["+OGPlugin_selectedRanks+"]" );
                            OGPlugin_result = OGPlugin_sendText("stats",StatsArrayBuffer[ogs_LastStatWho][ogs_LastStatTyp],CurrentDocUrl);

                            // rinitialiser le tampon
                            StatsArrayBuffer[ogs_LastStatWho][ogs_LastStatTyp] = '';
                            Curr_StatBufCount[ogs_LastStatWho][ogs_LastStatTyp] = 0;

                            ogs_LastStatWho = -1;
                            ogs_LastStatTyp = -1;
                            // dsactiver le bouton de vidage des tampons

                        }
                        OGPlugin_SetFlushButtonState(false);
                    } else {
                      ogs_LastStatWho = StatWho;
                      ogs_LastStatTyp = StatTyp;
                    }


                    /* *********************************************
                       ** mise en tampon des classements gnraux **
                       ********************************************* */

                    // ajout du sparateur si le tampon contient dj au moins UN lment
                    // icic text ?= StatContent
                    if(Curr_StatBufCount[StatWho][StatTyp]>0)
                      text = "<==||==>" + text;
                    // sinon text=lui-mme

                    OGPlugin_SetFlushButtonState(true);
                    //****************************************************************

                    /////////////////////////////////////////////////////////////
                    // test doublon: prendre 50 caractre par ex du classement //
                    //  ajouter et cherche le motif dans le tampon            //
                    /////////////////////////////////////////////////////////////

                    var motif_stats_a_chercher = text.substr(500, 50); // sous-chane sur les noms de joueurs/alliances
                    if (Curr_StatBufCount[StatWho][StatTyp]>0 && StatsArrayBuffer[StatWho][StatTyp].indexOf(motif_stats_a_chercher,0)>-1) {
                        if (ogs_debug_mode==true) alert("donnees deje presentes! \nnb elem: "+Curr_StatBufCount[StatWho][StatTyp]+"\nmotif: "+motif_stats_a_chercher+"\ntampon: "+StatsArrayBuffer[StatWho][StatTyp]);
                        return 0; // on quitte , rien  faire
                    }
                    else { // ok pas de doublons

                        // mise en tampon locale effective
                        StatsArrayBuffer[StatWho][StatTyp]+=text; // ajout tampon
                        Curr_StatBufCount[StatWho][StatTyp]++; // incrementation indice tampon

                        // notification de la mise en tampon
                        OGPlugin_SetStatusViewLabel("notify","Mise en tampon du classement "+ogs_buff_statusviewline+" ["+OGPlugin_selectedRanks+"] ("+Curr_StatBufCount[StatWho][StatTyp]+"/"+OGPlugin_getIntPref("OGPlugin.settings.buffer_numstatstabs", 0 ,'')+")");
                    }

                    // est-ce que le tampon est plein
                    if (Curr_StatBufCount[StatWho][StatTyp]>=OGPlugin_getIntPref("OGPlugin.settings.buffer_numstatstabs", 0 ,'')) {

                         // moditication des proprits du bouton Envoyer - dsactiver quand on vide auto le tampon
                         OGPlugin_SetFlushButtonState(false);

                        OGPlugin_SetStatusViewLabel("notify","Envoi du tampon de statistiques "+ogs_buff_statusviewline);

                        OGPlugin_result = OGPlugin_sendText("stats",StatsArrayBuffer[StatWho][StatTyp],CurrentDocUrl);

                        Curr_StatBufCount[StatWho][StatTyp]=0; // vidage indice tampon
                        StatsArrayBuffer[StatWho][StatTyp]=""; // vidage tampon
                    }
                    return 1;
}

//==============================================================================================

/**
 * Fonctions annexes de filtrage, analyse de contenu de page, etc...
 * dtermine si on est devant le panneau de rubrique de la page message du compte commandant
 * @param targetdoc
 **/
function OGPlugin_IsCommandantMsgPanel (targetdoc) {
            var IsCommMsgPanel=false;
            //  voir: retourner une constante combinant divers constante correspondant
            //  une catgorie de message
            //******************************************************************
            const ShowMenuLabel = "Afficher";
            const GenderMenuLabel = "Genre";

            const SpyReportLabel = "Rapports d'espionnage";
            const CombatReportLabel = "Rapports de combat";
            const AllyMsgLabel = "Message de votre alliance";
            const PlayerMsgLabel = "Messages de joueurs";
            const GeneralMsgLabel = "Autres messages";
            //******************************************************************
            var message_page = targetdoc.getElementsByTagName('table')[OGPlugin_getIntPref('OGPlugin.settings.messagestablerank', ogs_MsgPageRankTab, '')];
            if (message_page != null)
                var message_page_html = message_page.innerHTML;
            //
            if (message_page_html!='') {
                ShowMenuLabel_pos = message_page_html.search(ShowMenuLabel);
                GenderMenuLabel_pos = message_page_html.search(GenderMenuLabel);

                SpyReportLabel_pos = message_page_html.search(SpyReportLabel);
                CombatReportLabel_pos = message_page_html.search(CombatReportLabel);
                AllyMsgLabel_pos = message_page_html.search(AllyMsgLabel);
                PlayerMsgLabel_pos = message_page_html.search(PlayerMsgLabel);
                GeneralMsgLabel_pos = message_page_html.search(GeneralMsgLabel);

                if (ShowMenuLabel_pos>-1 &&
                    GenderMenuLabel_pos>ShowMenuLabel_pos &&

                    SpyReportLabel_pos>GenderMenuLabel_pos &&
                    CombatReportLabel_pos>SpyReportLabel_pos &&
                    AllyMsgLabel_pos>CombatReportLabel_pos &&
                    PlayerMsgLabel_pos>AllyMsgLabel_pos &&
                    GeneralMsgLabel_pos>PlayerMsgLabel_pos)
                   IsCommMsgPanel=true;
                if (ogs_getreportsdebug_mode==true ) alert(ShowMenuLabel_pos+"/"+GenderMenuLabel_pos+"/"+SpyReportLabel_pos+"/"+CombatReportLabel_pos+"/"+AllyMsgLabel_pos+"/"+PlayerMsgLabel_pos+"/"+GeneralMsgLabel_pos);
            }


            return IsCommMsgPanel;
}

/**
 * Ajout du code javascript inline dans la page stats pour l'ajout de boutons de dfilement
 **/
function OGPlugin_AddStatsNextPrevButtons(targetdocument) {
    // try {

	        OGPlugin_addJavaScript(targetdocument, "chrome://ogsplugin/content/ogsplugin_btns.js");

          var path = ogs_PathtoStatsTable;
          var obj = OGPlugin_EvalNode(path,targetdocument);
          if (obj.snapshotLength < 2) return;

          //alert("debut OGPlugin_AddStatsNextPrevButtons");
          var form = targetdocument.createElement('tr');
	        var td = targetdocument.createElement('td');

	        var buttonlabel=OGPlugin_GetLocString("statpagebuttonlabel");
        	td.setAttribute("colspan","8");
        	td.setAttribute("class","1");
        	td.setAttribute("align","center");
        	td.setAttribute("valign","middle");


          //td.innerHTML  += '<form action="ogsplugin" method=post target="_milos" id="ogsplugin_statbuttons" >';
        	td.innerHTML  = "<br><input type=\"button\" id=\"ogsplugin_prevbtn\" value=\"&lt;- "+buttonlabel+"\" onClick=\"OGPlugin_NextPageSubmit('l:ogsplugin');\">"+
        	"<input type=\"button\" id=\"ogsplugin_nextbtn\" value=\""+buttonlabel+" -&gt;\" onClick=\"OGPlugin_NextPageSubmit('r:ogsplugin');\">";

        	form.appendChild(td);

          var tds = OGPlugin_EvalNode(ogs_PathtoStatsTable+'/child::tbody', targetdocument);
        	if (tds.snapshotLength > 0) {
        		//tds.snapshotItem(0).insertBefore(form,tds.snapshotItem(0).firstChild);
            tds.snapshotItem(0).insertBefore(form,tds.firstChild);
          }

  	/*} catch (e) {
  		//alert("erreur OGPlugin_AddStatsNextPrevButtons");
  	} */
}

/**
 * Efface les numro d'id sessions prsents dans les captures html
 * @param html_content chane reprsentant un contenu texte balis HTML
 **/
function OGPlugin_CleanSessionIdData (html_content)
{
          var html_content_filtered = html_content;

           // filtrage des sessionid
          var sessionid_tab;

          // modle: session=143a6dd17ca4
          RegExpSessionID = /session=[0-9,a-f,A-F]{10,16}/gi;
          sessionid_tab = html_content_filtered.match(RegExpSessionID);
          // filtrage effectif
          html_content_filtered = html_content_filtered.replace(RegExpSessionID,"session=0");

          return html_content_filtered;
}
/**
 * Fonction de filtrage du contenu captur de la page Dfense (Ogame)
 * ex: remplacer '66 disponible, max. 0' par '66 disponible(s)_'
 **/
function OGPlugin_DefenceFilterPage(parcontenttofilter) {
          var lcontenttofilter = parcontenttofilter;

          const missilenumbers= /(\d{1,3})\s+disponible\,\s+max\.\s+\d{1,3}/g;
          missileenumfoundtab = lcontenttofilter.match(missilenumbers);

          if (missileenumfoundtab != null) {
              for (i=0;i<missileenumfoundtab.length;i++) {

                  missiletofilter = missileenumfoundtab[i];
                  const missilenumber = /(\d{1,3})\s+disponible\,\s+max\.\s+\d{1,3}/;
                  missileenumfound = missiletofilter.match(missilenumber); // retirer les points
                  if (ogs_defencefilterdebug_mode==true) alert("nb missile: "+missileenumfound[1]);
                  lcontenttofilter = lcontenttofilter.replace(missileenumfoundtab[i]," "+missileenumfound[1]+" disponible(s) " );
              }
          }
          return lcontenttofilter;
}

/**
 * filtrage de tous les indices de technos incrment du compte technocrate
 **/
function OGPlugin_FilterTechnoOfficer(parcontenttofilter) {

          var lcontenttofilter = parcontenttofilter;

          var TechnoLevels = /(Niveau\s+\d{1,3}\s)\+\d{1,2}\s*/gi;
          var TechnoIncrement = /\s?\+\d{1,3}\s/g;
          //var TechnoLevels=new RegExp('(Niveau\s\d{1,3}\s)\+\d{1,2}', 'gi');

          pointednumbersfound = lcontenttofilter.match(TechnoLevels);

          //alert("filtre: "+pointednumbersfound);
          if (pointednumbersfound!=null) {
              for (i=0;i<pointednumbersfound.length;i++) {

                  LevelLabeltofilter = pointednumbersfound[i].replace(TechnoIncrement,'');
                  //LevelLabeltofilter = OGPlugin_TrimString(LevelLabeltofilter); // retirer l'espace de fin

                  if (ogs_filtertechnoofficer_debug_mode==true) alert('dans boucle filtre OGPlugin_FilterTechnoOfficer: '+pointednumbersfound[i]+'/'+LevelLabeltofilter+' ('+pointednumbersfound.length+')');
                  lcontenttofilter = lcontenttofilter.replace(pointednumbersfound[i],LevelLabeltofilter); // remplacer 'Niveau 14 +2 ' par 'Niveau 14 '
              }
              if (ogs_filtertechnoofficer_debug_mode==true) alert("filtrage termine!");
          }

          if (ogs_filtertechnoofficer_debug_mode==true) alert(lcontenttofilter);
          return lcontenttofilter;
}

/**
 * filtrage de tous les messages de progression pour les recherches en cours
 **/
function OGPlugin_TechnoInProgressFilterLabels(parcontenttofilter) {

          if (parcontenttofilter=="") return "";
          else var lcontenttofilter = parcontenttofilter;


          var templineregsplit = /(\d{0,2}\:?\d{2}\:\d{2})\nInterrompre(\nsur\n\w+|Termin.\nContinuer|)(\s\n+(\d{0,2}\/\d{0,2}\s)\d{0,2}\:?\d{2}\:\d{2})?/i;



          labeltofilter = lcontenttofilter.match(templineregsplit);
          //alert(labeltofilter[0]+"\n"+labeltofilter.valueOf());
          // filtrage
          //alert('filtrage OGPlugin_TechnoInProgressFilterLabels\n'+labeltofilter);
          if (labeltofilter!=null)
              lcontenttofilter = lcontenttofilter.replace(labeltofilter[0], '-');

          //alert(lcontenttofilter);
          return lcontenttofilter;
}

/**
 * filtrage de tous les nombres d'un texte de donnes captures
 *
 **/
function OGPlugin_FilterNumberPoints(parcontenttofilter) {

          if (parcontenttofilter == '' || parcontenttofilter == null)
             return false;

          var lcontenttofilter = parcontenttofilter;

          /* on considre un sparateur de nombre comme un symbole sparant
          un bloc de 1  3 chiffres et un bloc de 3 chiffres - les nombres dcimaux sont normalement exlus */

          const pointednumbers= /(?:\d{1,3})(?:\.\d{3})+/g; // filtre spcifique Ogame
          const spacednumbers= /(?:\d{1,3})(?:\s\d{3})+/g; // filtre spcifique E-Univers
          var pointednumbersfound = lcontenttofilter.match(pointednumbers);
          var spacednumbersfound = lcontenttofilter.match(spacednumbers);

          if (pointednumbersfound != null) {
              if (ogs_filterpoint_debug_mode==true) alert("Entre dans la boucle de filtre!");
              for (i=0;i<pointednumbersfound.length;i++) {

                  numberfiltered = pointednumbersfound[i].replace(/\./g, ''); // retirer les points

                  // remplace les nombres  point par le mme nombre sans point
                  lcontenttofilter = lcontenttofilter.replace(pointednumbersfound[i],numberfiltered );
              }
          }

          if (spacednumbersfound != null) {
              for (i=0;i<spacednumbersfound.length;i++) {
                  numberfiltered = spacednumbersfound[i].replace(/\s/g, ''); // retirer les espaces

                  // remplace les nombres  point par le mme nombre sans point
                  lcontenttofilter = lcontenttofilter.replace(spacednumbersfound[i],numberfiltered );
              }
          }


          return lcontenttofilter;
}


/**
 * Filtrage des rapports d'espionnage: mise  zro du stock de ressources des hangars/rservoirs
 */
function OGPlugin_SpyReportFilter(spy_report) //  revoir
{
         var report_filtered="";
         //pattern = new RegExp("ogsplugin?[0-9]{0,2}.php","g");
         if (OGPlugin_getBoolPref('OGPlugin.settings.filterspyreportressource', false, '')==true) {
             pattern = new RegExp( "(Mtal\:\t\d+\t\tCristal\:\t\d+\nDeutrium\:\t\d+\tEnergie\:\t\d+)\nFlotte","g");

             report_filtered = spy_report.replace(pattern, "Mtal\:\t0\t\tCristal\:\t0\nDeutrium\:\t+\tEnergie\:\t+");
         }
         //alert(spy_report);
         return spy_report;
}

/**
 * Initialise les tableaux de noms correspondant Who et Type (Ogame)
 **/
function OGPlugin_InitStatsTabNames() {

    StatsWhoTabNames[0] = OGPlugin_GetLocString("statsupdated.playerprefix");
    StatsWhoTabNames[1] = OGPlugin_GetLocString("statsupdated.allyprefix");

    StatsTypeTabNames[0] = OGPlugin_GetLocString("statsupdated.scorewordinfix");
    StatsTypeTabNames[1] = OGPlugin_GetLocString("statsupdated.fleetwordinfix");
    StatsTypeTabNames[2] = OGPlugin_GetLocString("statsupdated.researchwordinfix");

}

/**
 * Surbrillance Ogame
 * Mise  jour des infos de surbrillance depuis premier serveur ogspy correspondant: une seule fois au dmarrage
 * @param paraccounturlassoc tableau de chane compos d'une url[0], un id de compte[1] et d'un nom de serveur[2]
 **/
function OGPlugin_OgameChkHighlightingOnStart(paraccounturlassoc)
{

        if (ogs_firsttime_onogamepageload==true && IsOGameDomain==true && paraccounturlassoc!=false) {
            ogs_firsttime_onogamepageload = false;


            if (OGPlugin_getBoolPref('OGPlugin.settings.checkdiplomatyonstart', false, '')) {
                // mise  jour infos surbrillance premier serveur correspondant
                OGPlugin_SetStatusViewLabel("notify","V\u00e9rification des infos de surbrillance(diplomatie) sur "+paraccounturlassoc[2]);
                var result_ServerCatAllies = OGPlugin_GetServerCatAllies(ogs_targetserverid, ogs_targetogspyurl, true);
                if (result_ServerCatAllies[0]==true) {

                    // enregistrement dans les proprits
                    OGPlugin_setCharPref("OGPlugin.settings.srvfriendlyallies"+ogs_targetserverid, result_ServerCatAllies[2], '');
                    OGPlugin_setCharPref("OGPlugin.settings.srvpnaallies"+ogs_targetserverid, result_ServerCatAllies[3], '');
                    OGPlugin_setCharPref("OGPlugin.settings.srvenemyallies"+ogs_targetserverid, result_ServerCatAllies[4], '');
                    OGPlugin_setCharPref("OGPlugin.settings.srvtradingallies"+ogs_targetserverid, result_ServerCatAllies[5], '');

                    alert("Mise \u00e0 jour des infos de surbrillance depuis premier serveur ogspy correspondant(n\u00b0"+ogs_targetserverid+":"+ogs_targetservername+")\n\u00e0 l'univers courant: \n"+ogs_targetogspyurl+"\n\n"+result_ServerCatAllies[1]);
                    OGPlugin_SetStatusViewLabel("notify", result_ServerCatAllies[1]);
                } else {

                  OGPlugin_SetStatusViewLabel("notify", "Aucune mise \u00e0 jour de la diplomatie(surbrillance) n'a \u00e9t\u00e9 d\u00e9tect\u00e9e sur "+ogs_targetservername);
                }
            }

        }
}

/**
 * Rcupre le libell de Plante affich dans la bote de choix en haut de la page Ogame (0.76)
 **/
function OGPlugin_getOgamePlanetLabel(partargetdoc)
{
        var tmpPlanetNameWithCoords = "";
        var PlanetSelectBox = partargetdoc.getElementsByTagName('select')[0];
        if (PlanetSelectBox!=null) {
            tmpPlanetNameWithCoords = PlanetSelectBox.options[PlanetSelectBox.selectedIndex].text;
            tmpPlanetNameWithCoords = tmpPlanetNameWithCoords.replace("    ["," [")
        } 
        return tmpPlanetNameWithCoords;
}

/**
 * Rcupre le nom de serveur Ogame  partir d'une url de page
 * @param pardocurl chane adresse url d'un document
 **/
function OGPlugin_ExtractOgameServerFromUrl (pardocurl)
{
        // extraction nom serveur Ogame depuis URl
        tmpOgameServer = pardocurl.match(/^http\:\/\/([\w\d\.]+)[\/|$]/);
        if (tmpOgameServer!=null) {
            if (ogs_currentogameuniverse!="" && ogs_currentogameuniverse != tmpOgameServer[1]) {
                OGPlugin_SetStatusViewLabel("notify","Changement d'univers d\u00e9tect\u00e9." );
                // voir pour rinitialisation des tampons temporaires
            }
            ogs_currentogameuniverse = tmpOgameServer[1];
        } else ogs_currentogameuniverse="";
}
