/*
Barre d'Outils OGSPY, extension firefox d'aide aux mise  jour de serveurs OGSPY

OGSPY Toolbar, a firefox plugin for helping players in updating OGSPY servers game datas

Copyright (C) 2006-2007 Naqdazar (ajdr@free.fr)

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
au titre des clauses de la Licence Publique Gnrale GNU, telle que publie par la
Free Software Foundation ; soit la version 2 de la Licence.
Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ;
 sans mme une garantie implicite de COMMERCIABILITE ou DE CONFORMITE A UNE UTILISATION PARTICULIERE.

 Voir la Licence Publique Gnrale GNU pour plus de dtails.

 Vous devriez avoir reu un exemplaire de la Licence Publique Gnrale GNU avec ce programme ;
  si ce n'est pas le cas, crivez  la Free Software Foundation Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

This program is free software; you can redistribute it and/or modify it under the
terms of the GNU General Public licence as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details.

You should have received a copy of the GNU General Public licence along with this program;
 if not, write to the Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/**
 * ######### Variables globale pour Ogame / E-Univers dplaces dans ogq_commonhooks.js ########
 **/
 

/**
 * Appel toutes les fonctions prdfinies capables de dtecter et analyser une page de jeu Ogame
 **/

function OGPlugin_OgameChkAllHandledPages(partargetdoc)
{
        // combat reports - /game/bericht.php // rapport espio en popup
        OGPlugin_HandleOgameCombatReportPage(partargetdoc);

        // Dtection et traitement de la page empires
        OGPlugin_HandleOgameEmpirePage(partargetdoc);

        // infos plante / coord non dispo sur page galaxie et pages empires!!!!! -> exception
        PlanetNameWithCoords = OGPlugin_getOgamePlanetLabel(partargetdoc); // eg sur Ogame : "Terria [1:120:8]"

        // Dtection et traitement de la page vue galaxie
        OGPlugin_HandleOgameGalaxyPage(partargetdoc);

        // Dtection et traitement de la page classements gnraux (points, flotte, recherche)
        OGPlugin_HandleOgameStatsPage(partargetdoc);

        //Dtection et traitement de la page messages
        OGPlugin_HandleOgameMessagesPage(partargetdoc);

        // Dtection et traitement de la page alliance interne
        OGPlugin_HandleOgameAllyPage(partargetdoc);

        // Building - Btiments /game/b_building.php - pas d'autres param type sous-page (defence, techno, etc...)
        OGPlugin_HandleOgameBuildingPage(partargetdoc);

        // Ressources - /game/resources.php - pas d'autres param type sous-page (btiments/defence, btiments/techno, etc...)
        OGPlugin_HandleOgameRessourcePage(partargetdoc);

        // Flotten - /game/flotten.php - pas d'autres param type sous-page (btiments/defence, btiments/techno, etc...)
        OGPlugin_HandleOgameFleetPage(partargetdoc);

        // Dtection et traitement des pages laboratoire, chantier spatial et dfense
        OGPlugin_HandleOgameAltBuildingsPage(partargetdoc);

        // Page d'accueil / Vue Gnrale - /game/overview.php
        OGPlugin_HandleOgameOverviewPage(partargetdoc);
}


/**
 * Fonctions de dtections des Pages Ogame et de prparation aux captures de donnes
 * Ces fonctions doivent pouvoir accder aux variables et constantes globales de ogsplugin.js
 **/
 
function OGPlugin_HandleOgameStatsPage(parDocument)
{

        //////////////////////////
        // CLASSEMENTS GENERAUX //
        //////////////////////////
        // commun  toutes les actions d'envoi manuel
        if(CurrentDocUrl.search("/game/stat.php") > -1) {

            if (ogs_getstatsdebug_mode==true) alert("Page statistiques dtecte!");
            
            


            var handlegeneralstats=false;
            // rcupration des infos d'interface classement
            OGPlugin_selectedTyp = OGPlugin_getStatsTyp(parDocument);
            OGPlugin_selectedWho = OGPlugin_getStatsWho(parDocument);
            OGPlugin_selectedRanks = OGPlugin_getStatswhitch(parDocument);
            
            

            statusviewline = OGPlugin_GetLocString("statsfound.prefix");
            if (OGPlugin_selectedWho == 0) statusviewline += OGPlugin_GetLocString("statsupdated.playerprefix");
            if (OGPlugin_selectedWho == 1) statusviewline += OGPlugin_GetLocString("statsupdated.allyprefix");

            if (OGPlugin_selectedTyp == 0) statusviewline_typ = OGPlugin_GetLocString("statsupdated.scorewordinfix");
            if (OGPlugin_selectedTyp == 1) statusviewline_typ = OGPlugin_GetLocString("statsupdated.fleetwordinfix");
            if (OGPlugin_selectedTyp == 2) statusviewline_typ = OGPlugin_GetLocString("statsupdated.researchwordinfix");
            



            
            if (OGPlugin_getBoolPref('OGPlugin.settings.autocopytoclpbrd', false, '')) {
                var statstextsel = OGPlugin_GetStatsTextSel(parDocument);

                // ajout de tags pour ODS
                statstextsel = "<typeclassement="+ogs_stats_who_tags[OGPlugin_selectedWho]+"_"+ogs_stats_what_tags[OGPlugin_selectedTyp]+">\n" + statstextsel;
                if (OGPlugin_CopyToClipboard(statstextsel))
                OGPlugin_SetStatusViewLabel("success", ogs_gameprefixmsg+'Classement g\u00e9n\u00e9ral copi\u00e9 dans le presse-papier');
            }

            // Si le tampon n'est pas vide activer le bouton mme si la mise en tampon n'est pas active
            if (Curr_StatBufCount[OGPlugin_selectedWho][OGPlugin_selectedTyp]>0) OGPlugin_SetFlushButtonState(true);

            statusviewline += "("+statusviewline_typ+")"+" ["+OGPlugin_selectedRanks+"] "+OGPlugin_GetLocString("statsfound.suffix");
            OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+statusviewline);
            //----------------------------------------
            // doit rcuprer le texte du classement avant de mettre en surbrillance
            text = OGPlugin_getStatsText(parDocument, OGPlugin_FoxGameGetBooleanPref("foxgameAddStatButtons",false));


            if (ogs_filterpoint_debug_mode==true) alert(text);
            // filtrage des points de nombre
            /* if (OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, '')==true) {
                if (ogs_filterpoint_debug_mode==true) alert(text);
                // text = OGPlugin_FilterNumberPoints(text); // INUTILE
            } */

            // surbrillance active??
            if (OGPlugin_getBoolPref('OGPlugin.settings.enablehighlighting', false, '')==true) {
                ///////////////////////////////////////////////////////////
                // MISE EN COULEUR DES JOUEURS ET ALLIANCE DU CLASSEMENT // ********************
                ///////////////////////////////////////////////////////////

                // Mise en surbrillance
                // Appel d'office, traitements catgorie dans la fonction
                // appel de la fonction mise en couleur des lments du tableau
                OGPlugin_StatsColorTypedNames(OGPlugin_selectedWho, OGPlugin_selectedTyp, parDocument, ogs_targetserverid, OGPlugin_FoxGameGetBooleanPref("foxgameAddStatButtons",false));
                //******************************************************************
            } // fin test gestion surbrillance

            //==================================================================
            // ajout boutons dfilement sur les pages de classement
            if (OGPlugin_getBoolPref("OGPlugin.settings.genstatsbuttons", false, '')==true) {
                try {
                    OGPlugin_AddStatsNextPrevButtons(parDocument);
                } catch(e) {
                  // ajout d'un message dans le journal sans affichage!
                  if (ogs_getstatsdebug_mode==true) alert("Erreur insertion boutons dfil");
                  ogs_StatusLabelsHistory.push(labeltext_date.toLocaleString()+" : "+OGPlugin_GetLocString("error.couldntinsertstatsbuttons"));
                }
            }
            //==================================================================
            if (OGPlugin_selectedWho == 0) {
                response_Whoname = OGPlugin_GetLocString("statsupdated.playerprefix");
                // dclaration dbut fichier: global pour fonction FillInStats....
                ogs_buff_statusviewline = OGPlugin_GetLocString("statsupdated.playerprefix");
            }
            if (OGPlugin_selectedWho == 1) {
                response_Whoname = OGPlugin_GetLocString("statsupdated.allyprefix");
                ogs_buff_statusviewline = OGPlugin_GetLocString("statsupdated.allyprefix");
            }
            //==================================================================
            if (OGPlugin_selectedTyp == 0) {
                response_Typename = OGPlugin_GetLocString("statsupdated.scorewordinfix");
                ogs_buff_statusviewline += '('+OGPlugin_GetLocString("statsupdated.scorewordinfix")+')';
            }
            if (OGPlugin_selectedTyp == 1) {
                response_Typename = OGPlugin_GetLocString("statsupdated.fleetwordinfix");
                ogs_buff_statusviewline += '('+OGPlugin_GetLocString("statsupdated.fleetwordinfix")+')';
            }
            if (OGPlugin_selectedTyp == 2) {
                response_Typename = OGPlugin_GetLocString("statsupdated.researchwordinfix");
                ogs_buff_statusviewline += '('+OGPlugin_GetLocString("statsupdated.researchwordinfix")+')';
            }
            //==================================================================
            if (ogs_getstatsdebug_mode==true) alert("Who: "+OGPlugin_selectedWho+"\nresponse_Whoname: "+response_Whoname);
            //==================================================================
            if (text=="statsnodata") {
                statusviewline=OGPlugin_GetLocString("error.nostatsdatafound.prefix")+response_Whoname+" ("+OGPlugin_selectedRanks+")"+OGPlugin_GetLocString("error.nostatsdatafound.suffix");
                OGPlugin_SetStatusViewLabel("notify", statusviewline);
                return 0;
            } else if (text=="partialstatsdata") {
                statusviewline=OGPlugin_GetLocString("error.partialstatsdatafound.prefix")+response_Whoname +" ("+OGPlugin_selectedRanks+")"+OGPlugin_GetLocString("error.partialstatsdatafound.suffix");
                OGPlugin_SetStatusViewLabel("notify", statusviewline);
            }


            // TRAITEMENTS STATS A FAIRE OU PAS
            handlegeneralstats=OGPlugin_getBoolPref("OGPlugin.settings.handlegeneralstats", true, "");
            if (handlegeneralstats==true) { // donnes classement  traiter pour envoi sur serveur

                // test buffering activ
                enablestatbuffering=OGPlugin_getBoolPref("OGPlugin.settings.enablestatbuffering", false, '');
                if (enablestatbuffering==true ) {
                    if (OGPlugin_FillInStatsBuffer(OGPlugin_selectedWho, OGPlugin_selectedTyp, text)==0)
                        OGPlugin_SetStatusViewLabel("nothingdone", ogs_gameprefixmsg+"Donn\u00e9es de classement "+response_Whoname+"("+response_Typename+") "+OGPlugin_selectedRanks+" d\u00e9j\u00e0 pr\u00e9sentes dans le tampon!");
                } else OGPlugin_result = OGPlugin_sendText("stats",text,CurrentDocUrl);
            }  // fin test gestion page stats
            else OGPlugin_SetStatusViewLabel("notify",ogs_gameprefixmsg+statusviewline+" - "+OGPlugin_GetLocString("error.statsmanagmntdisabled"));
        }
}

/**
 * Dtection de la page message / rapport Ogame
 **/
function OGPlugin_HandleOgameMessagesPage(parDocument)
{
        ///////////////////
        // PAGE MESSAGES //
        ///////////////////

        // Dtection et traitement de la page Messages
        if(CurrentDocUrl.search("/game/messages.php") > -1) {

            if (OGPlugin_getBoolPref('OGPlugin.settings.autocopytoclpbrd', false, '')) {
                // copie du contenu texte de la page dans le presse papier
                var reportstextsel = OGPlugin_GetSpyReportsTextSel(parDocument);
                if (OGPlugin_CopyToClipboard(reportstextsel))
                OGPlugin_SetStatusViewLabel("success", ogs_gameprefixmsg+'Contenu des messages copi\u00e9s dans le presse-papier');
            }

            ogs_ismodecommandant=false;
            var msg_handled=true; // d'aprs l'url est-ce une catgorie prise en charge(commandant surtout)
            ogs_messagetype="";
            var msgpanel_cmd = false;

            var mode_commandant_string="";
            ogs_ismodecommandant = OGPlugin_IsCommandantMsgPanel(parDocument);
            var are_msg_handled_onpage = OGPlugin_DetectHandledMessages(parDocument, ogs_ismodecommandant);
            if (ogs_debug_mode==true) alert("Nb tables: "+parDocument.getElementsByTagName('table').length+"\nMessage dtectes: "+are_msg_handled_onpage);
            OGPlugin_SetSendButtonLabel("reports",false);

            if (msgpanel_cmd==true)
                mode_commandant_string=" (Panneau Menu)";

            // dtection mode commandant?
            if (CurrentDocUrl.search("&espioopen") > -1) { // au lieu de &espioopen=0 ou on
                ogs_ismodecommandant=true;
                msg_handled=are_msg_handled_onpage;
                mode_commandant_string=" (Rapports d'espionnages)";
                ogs_messagetype="espio";
                // if (ogs_debug_mode==true) alert(OGPlugin_GetSpyReportsTextSel(parDocument));
            } else

            if (CurrentDocUrl.search("&combatopen") > -1) {
                ogs_ismodecommandant=true;
                msg_handled=are_msg_handled_onpage;
                mode_commandant_string=" (Rapports de combat)";
                ogs_messagetype="combat";
            } else

            if (CurrentDocUrl.search("&generalopen=") > -1) {
                ogs_ismodecommandant=true;
                msg_handled=true;
                mode_commandant_string=" (Autres messages)";
                ogs_messagetype="general";
            } /* else

            if (CurrentDocUrl.search("&useropen=") > -1) {
                ogs_ismodecommandant=true;
                msg_handled=false;
                mode_commandant_string=" (Messages de joueurs)";
                ogs_messagetype="user";
            } */ else { // mode compte simple
                  /* // bis repetita
                  ogs_ismodecommandant = OGPlugin_IsCommandantMsgPanel(parDocument); */

                  if (ogs_ismodecommandant==true) mode_commandant_string = " (Menu Commandant)";
                  ogs_messagetype="all";
                  msg_handled = are_msg_handled_onpage;

            }
            /* if (mode_commandant==true) mode_commandant_string="(Mode Commandant)";
            else mode_commandant_string=""; */


            //if (mode_commandant==false) OGPlugin_SetSendButtonLabel("reports",false); // SendButtonActionCmd=="reports"

            if (msg_handled==true) {// catgories de messages gres, ex pas message utilisateur avec cette version
                // cas mode commandant, option catgorie message doit tre choisie
                OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+OGPlugin_GetLocString("reportsfound")+mode_commandant_string);
                if (msgpanel_cmd==false || ogs_ismodecommandant==true) {
                    if (OGPlugin_getBoolPref("OGPlugin.settings.autoreporten", false, '')==true)
                       OGPlugin_GetOgamePageReport();
                    else {
                         OGPlugin_SetSendButtonLabel('reports', msg_handled);
                    }
                }
            } else OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+OGPlugin_GetLocString("reportsfound")+mode_commandant_string+" - Aucun message \u00e0 capturer!");
            return;
        }
}

/**
 * Dtection de la page vue galaxie Ogame
 **/
function OGPlugin_HandleOgameGalaxyPage(parDocument)
{
// Gestion page galaxie
        if(CurrentDocUrl.search("/game/galaxy.php") > -1) {
            // break if foxgame reduced galaxyview or enhanced debris field is enabled
            var handlegalaxyviews=false;

            if (OGPlugin_getBoolPref('OGPlugin.settings.autocopytoclpbrd', false, '')) {
                var galaxytextsel = OGPlugin_GetGalaxyTextSel(parDocument);
                if (OGPlugin_CopyToClipboard(galaxytextsel))
                OGPlugin_SetStatusViewLabel("success", ogs_gameprefixmsg+'Contenu de page galaxie copiee dans le presse-papier');
            }

            // mises en commun
            OGPlugin_selectedGalaxy = OGPlugin_getGalaxy(parDocument);
            OGPlugin_selectedSystem = OGPlugin_getSystem(parDocument);
            statusviewline=OGPlugin_GetLocString("galaxyfound.prefix")+OGPlugin_selectedGalaxy+":"+OGPlugin_selectedSystem+OGPlugin_GetLocString("galaxyfound.suffix");
            OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+statusviewline);

            // --------------------------------------------------------------------

            var var_foxgameRemovePlanets = OGPlugin_FoxGameGetBooleanPref("foxgameRemovePlanets",false);

            // les vues galaxie sont-elle prises en charge?
            handlegalaxyviews=OGPlugin_getBoolPref("OGPlugin.settings.handlegalaxyviews", true, '');
            if (handlegalaxyviews==true)  {
                var galaxy_cmd="galaxy";
                SendButtonActionCmd = galaxy_cmd;
                //------
                var var_foxgameAddMilosButtons = OGPlugin_FoxGameGetBooleanPref("foxgameAddMilosButtons",false); // bouton vue galaxie?
                // foxgameAddMilosButtons
                if (var_foxgameAddMilosButtons==true) { // ne fonctionne que pour les bases ogspy
                     galaxy_cmd="galaxyraw";
                     text = parDocument.getElementsByTagName("input")[11].value;
                     if (text.length<10 || text=="galaxy") {
                        OGPlugin_SetStatusViewLabel("failure",OGPlugin_GetLocString("error.foxgamedbnotogspy"));
                        if (OGPlugin_getBoolPref("OGPlugin.settings.autoshowfgoptions", false, '') == true)
                           OGPlugin_ShowFoxgameOptions(2);
                     }
                } else {
                        try {
                            text = OGPlugin_get_galaxyview_data(parDocument,var_foxgameRemovePlanets);
                        } catch(e) {
                            // foxgame n'est pas install
                            text = OGPlugin_get_galaxyview_data(parDocument,false);
                        }
                }
                
                if (OGPlugin_getBoolPref('OGPlugin.settings.gatesendmod', false, '')) { // mode envoie vers portail
                    OGPlugin_result = OGPlugin_sendText(galaxy_cmd,galaxytextsel,CurrentDocUrl);
                    OGPlugin_SetStatusViewLabel("nothingdone", ogs_gameprefixmsg+"Envoi direct vers Portail.");
                
                } else {
                    //
                    if (OGPlugin_getBoolPref('OGPlugin.settings.enablegalviewbuffering',false,'')==true) {
                        if (OGPlugin_FillInGalBuffer(OGPlugin_selectedGalaxy+":"+OGPlugin_selectedSystem, text)==0)
                            OGPlugin_SetStatusViewLabel("nothingdone", ogs_gameprefixmsg+statusviewline+OGPlugin_GetLocString("error.galviewalreadyexistsinbuffer"));
                    } else OGPlugin_result = OGPlugin_sendText(galaxy_cmd,text,CurrentDocUrl);
                }
                // fin test gestion vue galaxie
            } else OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+statusviewline+OGPlugin_GetLocString("error.galviewsmanagmntdisabled"));
            
            
            /* surbrillance active??
               laisser ici sans quoi les champs capturs contiendront d'autres infos: eg classement #10 */
            if (OGPlugin_getBoolPref('OGPlugin.settings.enablehighlighting', false, '')==true) {
                // Mise en surbrillance
                // Appel d'office, traitements descatgories dans la fonction et ses sous-fonctions
                OGPlugin_GalViewsColorTypedNames(parDocument, ogs_targetserverid, var_foxgameRemovePlanets); // obsolte ...,tmpaltfriendlyallies,tmpaltpnaallies,tmpaltenemyallies, tmpalttradingallies);
            }

            return 1;
        }
}

/**
 * Dtection de la page historique alliance Ogame
 **/
function OGPlugin_HandleOgameAllyPage(parDocument)
{
        var TAGLabelFound='';

        // Allyhistory
        if (CurrentDocUrl.search("/game/allianzen.php") > -1) {
            if (CurrentDocUrl.search("&a=4") > -1) {


               // test supplmentaire pour dtecter restauration de session firefox sur tableau alliance
               if  (AllyTAGFound!='undefined' && AllyTAGFound!=null && AllyTAGFound!='' ) { // TAG dtecte et NON undefined?
                   OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+OGPlugin_GetLocString("allystatsfound")+" ("+AllyTAGFound+")");
                   if (OGPlugin_getBoolPref("OGPlugin.settings.handleallystats", true, '') == true) // vrifie si option gestion alliance perso ok
                   {
                      ally_history_content = parDocument.getElementsByTagName("table")[OGPlugin_getIntPref('OGPlugin.settings.allyhisttablerank', ogs_AllyHistRankTab, '')].innerHTML;

                      // filtrage des points de nombre
                      if (OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, '')==true)
                         ally_history_content = OGPlugin_FilterNumberPoints(ally_history_content);

                      if (ogs_allyhistorydebug_mode==true) alert(ally_history_content);

                      OGPlugin_result = OGPlugin_sendText("allyhistory",ally_history_content,CurrentDocUrl);
                   }
               } else OGPlugin_SetStatusViewLabel("nothingdone", ogs_gameprefixmsg+"Tableau alliance : cliquer sur le menu Alliance pour capturer le TAG!");

            } else if(CurrentDocUrl.search("&a=") == -1){ // viter les autres pages


              // cas  prvoir s'il n'y a pas d'image alliance, le TAG est sur la ligne 1 dans le cas (0,1,...)

              // vrifier qu'un page d'alliance existe
              var IsPageWithAllyExists = parDocument.getElementsByTagName("table").length>=6; // Ogame 0.76 5+1

              if (IsPageWithAllyExists==true) {
                  // RECHERCHE DU TAG D'ALLIANCE
                  TAGLabelFound = parDocument.getElementsByTagName("table")[OGPlugin_getIntPref('OGPlugin.settings.allyhisttablerank', ogs_AllyHistRankTab, '')].rows[1].cells[0].innerHTML;
                  // premier cas, 2e ligne quand il n'y a pas d'image
                  if (TAGLabelFound=='TAG') {
                      //alert("tag sur premire ligne!");
                      tmpallytagread = parDocument.getElementsByTagName("table")[OGPlugin_getIntPref('OGPlugin.settings.allyhisttablerank', ogs_AllyHistRankTab, '')].rows[1].cells[1].innerHTML;
                  }
                  // si 'TAG' n'est pas trouv c'est la troisime ligne
                  else {
                          //alert("tag sur deuxime ligne!");
                          TAGLabelFound = parDocument.getElementsByTagName("table")[OGPlugin_getIntPref('OGPlugin.settings.allyhisttablerank', ogs_AllyHistRankTab, '')].rows[2].cells[0].innerHTML;
                          tmpallytagread = parDocument.getElementsByTagName("table")[OGPlugin_getIntPref('OGPlugin.settings.allyhisttablerank', ogs_AllyHistRankTab, '')].rows[2].cells[1].innerHTML;

                       }

                  // masque qui tient compte du changement de TAG nouveau (ex: ancien )
                  var RegExpAllyTag=new RegExp("^(.+)\s?(?:\(.*\))$","");

                  AllyTAGFound = RegExpAllyTag.exec(tmpallytagread)[1];

                  //alert("tag ally: "+AllyTAGFound);

                  //alert(TAGLabelFound+"-"+AllyTAGFound);

                  if ((AllyTAGFound!='') && TAGLabelFound=='TAG') {
                      if (AllyTAGFound!='undefined')
                          statusviewline = OGPlugin_GetLocString("allypagefound")+" ("+AllyTAGFound+")";
                      else statusviewline = OGPlugin_GetLocString("allypagefound")+" ("+OGPlugin_GetLocString("error.allyundefined")+")";
                  }

                  OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+statusviewline);
                }
            }
        }

}

/**
 * Dtection de la page Empire Ogame
 **/
function OGPlugin_HandleOgameEmpirePage(parDocument)
{
        if (CurrentDocUrl.search("/game/imperium.php") > -1) {
            //alert("empire");
            if (CurrentDocUrl.search("&planettype=1") > -1) {
            // empire plante
              OGPlugin_SetSendButtonLabel("planetempire", true);
              statusviewline = OGPlugin_GetLocString("planetempirefound");
            } else if (CurrentDocUrl.search("&planettype=3") > -1) {
            // empire lunes
              OGPlugin_SetSendButtonLabel("moonempire", true);
              statusviewline = OGPlugin_GetLocString("moonempirefound");
            }
            OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+statusviewline);


            if (OGPlugin_getBoolPref("OGPlugin.settings.autosendempirepage", false, '')==true)
               OGPlugin_GetOgamePageReport();
            else {
                 document.getElementById("OGPlugin-reports").disabled = false;
            }

            return;
        }
}

/**
 * dtection et prparation au traitement des rapports de combat
 **/
function OGPlugin_HandleOgameCombatReportPage(parDocument)
{
        // attention les rapports d'espionnage surgissant sont affich par ce script beright.php
        if (CurrentDocUrl.search("/game/bericht.php") > -1 /* && !disable_extra_page_detection */) {
            //alert("rapports de combats!");

            /* on s'assure de n'avoir pas accd au popup des rapports d'espionnage
            par l'icne de la vue galaxie(mode commandant) */

            if (CurrentDocUrl.search("&pID=") == -1) { // n'est pas un rapport d'espionnage obtenu de la page galaxie
                OGPlugin_showWindowChrome();
                //---
                //**************************************************************
                /// dtecter si on a affaire  un rapport de combat ou un rapport d'espionnage surgissant
                // option "Ne montrer qu'une partie du rapport d'espionnage"
                var targettable = OGPlugin_TrigDoc.getElementsByTagName("table")[0];
                if (targettable!=null) {

                    if (targettable.innerHTML.search(RegExpSpyHeader)>-1) {
                        // cas particulier: rapport d'espionnage surgissant depuis page messages
                        // mixte compte simple et commandant
                        // OGPlugin_GetLocString
                        if (ogs_getreportsdebug_mode==true) alert("rapport de combat surgissant");
                        OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+OGPlugin_GetLocString("spyreportpopupfound"));
                        //-----
                        ogs_messagetype = "spyreport_onpopup";
                        OGPlugin_SetSendButtonLabel("reports", false);
                        if (OGPlugin_getBoolPref("OGPlugin.settings.autoreport", false, '')==true)
                           OGPlugin_GetOgamePageReport();
                        else document.getElementById("OGPlugin-reports").disabled = false;
                        return 1;
                    }
                } else if (ogs_getreportsdebug_mode==true) alert("erreur getElementsByTagName table0");
                //**************************************************************
                // valeur ogs_targetserverid  revoir

                if (OGPlugin_getCharPref('OGPlugin.settings.playernick'+ogs_targetserverid, 'aucun_pseudo', '')!="") {

                   OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+OGPlugin_GetLocString("combatrepfound"));
                   OGPlugin_SetSendButtonLabel("combreports", false); // appel ncessaire ici -> "combreports" dtermine opration
                    if (OGPlugin_getBoolPref("OGPlugin.settings.autosendrcreport", false, '')==true)
                       OGPlugin_GetOgamePageReport();
                    else  document.getElementById("OGPlugin-reports").disabled = false;  // dgriser
                }
                else OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+OGPlugin_GetLocString("combatrepnonick")+" ("+ogs_targetserverid+")");
            } else { // rapports d'espionnage par menu galaxie non grs
                  OGPlugin_SetSendButtonLabel("reports", false);
                  OGPlugin_SetStatusViewLabel("nothingdone", ogs_gameprefixmsg+OGPlugin_GetLocString("planetspyreportnothandled"));
                  return 0;
            }
            return 1;
        }
}

/**
 * Dtection de la page btiments Ogame
 **/
function OGPlugin_HandleOgameBuildingPage(parDocument)
{
        // Buildings - /game/b_building.php - pas d'autres param type sous-page (defence, techno, etc...)
        if (CurrentDocUrl.search("/game/b_building.php") > -1) {
            OGPlugin_SetSendButtonLabel("buildings", true);
            OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+OGPlugin_GetLocString("buildingsfound")+PlanetNameWithCoords);

            if (OGPlugin_getBoolPref("OGPlugin.settings.autosendbuildingpage", false, '')==true)
               OGPlugin_GetOgamePageReport();
            else {
                 document.getElementById("OGPlugin-reports").disabled = false;
            }
        }
}

/**
 * prise en charge de la page de sommaire de la plante: temprature, diamtre, nb de cases, etc...
 **/
function OGPlugin_HandleOgameOverviewPage(parDocument)  // parDocument inutile
{
        if (CurrentDocUrl.search("/game/overview.php") > -1) {
            OGPlugin_SetSendButtonLabel("overview", true);
            OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+OGPlugin_GetLocString("overviewfound")+PlanetNameWithCoords);

            if (OGPlugin_getBoolPref("OGPlugin.settings.autosendoverviewpage", false, '')==true)
               OGPlugin_GetOgamePageReport();
            else {
                 document.getElementById("OGPlugin-reports").disabled = false; // activation du bouton
            }
        }
}

/**
 * Dtection de la page Ressources Ogame
 **/
function OGPlugin_HandleOgameRessourcePage(parDocument) // parDocument inutile
{
        // Ressources - /game/resources.php - pas d'autres param type sous-page (btiments/defence, btiments/techno, etc...)
        if (CurrentDocUrl.search("/game/resources.php") > -1) {
            OGPlugin_SetSendButtonLabel("resources", true);
            OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+OGPlugin_GetLocString("resourcesfound")+PlanetNameWithCoords);

            if (OGPlugin_getBoolPref("OGPlugin.settings.autosendresourcespage", false, '')==true)
               OGPlugin_GetOgamePageReport();
            else {
                 document.getElementById("OGPlugin-reports").disabled = false;
            }
        }
}

/**
 * Dtection de la page Flotte(plante/lune) Ogame
 **/
function OGPlugin_HandleOgameFleetPage(parDocument) // parDocument inutile
{
        // Flotten - /game/flotten.php - pas d'autres param type sous-page (btiments/defence, btiments/techno, etc...)
        if (CurrentDocUrl.search("/game/flotten1.php") > -1) {
            OGPlugin_SetSendButtonLabel("flotten", true);
            OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+OGPlugin_GetLocString("flottenfound")+PlanetNameWithCoords);

            if (OGPlugin_getBoolPref("OGPlugin.settings.autosendfleetpage", false, '')==true)
               OGPlugin_GetOgamePageReport();
            else {
                 document.getElementById("OGPlugin-reports").disabled = false;
            }
        }
}

/**
 * Dtection et traitement des pages laboratoire, chantier spatial et dfense
 **/
function OGPlugin_HandleOgameAltBuildingsPage(parDocument) // parDocument inutile
{
        if (CurrentDocUrl.search("/game/buildings.php") > -1) {
           // Technology  buildings.php?session=654654654b6&mode=Forschung
           if (CurrentDocUrl.search("mode=Forschung") > -1) {
             OGPlugin_SetSendButtonLabel("technos", true);
             OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+OGPlugin_GetLocString("technosfound"));

            if (OGPlugin_getBoolPref("OGPlugin.settings.autosendtechnopage", false, '')==true)
               OGPlugin_GetOgamePageReport();
            else {
                 document.getElementById("OGPlugin-reports").disabled = false;
            }
           }
           // Shipyard / Chantier Spatial - /game/buildings.php?session=654654654&mode=Flotte
           else if (CurrentDocUrl.search("mode=Flotte") > -1  && !disable_extra_page_detection) {  // chantier spatial!!
             OGPlugin_SetSendButtonLabel("shipyard", true);
             OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+OGPlugin_GetLocString("shipyardfound")+PlanetNameWithCoords);

            if (OGPlugin_getBoolPref("OGPlugin.settings.autosendshipyardpage", false, '')==true)
               OGPlugin_GetOgamePageReport();
            else {
                 document.getElementById("OGPlugin-reports").disabled = false;
            }
           }
           //defence  - game/buildings.php?session=987654645&mode=Verteidigung
           else if (CurrentDocUrl.search("mode=Verteidigung") > -1) {
              OGPlugin_SetSendButtonLabel("defence", true);
              OGPlugin_SetStatusViewLabel("notify", ogs_gameprefixmsg+OGPlugin_GetLocString("defencefound")+PlanetNameWithCoords);

            if (OGPlugin_getBoolPref("OGPlugin.settings.autosenddefencepage", false, '')==true)
               OGPlugin_GetOgamePageReport();
            else {
                 document.getElementById("OGPlugin-reports").disabled = false;
            }
           }
        } // fin page buidlings
}



//====================================================================================================
/**
 * Capture la page Ogame spcifie destine  tre intgre dans l'espace personnel OGSPY ou autre
 * Mthode appele lors d'un clic sur le bouton envoyer
 **/
function OGPlugin_GetOgamePageReport() {

    /**
     * Commandes prises en charge:
     *  reports : rapports d'espionnage, recyclage, espionnage ennemi
     *  buildings : page btiments
     *  resources : page ressources si utilis
     *  technos : page laboratoire
     *  shipyard : page chantier spatial si utilis
     *  flotten : page flotte
     *  defence : page dfense
     *  combreports : rapports de combat sur cadre surgissant
     *  planetempire : tableau gnral des plantes
     *  moonempire : tableau gnral des lunes
     *  overview : vue gnrale - nb cases, temlprature, etc...
     **/

    // reports / buildings / combreports / defence / fleet / technos
    // ici OGPlugin_TrigDoc.location.href  revoir, plutt enr dans var locale juste aprs dtection
    if (SendButtonActionCmd=="reports") {

           var messageElements; // = OGPlugin_TrigDoc.getElementsByTagName("table")[5].innerHTML;
           if (ogs_debug_mode==true) alert("GetPageReport mode commandant: "+ogs_ismodecommandant);

           if ( ogs_messagetype == 'spyreport_onpopup') { // commun compte simple et commandant
              if (ogs_debug_mode==true) alert("rapport espio surgissant dtect!");
              messageElements = OGPlugin_GetSpyReportOnPopup();

              // filtrage des points de nombre
              if (OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, '')==true)
              messageElements = OGPlugin_FilterNumberPoints(messageElements);

           } else
           {
                messageElements = OGPlugin_GetMessagesText(OGPlugin_TrigDoc); // contenu test :

                if(ogs_getreportsdebug_mode) alert("OGPlugin_GetOgamePageReport, messageElements:\n"+messageElements);

                // filtrage des points de nombre
                if (OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, '')==true)
                messageElements = OGPlugin_FilterNumberPoints(messageElements);
                  
                if (ogs_getreportsdebug_mode==true) alert(ogs_messagetype+":\n"+messageElements);
           }
           // messageElements=OGPlugin_SpyReportFilter(messageElements);
           if (ogs_debug_mode==true) alert("retour messageElements("+ogs_ismodecommandant+")\n"+messageElements);
           if (messageElements.length>10)
              OGPlugin_result = OGPlugin_sendText(SendButtonActionCmd,messageElements,OGPlugin_TrigDoc.location.href);
           else OGPlugin_SetStatusViewLabel("nothingdone", ogs_gameprefixmsg+OGPlugin_GetLocString("reportsfound")+" - Aucun message \u00e0 capturer!");

    } else if (SendButtonActionCmd=="buildings") {

           var messageElements =  OGPlugin_HTMLTabletoText(OGPlugin_TrigDoc.getElementsByTagName("table")[OGPlugin_getIntPref('OGPlugin.settings.buildingpagetablerank', ogs_BuildingPageRankTab, '')]);

          // filtrage des points de nombre
          if (OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, '')==true)
            messageElements = OGPlugin_FilterNumberPoints(messageElements);


           if (ogs_planetpagesdebug_mode==true) alert(messageElements);
           if (messageElements!=false)
               OGPlugin_result = OGPlugin_sendText(SendButtonActionCmd,messageElements,OGPlugin_TrigDoc.location.href);
           else OGPlugin_SetStatusViewLabel("failure", ogs_gameprefixmsg+"Erreur: la zone de capture cibl\u00e9e n'a pas les propri\u00e9t\u00e9s requises(batiments)!");

    } else if (SendButtonActionCmd=="resources") {

          var messageElements = OGPlugin_GetResourceDataTextSel(OGPlugin_TrigDoc);

          // filtrage des points de nombre
          if (OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, '')==true)
          messageElements = OGPlugin_FilterNumberPoints(messageElements);


          if (messageElements!='error')
              OGPlugin_result = OGPlugin_sendText(SendButtonActionCmd,messageElements,OGPlugin_TrigDoc.location.href);
          else OGPlugin_SetStatusViewLabel("failure", ogs_gameprefixmsg+"Erreur lors de la capture de la page ressources!");

    } else if (SendButtonActionCmd=="technos") {

           //var messageElements = OGPlugin_TrigDoc.getElementsByTagName("table")[5].innerHTML; //  revoir

           messageElementsHTML = OGPlugin_TrigDoc.getElementsByTagName("table")[OGPlugin_getIntPref('OGPlugin.settings.technopagetablerank', ogs_TechnoPageRankTab, '')];


           // filtrage du javascript captur pour les recherches en cours -> dplac dans OGPlugin_HTMLTabletoText
          //messageElementsHTML.innerHTML = OGPlugin_RemoveJavaScriptTags(messageElementsHTML.innerHTML);

           //alert(messageElementsHTML.innerHTML);

           var messageElements =  OGPlugin_HTMLTabletoText(messageElementsHTML, true);
           //var messageElementsHTMLContent =  OGPlugin_HTMLTagstoText(messageElementsHTMLContent);
           /* alert(messageElementsHTML.innerHTML);
           alert(messageElements); */


           // filtrer les messages de rechercher en cours
           if (OGPlugin_getBoolPref('OGPlugin.settings.filtertechnoprogress', true, 'OGPlugin-filtertechnoprogress')==true)
              messageElements = OGPlugin_TechnoInProgressFilterLabels(messageElements);

           // filtrage des incrments officier, aprs tranformation html en texte
           if (OGPlugin_getBoolPref('OGPlugin.settings.filtermissiblenumber', true, 'OGPlugin-filtermissiblenumber')==true)
              messageElements = OGPlugin_FilterTechnoOfficer(messageElements);

           // filtrage des points de nombre
           if (OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, '')==true)
              messageElements = OGPlugin_FilterNumberPoints(messageElements);

           if (messageElements!=false)
               OGPlugin_result = OGPlugin_sendText(SendButtonActionCmd,messageElements,OGPlugin_TrigDoc.location.href);
           else OGPlugin_SetStatusViewLabel("failure", "Erreur: la zone de capture cibl\u00e9e n'a pas les propri\u00e9t\u00e9s requises(laboratoire)!");

    } else if (SendButtonActionCmd=="shipyard") {

           var messageElements =  OGPlugin_HTMLTabletoText(OGPlugin_TrigDoc.getElementsByTagName("table")[ogs_ShipyardPageRankTab]);

          // filtrage des points de nombre
          if (OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, '')==true)
          messageElements = OGPlugin_FilterNumberPoints(messageElements);

           if (messageElements!=false)
               OGPlugin_result = OGPlugin_sendText(SendButtonActionCmd,messageElements,OGPlugin_TrigDoc.location.href);
           else OGPlugin_SetStatusViewLabel("failure", ogs_gameprefixmsg+"Erreur: la zone de capture cibl\u00e9e n'a pas les propri\u00e9t\u00e9s requises(chantier spatial)!");

    } else if (SendButtonActionCmd=="flotten") {

          var messageElements = OGPlugin_GetFleetDataTextSel(OGPlugin_TrigDoc);

          // filtrage des points de nombre
          if (OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, '')==true)
          messageElements = OGPlugin_FilterNumberPoints(messageElements);


          if (messageElements!='error')
              OGPlugin_result = OGPlugin_sendText(SendButtonActionCmd,messageElements,OGPlugin_TrigDoc.location.href);
          else OGPlugin_SetStatusViewLabel("failure", ogs_gameprefixmsg+"Erreur lors de la capture de la composition de flotte \u00e0 quai!");

    } else if (SendButtonActionCmd=="defence") {

           //var messageElements = OGPlugin_TrigDoc.getElementsByTagName("table")[5].innerHTML; //  revoir
           var messageElements =  OGPlugin_HTMLTabletoText(OGPlugin_TrigDoc.getElementsByTagName("table")[OGPlugin_getIntPref('OGPlugin.settings.defencepagetablerank', ogs_defencePageRankTab, '')]);

          // filtrage des points de nombre
          if (OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, '')==true)
              messageElements = OGPlugin_FilterNumberPoints(messageElements);

          // filtrage supplmentaire pour la page dfense
          messageElements = OGPlugin_DefenceFilterPage(messageElements);

           if (messageElements!=false)
               OGPlugin_result = OGPlugin_sendText(SendButtonActionCmd,messageElements,OGPlugin_TrigDoc.location.href);
           else OGPlugin_SetStatusViewLabel("failure", ogs_gameprefixmsg+"Erreur: la zone de capture cibl\u00e9e n'a pas les propri\u00e9t\u00e9s requises(d\u00e9fense)!");

    } else if (SendButtonActionCmd=="combreports") {

           //var messageElements = OGPlugin_TrigDoc.getElementsByTagName("table")[1].innerHTML; //  revoir
           var messageElements = OGPlugin_GetCombatReportsTextSel(OGPlugin_TrigDoc);

          // filtrage des points de nombre
          if (OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, '')==true)
          messageElements = OGPlugin_FilterNumberPoints(messageElements);

           if (messageElements!='error')
              OGPlugin_result = OGPlugin_sendText(SendButtonActionCmd,messageElements,OGPlugin_TrigDoc.location.href);
           else OGPlugin_SetStatusViewLabel("failure", ogs_gameprefixmsg+"Erreur lors de la capture du rapport de combat!");

    } else if (SendButtonActionCmd=="planetempire") {
           //var messageElements = OGPlugin_TrigDoc.getElementsByTagName("table")[0].innerHTML; //  revoir
           //var messageElements =  OGPlugin_HTMLTabletoText(OGPlugin_TrigDoc.getElementsByTagName("table")[OGPlugin_getIntPref('OGPlugin.settings.planempiretablerank', ogs_PlanetEmpireRankTab, '')]);
           //capture texte
           var messageElements = OGPlugin_GetEmpireDataTextSel(OGPlugin_TrigDoc);

            // filtrage des points de nombre
            if (OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, '')==true)
            messageElements = OGPlugin_FilterNumberPoints(messageElements);


           if (messageElements!=false)
               OGPlugin_result = OGPlugin_sendText(SendButtonActionCmd,messageElements,OGPlugin_TrigDoc.location.href);
           else OGPlugin_SetStatusViewLabel("failure", ogs_gameprefixmsg+"Erreur: la zone de capture cibl\u00e9e n'a pas les propri\u00e9t\u00e9s requises(empire planetes)!");

    }  else if (SendButtonActionCmd=="moonempire") {

          //var messageElements = OGPlugin_TrigDoc.getElementsByTagName("table")[0].innerHTML; //  revoir
          var messageElements =  OGPlugin_HTMLTabletoText(OGPlugin_TrigDoc.getElementsByTagName("table")[OGPlugin_getIntPref('OGPlugin.settings.moonempiretablerank', ogs_MoonEmpireRankTab, '')]);

          // filtrage des points de nombre
          if (OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, '')==true)
          messageElements = OGPlugin_FilterNumberPoints(messageElements);


           if (messageElements!=false)
               OGPlugin_result = OGPlugin_sendText(SendButtonActionCmd,messageElements,OGPlugin_TrigDoc.location.href);
           else OGPlugin_SetStatusViewLabel("failure", ogs_gameprefixmsg+"Erreur: la zone de capture cibl\u00e9e n'a pas les propri\u00e9t\u00e9s requises(empire luhes)!");

    }  else if (SendButtonActionCmd=="overview") {

           var messageElements = OGPlugin_GetPlanetDetails(OGPlugin_TrigDoc);



           if (messageElements!=false)
               OGPlugin_result = OGPlugin_sendText('planetdetails',messageElements,OGPlugin_TrigDoc.location.href);
           else OGPlugin_SetStatusViewLabel("failure", ogs_gameprefixmsg+"Erreur: la zone de capture cibl\u00e9e n'a pas les propri\u00e9t\u00e9s requises: vue generale!");
    }
    OGPlugin_SetSendButtonLabel('', false);

    if (ogs_planetpagesdebug_mode==true) alert('Filtrage des points:\n'+messageElements);

}



/**
 * Capture des rapports d'espionnage par analyse et consignation de donnes HTml
 * @param parTargetDoc est une rfrence sur le document actif ayant gnr onload
 * @return une tableau html compos des rapports d'espionnage correspondant capturs
 **/
function OGPlugin_GetSpyReportsHTML(parTargetDoc) { // "text" / "html" (<=)
// prvoir recherche adresses pubs pour dcalage indice de table: eg http://ads.gameforgeads.de/adframe

    //***************
    if (parTargetDoc==null) OGPlugin_SetStatusViewLabel("failure", "OGPlugin_GetSpyReportsHTML: parTargetDoc n'est pas initialis\u00e9e");

    if (ogs_ismodecommandant==true) {
        var targettable = parTargetDoc.getElementsByTagName('table')[OGPlugin_getIntPref('OGPlugin.settings.messagestablerank', ogs_CmdMsgPageRankTab, '')+1];
        var start_row=0;
    }
    else { // cas compte simple
        // compte simple, 2e table du formulaire
        // dtection pub pour prise en compte dcalage
        /* if (OGPlugin_TrigDoc.getElementsByTagName('tbody')[2].innerHTML.search("http://ads.gameforgeads.de/adframe")>-1)
            var targettable = OGPlugin_TrigDoc.getElementsByTagName('tbody')[2];
        else */ var targettable = parTargetDoc.getElementsByTagName('tbody')[OGPlugin_getIntPref('OGPlugin.settings.messagestablerank', ogs_MsgPageRankTab, '')]; // si pas pub Ogame 0.76: [5]->[6]
        var start_row=0;
    }

    // si pas de proprits pour la table, loguer mauvais ciblage de table dans le journal et quitter
    if (targettable.length==0) alert("Table message n'a pas de proprit!");
    var rows = targettable.rows;

    var cells;
    var lcpt;
    var nom_case_a_cocher='';
    var case_a_tester;
    var spyreports_html=""; // tous les rapports de la page
    var spyreport_html=""; // un rapport

    //var numiter=OGPlugin_TrigDoc.forms[0].length;

    //alert(rows.length+" lignes");
    for (cpt=0;cpt<rows.length;cpt++) {
         cells = rows[cpt].cells;
         spyreport_found = false;
         if (cells.length==2 && rows[cpt-1].cells.length>=4)
         {
            // const RegExpSpyHeader dfinie en dbut de fichier
            // const RegExpEnemySpyHeader dfinie en dbut de fichier

            // reconstruction de la cellule avec balisage html
            // tre sr qu'on a bien quatre colonne
            //if (rows[cpt-1].cells.length>4)
            if (ogs_getreportsdebug_mode==true ) OGPlugin_SetStatusViewLabel("notify", "nombre colonnes: "+rows[cpt-1].cells.length);
                spyreport_html =  "<tr><th>"+rows[cpt-1].cells[1].innerHTML+"</th>\n<th>"+rows[cpt-1].cells[2].innerHTML+"</th>\n<th><span class=\"espionagereport\">"+rows[cpt-1].cells[3].innerHTML+"</tr>\n<tr>\n<td class=\"b\"> </td><td colspan=\"3\" class=\"b\">"+cells[1].innerHTML+"</td>\n</tr>"; // 2e colonne

            // option capture rapports d'espionnage enemi? et dtection d'un tel rapport
            if (OGPlugin_getBoolPref('OGPlugin.settings.handlespyreports', false, '')==true && spyreport_html.search(RegExpSpyHeader)>-1)
            {
                spyreport_found = true;

                //FILTRAGE RESSOURCES
                if (OGPlugin_getBoolPref('OGPlugin.settings.filterspyreportressource', false, '')==true)
                {
                   var ressource_pattern = /<tr><td>M.{1,2}tal\:<\/td><td>\d+<\/td>\n<td>Cristal\:<\/td><td>\d+<\/td><\/tr>\n<tr><td>Deut.{1,2}rium\:<\/td><td>\d+<\/td>\n<td>Energie\:<\/td><td>\d+<\/td><\/tr>/g;
                   spyreport_html = spyreport_html.replace(ressource_pattern, "<tr><td>M\u00e9tal:</td><td>0</td>\n<td>Cristal:</td><td>0</td></tr>\n<tr><td>Deut\u00e9rium:</td><td>0</td>\n<td>Energie:</td><td>0</td></tr>");
                }
                //FILTRAGE FLOTTE
                if (OGPlugin_getBoolPref('OGPlugin.settings.filterspyreportfleet', false, '')==true)
                {
                   // expr ci-aprs fonctionne
                   var fleet_pattern = /<table\s+width="400"><tbody><tr><td\s+class="c"\s+colspan="4">Flotte\s{1,15}<\/td><\/tr>\n(\n?<tr><td>.*<\/td><td>\d*<\/td>\n?<td>.*<\/td><td>\d*<\/td>\n?<\/tr>){0,10}<\/tbody><\/table>/;

                  contenu_flotte=spyreport_html.match(fleet_pattern);

                 if (ogs_getreportsdebug_mode==true ) OGPlugin_SetStatusViewLabel("notify", spyreport_html);
                 //if (ogs_getreportsdebug_mode==true ) alert(spyreport_html+"\n");

                 if (contenu_flotte) spyreport_html = spyreport_html.replace(contenu_flotte[0], '');
                 else if (ogs_getreportsdebug_mode==true ) OGPlugin_SetStatusViewLabel("notify", "pas trouv!\n");
                 if (ogs_getreportsdebug_mode==true ) alert(spyreport_html);
                }

            } else
              // option capture rapports d'espionnage enemi? et dtection d'un tel rapport
              if (OGPlugin_getBoolPref('OGPlugin.settings.handleenemyspy', false, '')==true && spyreport_html.search(RegExpEnemySpyHeader)>-1) {
                      spyreport_found = true;
            }


         }
          // formattage commun pour rapport d'espionnage et espionnage enemi
          if (spyreport_found==true) {
              // sparateur rapports d'espionnages dans ogsplugin.php : "<td colspan=\"3\" class=\"b\">"
              // $reportarray = explode("<td colspan=\"3\" class=\"b\">",$reportstring);
              //if (spyreport_found==true) alert(spyreport_html);
              if (spyreports_html.length==0)
                  spyreports_html = spyreport_html;

              // sparateur prsent dans la 1.0.975: "\n<td colspan=\"3\" class=\"b\">\n"
              else spyreports_html += "\n"+ogsseparateur_rapports+"\n"+spyreport_html;
              if (ogs_getreportsdebug_mode==true) alert("Rapports d'espionnage: \n"+spyreport_html);
          }

    }
    return spyreports_html;
}





// rcupre le rapport de combat du popup ouvert depuis la page messages
function OGPlugin_GetSpyReportOnPopup() { // "text" / "html" (<=)

    //***************

    var targettable_content = OGPlugin_TrigDoc.getElementsByTagName('table')[0].innerHTML;
    return  targettable_content;
}

// compte commandant rcupre messages section autres messgaes: recyclage, retour de flotte, etc...
function OGPlugin_GetOtherMessages(parTargetDoc) { // "text" / "html" (<=) // corrig pour Ogame 0.76
// prvoir recherche adresses pubs pour dcalage indice de table: eg http://ads.gameforgeads.de/adframe

    //***************
    if (parTargetDoc==null) OGPlugin_SetStatusViewLabel("failure", "OGPlugin_GetOtherMessages: parTargetDoc n'est pas initialis\u00e9");

    if (ogs_ismodecommandant==true) {
        var targettable = parTargetDoc.getElementsByTagName('tbody')[OGPlugin_getIntPref('OGPlugin.settings.messagestablerank', ogs_CmdMsgPageRankTab, '')]; // 0.76 6->7
        var start_row=0;
    }
    else { // cas compte simple
        // compte simple, 2e table du formulaire
        // dtection pub pour prise en compte dcalage
        /* if (OGPlugin_TrigDoc.getElementsByTagName('tbody')[2].innerHTML.search("http://ads.gameforgeads.de/adframe")>-1)
            var targettable = OGPlugin_TrigDoc.getElementsByTagName('tbody')[2];
        else */ var targettable = parTargetDoc.getElementsByTagName('tbody')[OGPlugin_getIntPref('OGPlugin.settings.messagestablerank', ogs_MsgPageRankTab, '')]; // si pas pub // 0.76 5->6
        var start_row=0;

    }

    // si pas de proprits pour la table, loguer mauvais ciblage de table dans le journal et quitter
    if (targettable.length==0) alert("Table message n'a pas de proprit!");
    var rows = targettable.rows;

    if (ogs_getreportsdebug_mode==true) alert("Entre dans OGPlugin_GetOtherMessages\n"+rows.length+"\n"+targettable.innerHTML);

    var cells;
    var lcpt;
    var nom_case_a_cocher='';
    var case_a_tester;
    var othermessages_html=""; // tous les rapports de la page
    var othermessage_html=""; // un rapport

    //var numiter=OGPlugin_TrigDoc.forms[0].length;

    //alert(rows.length+" lignes");
    for (cpt=start_row;cpt<rows.length;cpt++) {
         cells = rows[cpt].cells;
         othermessage_found = false;
         if (cells.length==2 && rows[cpt-1].cells.length>=4)
         {
            // const RegExpChpDebris dfini en dbut de fichier


            // reconstruction de la cellule avec balisage html
            othermessage_html =  "<tr><th>"+rows[cpt-1].cells[1].innerHTML+"</th>\n<th>"+rows[cpt-1].cells[2].innerHTML+"</th>\n<th><span class=\"espionagereport\">"+rows[cpt-1].cells[3].innerHTML+"</tr>\n<tr>\n<td class=\"b\"> </td><td colspan=\"3\" class=\"b\">"+cells[1].innerHTML+"</td>\n</tr>"; // 2e colonne

            if (ogs_getreportsdebug_mode==true) alert("ligne "+cpt+"\n"+othermessage_html);

            // option capture rapports d'espionnage enemi? et dtection d'un tel rapport
            if (OGPlugin_getBoolPref('OGPlugin.settings.handlerecyreports', false, '')==true &&  othermessage_html.search(RegExpChpDebris)>-1)
            {
                if (ogs_getreportsdebug_mode==true) alert("Rapport recyclage trouv!\n"+othermessage_html);
                othermessage_found = true;
            }

            // formattage commun pour rapport d'espionnage et espionnage enemi
            if (othermessage_found==true) {
                // sparateur rapports d'espionnages dans ogsplugin.php : "<td colspan=\"3\" class=\"b\">"
                // $reportarray = explode("<td colspan=\"3\" class=\"b\">",$reportstring);
                //if (othermessage_found==true) alert(othermessage_html);
                if (othermessages_html.length==0)
                    othermessages_html = othermessage_html;

                // sparateur prsent dans la 1.0.975: "\n<td colspan=\"3\" class=\"b\">\n"
                else othermessages_html += "\n"+ogsseparateur_rapports+"\n"+othermessage_html;
                //if (ogs_getreportsdebug_mode==true) alert("autre message: \n"+othermessage_html);
            }
         }

    }
    return othermessages_html;
}

/**
 * Capture les rapports choisis de la page des messages en rcuprant le texte balis html
 **/
function OGPlugin_GetMessagesHTML() { // "text" / "html" (<=) // corrig pour Ogame 0.76
    // diffrences avec GetSpyReports, GetMessages captures tous les messages gres et proposes en options
    // prvoir recherche adresses pubs pour dcalage indice de table: eg http://ads.gameforgeads.de/adframe
    //  l'heure actuelle vaut parTableRank 5 en mode simple et 6 en mode commandant


    if (ogs_ismodecommandant==true) { // a-t-on dtect un compte commandant?
        var rows = OGPlugin_TrigDoc.getElementsByTagName('table')[OGPlugin_getIntPref('OGPlugin.settings.messagestablerank', ogs_MsgPageRankTab, '')+1].rows; // Ogame 0.76 [6] -> [7]
        var start_row=0;
    }
    else {var rows = OGPlugin_TrigDoc.getElementsByTagName('tbody')[OGPlugin_getIntPref('OGPlugin.settings.messagestablerank', ogs_MsgPageRankTab, '')].rows; // 'tbody' plutt que 'table' si pubs  // Ogame 0.76 [5] -> [6]
        var start_row=0;
    }
    // }
    if (ogs_getreportsdebug_mode==true) alert(ogs_ismodecommandant+"\n"+rows.innerHTML);

    var cells;
    var lcpt;
    var nom_case_a_cocher='';
    var case_a_tester;
    var messages_html=""; // tous les rapports de la page
    var message_html=""; // un rapport
    //var numiter=OGPlugin_TrigDoc.forms[0].length;

    //alert(rows.length+" lignes");
    for (cpt=start_row;cpt<rows.length;cpt++) {
         cells = rows[cpt].cells;
         message_found = false;
         if (cells.length==2 && rows[cpt-1].cells.length>=4)
         {

            //=================PARTIE RAPPORTS D'ESPIONNAGE FAIT/SUBIT===========================
            //******************************************************************
            // const RegExpSpyHeader dfinie en dbut de fichier
            // const RegExpEnemySpyHeader dfinie en dbut de fichier
            // const RegExpChpDebris dfinie en dbut de fichier
            //******************************************************************
            message_html = "<tr><th>"+rows[cpt-1].cells[1].innerHTML+"</th>\n<th>"+rows[cpt-1].cells[2].innerHTML+"</th>\n<th><span class=\"espionagereport\">"+rows[cpt-1].cells[3].innerHTML+"</tr>\n<tr>\n<td class=\"b\"> </td><td colspan=\"3\" class=\"b\">"+cells[1].innerHTML+"</td>\n</tr>"; // 2e colonne

            if (OGPlugin_getBoolPref('OGPlugin.settings.handlespyreports', false, '')==true && message_html.search(RegExpSpyHeader)>-1) {
                message_found = true;

                //FILTRAGE RESSOURCES OK
                if (OGPlugin_getBoolPref('OGPlugin.settings.filterspyreportressource', false, '')==true)
                {
                   var ressource_pattern = /<tr><td>M.{1,2}tal\:<\/td><td>\d+<\/td>\n<td>Cristal\:<\/td><td>\d+<\/td><\/tr>\n<tr><td>Deut.{1,2}rium\:<\/td><td>\d+<\/td>\n<td>Energie\:<\/td><td>\d+<\/td><\/tr>/g;
                   message_html = message_html.replace(ressource_pattern, "<tr><td>M+tal:</td><td>0</td>\n<td>Cristal:</td><td>0</td></tr>\n<tr><td>Deut+rium:</td><td>0</td>\n<td>Energie:</td><td>0</td></tr>");
                }
                //FILTRAGE FLOTTE
                if (OGPlugin_getBoolPref('OGPlugin.settings.filterspyreportfleet', false, '')==true)
                {
                   // expr ci-aprs fonctionne
                   var fleet_pattern = /<table\s+width="400"><tbody><tr><td\s+class="c"\s+colspan="4">Flotte\s{1,15}<\/td><\/tr>\n(\n?<tr><td>.*<\/td><td>\d*<\/td>\n?<td>.*<\/td><td>\d*<\/td>\n?<\/tr>){0,10}<\/tbody><\/table>/;

                   contenu_flotte=message_html.match(fleet_pattern);

                   if (ogs_getreportsdebug_mode==true ) OGPlugin_SetStatusViewLabel("notify", message_html);
                   //if (ogs_getreportsdebug_mode==true ) alert(spyreport_html+"\n");

                   if (contenu_flotte) message_html = message_html.replace(contenu_flotte[0], '');
                   else if (ogs_getreportsdebug_mode==true ) OGPlugin_SetStatusViewLabel("notify", "pas trouv!\n");
                   if (ogs_getreportsdebug_mode==true ) alert(message_html);
                }

            } // capture espionnage ennemi
            else if (OGPlugin_getBoolPref('OGPlugin.settings.handleenemyspy', false, '')==true && message_html.search(RegExpEnemySpyHeader)>-1) {
                    if (ogs_getreportsdebug_mode==true) alert("Rapports espionnage ennemi: \n"+message_html);
                      message_found = true;

            } // test prsence rapports de recyclage
             else if (OGPlugin_getBoolPref('OGPlugin.settings.handlerecyreports', false, '')==true && message_html.search(RegExpChpDebris)>-1) {
                    if (ogs_getreportsdebug_mode==true) alert("Rapports recyclage: \n"+message_html);
                      message_found = true;

            }
            //======FIN TRAITEMENT RAPPORTS D'ESPIONNAGE=======================================================================
         }


         //==========================COMMUN TOUT TYPE DE MESSAGE =============================================
         // ajout sparateur message si message  traiter dtect
        // sparateur rapports d'espionnages dans ogsplugin.php : "<td colspan=\"3\" class=\"b\">"
        // $reportarray = explode("<td colspan=\"3\" class=\"b\">",$reportstring);
        //if (spyreport_found==true) alert(spyreport_html);
         if (message_found==true) {
             if (messages_html.length==0)
                 messages_html = message_html;
             // sparateur 1.0.975: "\n<td colspan=\"3\" class=\"b\">\n"
             // prochain: <|-|-|>
             else messages_html += "\n"+ogsseparateur_rapports+"\n"+message_html;
         }
         //OGPlugin_SetStatusViewLabel("notify", "Ligne "+cpt+" : "+cells.length+" colonnes - "+spyreport_found);
    }
    return messages_html;
}



// Capture les infos suppl de la vue gnrale plante
function OGPlugin_GetPlanetDetails(parTargetDoc) {

    if (parTargetDoc==null) alert('erreur entree parTargetDoc: null');

      // rprage objet tableau flotte html par TAG et proprit largeur 519
	    var pathtofleetvoyaging = '//table[@width="519"]';
      var obj = OGPlugin_EvalNode(pathtofleetvoyaging,parTargetDoc);
		  if (obj.snapshotLength == 0) return false;

      var Selection = window.getSelection();
      if (Selection==null) {
          return "error";
      }
			if(Selection.rangeCount > 0) Selection.removeAllRanges();

		  var range = parTargetDoc.createRange();
	    range.selectNode(obj.snapshotItem(0));
			Selection.addRange(range);


      var text_tab = new Array(); // moon/planet | name | coords | diam | max temp | curr fields | max fields
      //--------------------------
			var data = Selection.toString();

			//alert('donnes:\n'+data);

      const colotypepattern = /(?![\s\t\n])([\w]+)\s\x22([\w,,,,,]+)\x22(?:\sen\sorbite\sde\s\[(\d{0,3}:\d{0,3}:\d{0,3})?\])?\s\((\w+)\)/i;
      colotype_tab = data.match(colotypepattern);
      if (colotype_tab!=null) {
          text_tab[0] = (colotype_tab[1]=='Lune' ? 'moon':'planet');
          text_tab[1] = colotype_tab[2];
          //alert(colotype_tab.join('/'));
      }

      // capture coordonnes plante
      const coordpattern = /(\S[\w\d\s]+\S)\s(\(\w+\))?\s?\[(\d:\d{1,3}:\d{1,2})\]/;
      coordplanet = PlanetNameWithCoords.match(coordpattern);
      if (coordplanet!=null) text_tab[2]= coordplanet[3]; // coordonnes lune/plante

      const temppattern = /Temp.rature[\s\t]+env\.\s\-?\d+.C\s.\s(\-?\d+)\s.C/i;
      planettemp = data.match(temppattern);
      if (planettemp!=null) {
          text_tab[4]=planettemp[1];

      }

      const detailspattern = /Diam.tre[\s\t]+([\d,\.]+)\skm\s\(\s(\d+)\s\/\s(\d+)\scases\s\)/i;
      planetdetails = data.match(detailspattern);
      if (planetdetails!=null) {
         text_tab[3]=planetdetails[1].replace('.','');
         text_tab[5]=planetdetails[2];
         text_tab[6]=planetdetails[3];

      }
			//alert(text_tab.join('|'));
			return text_tab.join('|');
}

/**
 * dtecter la prsence de messages pris en charge sur la page (targetdoc)
 * manque paramtre table cible suivant cas compte simple/commandant.
 **/
function OGPlugin_DetectHandledMessages (targetdoc, commandant_mode) { // corrig pour Ogame 0.76
            var handled_messages_found=false;
            //  voir: retourner une constante combinant divers constante correspondant
            //  une catgorie de message

            //******************************************************************
            // const RegExpSpyHeader dfinie en dbut de fichier
            // const RegExpEnemySpyHeader dfinie en dbut de fichier
            // const RegExpChpDebris dfinie en dbut de fichier
            //******************************************************************
            if (commandant_mode==false)
                var message_page_html = targetdoc.getElementsByTagName('table')[OGPlugin_getIntPref('OGPlugin.settings.messagestablerank', ogs_MsgPageRankTab, '')].innerHTML; // Ogame 0.76 5->6
            else  var message_page_html = targetdoc.getElementsByTagName('table')[OGPlugin_getIntPref('OGPlugin.settings.messagestablerank', ogs_CmdMsgPageRankTab, '')].innerHTML; // Ogame 0.76 6->7
            //
            if (ogs_getreportsdebug_mode==true ) alert(message_page_html);
            if (message_page_html.search(RegExpSpyHeader)>-1 ||
                message_page_html.search(RegExpEnemySpyHeader)>-1 ||
                message_page_html.search(RegExpChpDebris)>-1 ) handled_messages_found=true;
            //if (message_page_html.search(RegExpEnemySpyHeader)>-1) handled_messages_found=true;
            return handled_messages_found;
}

