/*
Barre d'Outils OGSPY, extension firefox d'aide aux mise  jour de serveurs OGSPY

OGSPY Toolbar, a firefox plugin for helping players in updating OGSPY servers game datas

Copyright (C) 2006 Naqdazar (ajdr@free.fr)

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
au titre des clauses de la Licence Publique Gnrale GNU, telle que publie par la
Free Software Foundation ; soit la version 2 de la Licence.
Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ;
 sans mme une garantie implicite de COMMERCIABILITE ou DE CONFORMITE A UNE UTILISATION PARTICULIERE.

 Voir la Licence Publique Gnrale GNU pour plus de dtails.

 Vous devriez avoir reu un exemplaire de la Licence Publique Gnrale GNU avec ce programme ;
  si ce n'est pas le cas, crivez  la Free Software Foundation Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

This program is free software; you can redistribute it and/or modify it under the
terms of the GNU General Public licence as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details.

You should have received a copy of the GNU General Public licence along with this program;
 if not, write to the Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/



//=========================constante d'activation dbogage par thme====================
const ogs_debug_mode = false; //  dfinir avec true pour afficher les popups intermdiaires de dbogage
const ogs_bufferingdebug_mode = false;
const ogs_getstatsdebug_mode = false;
const ogs_planetpagesdebug_mode = false;
const ogs_allyhistorydebug_mode = false;
const ogs_galaxycontentdebug_mode = false;
const ogs_defencefilterdebug_mode = false;
const ogs_sendtextdebug_mode = false;
const ogs_getreportsdebug_mode = false;
const ogs_presending_debug_mode = false;
const ogs_filterpoint_debug_mode = false;
const ogs_filtertechnoofficer_debug_mode = false;
const ogs_onresponse_debug_mode = false;
const ogs_hideonnonogamepage = false;
const ogs_frx15compat_debugmode = false;
const ogs_passwordman_debugmode = false;
const ogs_getcommand_debugmode = false; // dbogage affichage info demande/rponses commandes serveur
const ogs_ogspyforallconfig_debugmode = false; // dbogage action spciales ogspy for all
const ogs_optionpopups_debugmode = false; // debogage raction commandes popups panneau options
const ogs_euniverscapture_debugmode = false;
const ogs_sendmodedebug = false;
//====================================motifs de recherche Ogame==============================
const RegExpSpyHeader = new RegExp("Mati.res premi.res","gi"); // motif franais pour l'instant
const RegExpEnemySpyHeader = new RegExp("Une flotte ennemie de la plan.te","gi");
const RegExpChpDebris = new RegExp("sont dispers.es dans ce champ","gi"); // motif franais pour l'instant
const RegExpOgameUrl = new RegExp("http\:\/\/([a-z,A-Z,0-9,\.]+)\/game\/","");
const RegExpSessionId = new RegExp("/\?session\=[a-z,A-Z,0-9]{14,16}","g");
const UIDRegExp = /^[a-z]{10}$/i; // masque uid ogspyforall

const RegExpOgameServerCmd = /(\d+)\|([\w,\.,\-,_]+)/; // masque sparation commande serveur
const RegExpOgameServer = /^[0-2][0-5][0-9]\.[0-2][0-5][0-9]\.[0-2][0-5][0-9]\.[0-2][0-5][0-9]$|^ogame\d{3}\.de$|^s\d{3}\.gfsrv\.net|^uni\d+\.ogame\.(?:fr|org|de|es)$/i; // masque serveur ogame

const RegExpEUniversServer = /^[\w\d]+\.(e\-univers|projet42)\.org$/i; // masque serveur eunivers

const RegExpOGSPYUrl = /http\:\/\/(?:[\W\w,\-,_]+(?:\/|\.))+(?:ogsplugin|xtense_plugin)\.php/i; // masque adresse module  dtecter
const RegExpOGSPYStdUrl = /http\:\/\/(?:[\W\w,\-,_]+(?:\/|\.))+index\.php/i; // masque adresse standard  dtecter
const RegExpExtraChars = /[\&,,\x22,\x27,\(,\-,,_,,,\),\=,\^,\$,,!,\:,\,,~,#,{,\[,|,`,\\,\^,@,\],},,,%,,/,?,,\+,*]/gi;

const RegExpOgamedebris = /:[a-zA-Z&;\/<>]+([0-9\.]+)[a-zA-Z&;\/<>\s]+:[a-zA-Z&;\/<>]+([0-9\.]+)/;
const RegExpEuniversdebris = /\:\sT\s\:\s(\d+)\,\sC\s\:\s(\d+)/i;
//===================================================================================================================
const ogsseparateur_rapports='<|-|-|>'; // doit remplacer <td colspan=\"3\" class=\"b\">
//==================== CONSTANTES POUR LA FONCTION OGPlugin_DlgSendGetCommand ====================================

//================================================================================================================
// CONSTANTES OGAME - RANGS DE TABLE PERTINENTS POUR CHAQUE CATEGORIE
const ogs_FullPageRankTab = 0;
const ogs_FleetPageRankTab = 4; // Ogame 0.76
const ogs_StatsPageRankTab = 16; // Ogame 0.76
const ogs_AllyHistRankTab = 15; // Ogame 0.76
const ogs_GalaxyPageRankTab = 3; // Ogame 0.76
//=========== Autres pages ==============================================================
const ogs_ReportPageRankTab = 3; // Spy report on popup, Ogame 0.76 // non utilis
const ogs_BuildingPageRankTab = 16; // Ogame 0.76
const ogs_TechnoPageRankTab = 16; // Ogame 0.76
const ogs_ShipyardPageRankTab = 16; // Ogame 0.76
const ogs_defencePageRankTab = 16; // Ogame 0.76
const ogs_CombReportPageRankTab = 3; // Ogame 0.76 // non utilis
// ============ Pages Empire ======================================================
const ogs_PlanetEmpireRankTab = 0; // Ogame 0.76
const ogs_MoonEmpireRankTab = 0; // Ogame 0.76

const ogs_MsgPageRankTab = 6; // Ogame 0.76, rang pertinent table message, compte simple
const ogs_PopupReportRankTab = 1; // Ogame 0.76, rang pertinent popup rapport d'espionnage(commandant)
const ogs_CmdMsgPageRankTab = ogs_MsgPageRankTab+1; // rang table en mode commandant
//===============================================================================
// Chemin d'accs Dom pour les tables cibles Ogame
const ogs_PathtoFullPageTable = '//table[@width="99%"]'; // Chemin DOM pour la page entire //  tester
const ogs_PathtoCombatTable = '//table[@width="99%"]'; // Chemin DOM pour les rapports de combat
const ogs_PathtoFleetVoyaging = '//table[@width="519"]'; // Chemin Dom, page flotte
const ogs_PathtoStatsTable = '//table[@width="519"]'; // Chemin Dom, page classement gnral
const ogs_PathtoGalaxyTable = '//table[@width="569"]'; // Chemin Dom, page galaxie
const ogs_PathtoResourceTable = '//table[@width="550"]'; // Chemin Dom, page ressources
const ogs_PathtoEmpireTable = '//table[@width="750"]'; // Chemin Dom, page Empire
const ogs_PathtoMessageTable = '//table[@width="519"]'; // Chemin Dom, page Empire
const ogs_PathtoAllyHistTable = '//table[@width="519"]'; // Chemin Dom, page Historique alliance

const ogs_PathtoBuildingTable = '//table[@width="530"]'; // Chemin Dom, page btiment
const ogs_PathtoLaboTable = '//table[@width="530"]'; // Chemin Dom, page laboratoire
const ogs_PathtodefenceTable = '//table[@width="530"]'; // Chemin Dom, page dfense
//===============================================================================
const eun_StatsPageRankTab = 10; 
const eun_GalaxyPageRankTab = 11; 
const eun_MsgPageRankTab = 8; 
const eun_AllyHistRankTab = 8;
const eun_GlobalViewRankTab = 4; 
const eun_FleetPageRankTab = 4; 
const eun_TechnoPageRankTab = 4; 
const eun_DefencePageRankTab = 4; 
const eun_BuildingPageRankTab = 4;
// Chemin d'accs Dom pour les tables cibles E-Univers
const eun_PathtoFullPageTable = '//table[@width="100%"]'; // Chemin DOM pour la page entire //  tester
const eun_PathtoMessageTable = '//table[@width="530"]'; // Chemin Dom, page Message
const eun_PathtoGalaxyTable = '//table[@width="569"]'; // Chemin Dom, page galaxie
const eun_PathtoStatsTable = '//table[@width="650"]'; // Chemin Dom, page classement gnral
const eun_PathtoAllyHistTable = '//table[@width="519"]'; // Chemin Dom, page historique alliance

const eun_PathtoGlobalViewTable = '//table'; // Chemin Dom, page Vue Globale

const eun_PathtoCombatTable = '//table[@width="100%"]'; // Chemin DOM pour les rapports de combat
const eun_PathtoFleetVoyaging = '//table[@width="100%"]'; // Chemin Dom, page flotte

const eun_PathtoBuildingTable = '//table[@width="100%"]'; // Chemin Dom, page btiment //  tester
const eun_PathtoLaboTable = '//table[@width="100%"]'; // Chemin Dom, page laboratoire //  tester
const eun_PathtodefenceTable = '//table[@width="100%"]'; // Chemin Dom, page dfense //  tester

