/*
Barre d'Outils OGSPY, extension firefox d'aide aux mise  jour de serveurs OGSPY

OGSPY Toolbar, a firefox plugin for helping players in updating OGSPY servers game datas

Copyright (C) 2006 Naqdazar (ajdr@free.fr)

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
au titre des clauses de la Licence Publique Gnrale GNU, telle que publie par la
Free Software Foundation ; soit la version 2 de la Licence.
Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ;
 sans mme une garantie implicite de COMMERCIABILITE ou DE CONFORMITE A UNE UTILISATION PARTICULIERE. 
 
 Voir la Licence Publique Gnrale GNU pour plus de dtails. 
 
 Vous devriez avoir reu un exemplaire de la Licence Publique Gnrale GNU avec ce programme ;
  si ce n'est pas le cas, crivez  la Free Software Foundation Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

This program is free software; you can redistribute it and/or modify it under the
terms of the GNU General Public licence as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details.

You should have received a copy of the GNU General Public licence along with this program;
 if not, write to the Free Software Foundation, Inc., 
 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

// cacher l'onglet Analyse
const ogs_hideanalysistab =  false;
const ogs_accounttab_pos = 1;
const ogs_highlightingtab_pos = 7;

var serverurlchanged = new Array(false, false, false, false, false, false, false); // _7 lments
var passwordchangedtab = new Array(false, false, false, false, false, false, false); // _7 lments
// tableau boolens, case  cocher a chang d'tat?
var pwdcryptoptchangedtab = new Array(false, false, false, false, false, false, false); // _7 lments
var ogs_numuniv_tab = new Array(0, 0, 0, 0, 0, 0, 0); // tableau temporaire stockant les no d'univers, 7 lements
var ogs_playernicks_tab = new Array(null, null, null, null, null, null, null); // tableau temporaire stockant les pseudos Ogame, 7 lements
var testurlserver = "";
var testnumserverurl = -1;
var currentserveridopts = 0;
var keypress_buffer = new Array(0,0,0,0,0,0,0)

// variables globales pour les popups
var ogs_ogameurl_id = 0; // dfinie pour rprer l'id d'appel du popup(ligne 1  7)
var ogs_ogspyurl_id = 0;

var ogs_changingaccountstate = false;
var ogs_highlightingtab_set = false; // indique si les botes couleur ont t remplies
var ogs_firsttime_accountset = true; // indique dtection deux premire lignes de compte vierges: 1ere install?
var ogs_testfoxgameoptions = true; // test options foxgame au dmarrage

//------------------------------------------------------------------------------

function OGPlugin_InitOptionsWindow() {
    var DateStart = new Date(); 
    var starttime = DateStart.getTime();
    
    var prefs = OGPlugin_getPrefs();
    
    var dohide_tabhightlighting = !OGPlugin_getBoolPref('OGPlugin.settings.enablehighlighting', false, '');
    
    // si gestion surbrillance pas dsactive
    if (dohide_tabhightlighting==false) {
        // OGPlugin_InitColorComboBoxes();
    } else OGPlugin_HideHighlightingTab(dohide_tabhightlighting); // prend en charge OGPlugin_InitColorComboBoxes


    // cacher onglet analyse - exprimental
    OGPlugin_HideAnalysisTab(ogs_hideanalysistab);
    
    // si firefox 1.5, cacher dsactiver l'option autohide
    browserversion = OGPlugin_GetFirefoxVersion();
    if (browserversion[0]=='1') {
        var autohidecontrol = document.getElementById("OGPlugin-autohide");
        autohidecontrol.setAttribute("disabled", "true");
    }
    
    // chargement des proprits et rglage des contrles
    OGPlugin_LoadOptsValues();
    
    // Dtermination des options  afficher et "mise en page"
    OGPlugin_AllowOptionsOnShow();
    
    // Premier affichage Options, affichage onglet comptes
    if (!prefs.prefHasUserValue("OGPlugin.settings.url1")) {
        //  alert('first account');
        document.getElementById('OGPlugin-tabbox_options').selectedIndex = 1;
    }
    
    /* Si deux premires adresses url plugin non renseignes, proposer de commencer
     paramtrer en en saisissant une */
    //if ( OGPlugin_getCharPref("OGPlugin.settings.url"+1, '', "") == '' && OGPlugin_getCharPref("OGPlugin.settings.url"+2, '', "") == '')
     //   alert("Si c'est votre premi\u00e8re cr\u00e9ation de compte, veuillez commencer par entrer\nune adresse(url) de plugin afin d'engager l'assistant de param\u00e9trage.")

    // Chronomtrage du temps d'affichage du panneau options
    var DateEnd = new Date();
    var timebeforeshow = DateEnd.getTime()-starttime;
    var oldgroupboxcaption=document.getElementById("dialogGBcaption").label;
    document.getElementById("dialogGBcaption").label = oldgroupboxcaption+" ("+OGPlugin_GetLocString("optdlg.dlgloadedin")+timebeforeshow*4/1000+" secs)";
        
}

function OGPlugin_ChangeDialogTitle(NewTitle) //  revoir
{   // ne fonctionne psa, impossible de changer proprit fentre pendant venement
     var optiondialogwin=document.getElementById("OGPlugin-config");
     window.setTimeout(setNewTitle, 100);
        
     function setNewTitle()
     {
      optiondialogwin.title = NewTitle;
     }
}

function OGPlugin_CloseOptionsWindow()
{
  var oldgroupboxcaption=document.getElementById("dialogGBcaption").title;
  document.getElementById("dialogGBcaption").label = " fermeture en cours...";

  //OGPlugin_ChangeDialogTitle("fermeture"); */
  
  var resultsavevalues = OGPlugin_SaveOptsValues();
  if (resultsavevalues==1) return resultsavevalues;  
}

/**
 * Mthode vnement du bouton Annuler du panneau Options
 **/
function OGPlugin_Cancel() {
    //alert("cancel");
    window.close();
}

/**
 * Commande l'affichage de l'onglet about:config au retour sur la fentre
 * principale Firefox et quitte le panneau Options
 **/
function  OGPlugin_OpenAboutConfigTab() {
    if (confirm("Afficher les prori\u00e9t\u00e9s de FireSpy et de Firefox et quitter sans sauvegarder:\n\nConfirmer par OK pour quitter le panneau des Options et afficher dans un nouvel onglet les propri\u00e9t\u00e9s de firefox."+"\nIl suffira de R\u00e9initialiser les propri\u00e9t\u00e9s pr\u00e9fix\u00e9es par OGPlugin")) {
        opener.ogs_askforshowallfrxproperties = true; // mis  vrai depuis le patron xul
        OGPlugin_Cancel();
    }
}

/**
 * Rnitialise toutes les proprits de FireSpy
 **/
function  OGPlugin_ResetFireSpyPrefs() {
    if (confirm("R\u00e9initialiser les prori\u00e9t\u00e9s de l'extension et quitter sans sauvegarder?\n"+
       "Toutes les valeurs actuelles de Firespy seront supprim\u00e9es\npuis r\u00e9enregistr\u00e9es avec des valeurs par d\u00e9faut.")) {
        var prefs = OGPlugin_getPrefs();
        if (prefs.prefHasUserValue("OGPlugin.settings.autostarten")) // test sinon exception
            prefs.deleteBranch('OGPlugin');
        
        // Mthode resetBranch non implmente!!
        /* if (prefs.prefHasUserValue("OGPlugin.settings.autostarten")) // test sinon exception
            prefs.resetBranch('OGPlugin'); */
        OGPlugin_SetAutoConfigOptions(0); // maj surbrillance dsactive
        OGPlugin_SaveOptsValues();
        OGPlugin_Cancel();
    }
}

/**
 * Supprime toutes les proprits de FireSpy
 **/
function  OGPlugin_DeleteFireSpyPrefs() {
    if (confirm("Supprimer les prori\u00e9t\u00e9s de l'extension et quitter sans sauvegarder?\nL'effacement est irr\u00e9versible! Veuillez les copier pour r\u00e9f\u00e9rence ult\u00e9rieure.")) {
        var prefs = OGPlugin_getPrefs();
        if (prefs.prefHasUserValue("OGPlugin.settings.autostarten")) // test sinon exception
            prefs.deleteBranch('OGPlugin');
        OGPlugin_Cancel();
    }
}

/**
 * Mthode venement : Affiche toutes les proprits de FireSpy
 **/
function  OGPlugin_PrintFireSpyPrefs() {
    if (confirm("Afficher les prori\u00e9t\u00e9s de l'extension et quitter sans sauvegarder?")) {
        opener.ogs_doprintfirespyprefs = true;
        OGPlugin_Cancel();
    }
}



/* dtermine d'aprs les urls les options  afficher ou pas
   ex: xtense -> pas e cryptage */
function OGPlugin_AllowOptionsOnShow () {

          for (cpt=1; cpt<=7; cpt++) {
          
              callingurl = OGPlugin_getCharPref("OGPlugin.settings.url"+cpt , '' ,'');
              logameserver = OGPlugin_getCharPref("OGPlugin.settings.ogameurl"+cpt , '' ,'');

              if (logameserver.match(RegExpExtraChars)!=null) laccountdeact = '(X)'; // si compte "dsactiv"(prsence de car non alpha)
              else laccountdeact = '';

              // dtection d'un code UID OGS for All
              var is_ofa_uid = (callingurl.length==10 && (
                               callingurl.match(UIDRegExp)!=null
                               || OGPlugin_IsNCSStringEquals(callingurl.substr(0,24) , 'http://www.ogsforall.com')
                               || OGPlugin_IsNCSStringEquals(callingurl.substr(0,20) , 'http://ogsforall.com')));

              if (is_ofa_uid) {
                  document.getElementById("OGPlugin-ogspyforall"+cpt).value = "OGS for All: U"+OGPlugin_getIntPref("OGPlugin.settings.ofanumuniv"+cpt , 0 ,'')+laccountdeact;
                  OGPlugin_HideOgameParControls(cpt, true, false);
              
              } else {
                if (callingurl.search(/^.+?xtense_plugin\d?\.php$/)>-1) { // cas XTense
                    document.getElementById("OGPlugin-iscryptedpass"+cpt).checked = false;
                    document.getElementById("OGPlugin-iscryptedpass"+cpt).setAttribute("disabled", true);
                }

                if(logameserver!='' && callingurl!='') {
                        lnumuniv = OGPlugin_getIntPref("OGPlugin.settings.ofanumuniv"+cpt , 0 ,'');
                        if (lnumuniv>0) {

                            document.getElementById("OGPlugin-ogspyforall"+cpt).value = "Univers: "+lnumuniv+laccountdeact;
                            OGPlugin_HideOgameParControls(cpt, true, false);
                        }
                }
              }

             /* if (OGPlugin_TrimString(callingurl)=="" &&
              !(callingurl.search(/^.+?ogsplugin\d?\.php$/)>-1
              || callingurl.search(/^.+?xtense_plugin\d?\.php$/)>-1)) { */
              
          }
}

// rglage automatique par sauvegarde des options pertinentes par rang serveur
// options par serveur
function OGPlugin_SaveAutoConfigOptions (parnumline) {

          // Activation des options de surbrillance serveur par dfaut
          OGPlugin_setBoolPref('OGPlugin.settings.brightogspyfriendlyally'+parnumline, true, '');
          OGPlugin_setBoolPref('OGPlugin.settings.brightogspypnaally'+parnumline, true, '');
          OGPlugin_setBoolPref('OGPlugin.settings.brightogspyenemyally'+parnumline, true, '');
          OGPlugin_setBoolPref('OGPlugin.settings.brightogspytradingally'+parnumline, true, '');
}

// rglage automatique par positionnement des options pertinentes par rang serveur, eg cocher/dcocher les cases sans sauvegarde
// options gnrales
function OGPlugin_SetAutoConfigOptions (paraccountrank) {
          // Onglet Gnral
          document.getElementById("OGPlugin-autostart").checked = true;
          document.getElementById("OGPlugin-checkupdtonstart").checked = true;
          document.getElementById("OGPlugin-checkdiplomatyonstart").checked = true;
          document.getElementById("OGPlugin-autoshowfgoptions").checked = true;
          document.getElementById("OGPlugin-autohide").checked = false;
          
          // Onglet Compte
          document.getElementById("OGPlugin-multisserversend").checked = true;
          
          // Onglet Pages
          document.getElementById("OGPlugin-handlegalaxyviews").checked = true;
          document.getElementById("OGPlugin-handlegeneralstats").checked = true;
          document.getElementById("OGPlugin-handleallystats").checked = true;
          
          document.getElementById("OGPlugin-autosendbuildingpage").checked = true;
          document.getElementById("OGPlugin-autosendoverviewpage").checked = true;
          document.getElementById("OGPlugin-autosendresourcespage").checked = true;
          document.getElementById("OGPlugin-autosendtechnopage").checked = true;
          document.getElementById("OGPlugin-autosendshipyardpage").checked = true;
          document.getElementById("OGPlugin-autosendfleetpage").checked = true;
          document.getElementById("OGPlugin-autosenddefencepage").checked = true;
          document.getElementById("OGPlugin-autosendempirepage").checked = true;
          
          // Rapports
          document.getElementById("OGPlugin-handlespyreports").checked = true;
          document.getElementById("OGPlugin-handleenemyspy").checked = true;
          document.getElementById("OGPlugin-handlerecyreports").checked = true;
          
          document.getElementById("OGPlugin-autoreport").checked = true;
          document.getElementById("OGPlugin-autosendrcreport").checked = true;
          document.getElementById("OGPlugin-autosendrcreport").checked = true;
          
          // Filtres
          document.getElementById("OGPlugin-securesessionid").checked = true;
          document.getElementById("OGPlugin-filterpointsnumber").checked = true;
          document.getElementById("OGPlugin-filtertechincrements").checked = true;
          
          // Tampons
          document.getElementById("OGPlugin-enablegalviewbuffering").checked = false;
          document.getElementById("OGPlugin-enablestatbuffering").checked = false;
          
          
          if(paraccountrank>0 && confirm("Souhaitez-vous de m\u00eame positionner les options de surbrillance par d\u00e9faut pour la compte n\u00b0"+paraccountrank+"\n"+
                      "\nLe compte sera positionn\u00e9 dans l'onglet surbrillance et vous devrez valider les options par OK en quittant.")) {
              // Surbrillance du compte dsign
              OGPlugin_LoadServerIdFormatsParams(paraccountrank);
              //currentserveridopts=paraccountrank; // pos. indice courant du compte dsign
              document.getElementById("OGPlugin-brighuntilrankplayer").checked = true;
              document.getElementById("OGPlugin-enablestatbuffering").value = 100;

              document.getElementById("OGPlugin-brighuntilrankally").checked = true;
              document.getElementById("OGPlugin-enablestatbuffering").value = 10;

              document.getElementById("OGPlugin-echorankplayer").checked = true;
              document.getElementById("OGPlugin-echorankally").checked = true;

              document.getElementById("OGPlugin-brightfriendlyplayer").checked = true;
              document.getElementById("OGPlugin-brightenemyplayer").checked = true;
              document.getElementById("OGPlugin-brighttradingplayer").checked = true;

              document.getElementById("OGPlugin-brightfriendlyally").checked = true;
              document.getElementById("OGPlugin-brightenemyally").checked = true;
              document.getElementById("OGPlugin-brighttradingally").checked = true;

              // surbrillance "serveur"
              document.getElementById("OGPlugin-brightogspyfriendlyally").checked = true;
              document.getElementById("OGPlugin-brightogspypnaally").checked = true;
              document.getElementById("OGPlugin-brightogspyenemyally").checked = true;
              document.getElementById("OGPlugin-brightogspytradingally").checked = true;
          }
          
          
}

// Affiche au choix la boite de saisie de serveur ogame ou l'tiquette OGSpy for All
function OGPlugin_HideOgameParControls(parnumline, parhidebox, parhidecaption) {
        // if (ogs_optionpopups_debugmode==true) alert(parhidebox.toString()+"-"+parhidecaption.toString());
        document.getElementById("OGPlugin-ogameurl"+parseInt(parnumline)).setAttribute("hidden", parhidebox.toString());
        document.getElementById("OGPlugin-ogspyforall"+parseInt(parnumline)).setAttribute("hidden", parhidecaption.toString());
}

function OGPlugin_HideAllOgameParControls( parhidebox, parhidecaption) {
          for(cpt=1;cpt<8;cpt++) OGPlugin_HideOgameParControls(cpt, parhidebox, parhidecaption);
}
/**
 * Chargement des prfrences et positionnement des contrles
 **/
function OGPlugin_LoadOptsValues() { // lecture donnes options enregistres -> criture contrles
    var prefs = OGPlugin_getPrefs();
    var targetserverversion;
    var targeturltextbox;
    var noserverinfosfound=true;
    
   if (ogs_debug_mode==true) alert("dbut affichage option!");
    
    
    /////////////////////////
    // Infos comptes OGSPY //
    /////////////////////////

    // traitements des zones de saisie en boucle pour plus de facilit
    for (cpt=1;cpt<8;cpt++) {
      
        /* Affichage conditionnel de champs associs ssi url serveur ogspy non vide
           et affichage adresse serveur ogspy */
        if (OGPlugin_getCharPref("OGPlugin.settings.url"+cpt, '', "OGPlugin-url"+cpt)!='') {
      
            // nom joueurs
            if(prefs.prefHasUserValue("OGPlugin.settings.username"+cpt) && prefs.getCharPref("OGPlugin.settings.url"+cpt)!='') {
              username = decodeURI(prefs.getCharPref("OGPlugin.settings.username"+cpt));
              document.getElementById("OGPlugin-username"+cpt).value = username;
              document.getElementById("OGPlugin-username"+cpt).setAttribute("tooltiptext", 'Pseudo de jeu: '+ OGPlugin_getCharPref("OGPlugin.settings.playernick"+cpt, '', ''));
            }
            
            // mots de passe
            // cas mot de pass crypt
            var crypted = OGPlugin_getBoolPref('OGPlugin.settings.iscryptedpass'+cpt, false, 'OGPlugin-iscryptedpass'+cpt);
            if (crypted==true) {
                targetmenuitem = document.getElementById('OGPlugin-iscryptedpass'+cpt);
                targetmenuitem.setAttribute("disabled", true  );


                targetpasswordedit = document.getElementById("OGPlugin-password"+cpt);
                targetpasswordedit.value = "<crypt\u00e9>";
                targetpasswordedit.setAttribute("type", "text");

                //OGPlugin_getCharPref("OGPlugin.settings.password"+cpt, '', "OGPlugin-password"+cpt)
            } else OGPlugin_getCharPref("OGPlugin.settings.password"+cpt, '', "OGPlugin-password"+cpt);
            
            
            // Etiquette version serveur ogspy
            document.getElementById('OGPlugin-version'+cpt).setAttribute("tooltiptext",
            OGPlugin_getCharPref("OGPlugin.settings.serverversion"+cpt, '', "OGPlugin-version"+cpt));
            
            //////////////
            // Tooltips //
            //////////////
            if(prefs.prefHasUserValue("OGPlugin.settings.serverversion"+cpt) && prefs.prefHasUserValue("OGPlugin.settings.servername"+cpt)) {
                targetmenuitem = document.getElementById("OGPlugin-url"+cpt);
                targetmenuitem.setAttribute("tooltiptext", prefs.getCharPref("OGPlugin.settings.servername"+cpt)+' ('+prefs.getCharPref("OGPlugin.settings.serverversion"+cpt)+')' );
            }

            // cas serveur stat(bool)
            OGPlugin_getBoolPref('OGPlugin.settings.isstatserver'+cpt, false, 'OGPlugin-isstatserver'+cpt);

        }
               
        // adresse serveur ogame
        OGPlugin_getCharPref("OGPlugin.settings.ogameurl"+cpt, '', "OGPlugin-ogameurl"+cpt);
     
    }  
    if (ogs_debug_mode==true) alert("fin boucle compte OGSPY!");
    //-------------------------------------------------------------

    // ident server stat - obsolte
    /* if(prefs.prefHasUserValue("OGPlugin.settings.serverstatrank")) {
        serverstatrank = document.getElementById("OGPlugin-options-serverstatrank");
        serverstatrank.selectedIndex =  prefs.getIntPref("OGPlugin.settings.serverstatrank");
    } */

    //-------------------------------------------------------------

    ////////////////////
    // ONGLET GENERAL //
    ////////////////////

    // automatic start
    OGPlugin_getBoolPref('OGPlugin.settings.autostarten', true, 'OGPlugin-autostart');

    // recherche des mises  jour au dmarrage
    OGPlugin_getBoolPref('OGPlugin.settings.checkupdtonstart', false, 'OGPlugin-checkupdtonstart');
    
    // vrification de la diplomatie distante au dmarrage
    OGPlugin_getBoolPref('OGPlugin.settings.checkdiplomatyonstart', false, 'OGPlugin-checkdiplomatyonstart');
    
    // automaticly hide tool bar
    OGPlugin_getBoolPref('OGPlugin.settings.autohide', false, 'OGPlugin-autohide');
    
    // copier les galaxies et rapports d'espionnage vers le presse-papier
    OGPlugin_getBoolPref('OGPlugin.settings.autocopytoclpbrd', false, 'OGPlugin-autocopytoclpbrd');
    
    // mode autonome sans module - pages galaxie, messages, statistiques gnrales
    OGPlugin_getBoolPref('OGPlugin.settings.gatesendmod', false, 'OGPlugin-gatesendmod');
    
    // wrong config popup
    OGPlugin_getBoolPref('OGPlugin.settings.showfalseconfigpopups', true, 'OGPlugin-options-showfalseconfigpopups');

    // show option panel if needed
    OGPlugin_getBoolPref('OGPlugin.settings.showoptionpanelonerror', true, 'OGPlugin-options-showoptionpanelonerror');
    
    // Nombre d'entre du journal
    OGPlugin_getIntPref('OGPlugin.settings.logsize', 50, 'OGPlugin-logsize');
    
    // traiter les pages du jeu Ogame
    OGPlugin_getBoolPref('OGPlugin.settings.handleogame', true, 'OGPlugin-handleogame');

    // traiter les pages du jeu E-Univers
    OGPlugin_getBoolPref('OGPlugin.settings.handleeunivers', true, 'OGPlugin-handleeunivers');
    
    // traiter les pages du jeu Exile
   // OGPlugin_getBoolPref('OGPlugin.settings.handleexile', true, 'OGPlugin-handleexile');
    
    // traiter les pages du jeu Travian
    //OGPlugin_getBoolPref('OGPlugin.settings.handletravian', true, 'OGPlugin-handletravian');
    
    /////////////////////////////////
    // supplment options ajoutes //
    /////////////////////////////////
    
    /* // only handle checked reports
    if(prefs.prefHasUserValue("OGPlugin.settings.onlycheckedreports")) {
        var onlycheckedreports = prefs.getBoolPref("OGPlugin.settings.onlycheckedreports");
        document.getElementById("OGPlugin-onlycheckedreports").checked = onlycheckedreports;
    } */ // rebut, fonction non code
    
     // auto show foxgame options
    OGPlugin_getBoolPref('OGPlugin.settings.autoshowfgoptions', true, 'OGPlugin-autoshowfgoptions');


    // ONGLET GESTION PAGES / Pages Ogame

    // handle general players and alliances stats
    OGPlugin_getBoolPref('OGPlugin.settings.handlegeneralstats', true, 'OGPlugin-handlegeneralstats');
    
    // handle galaxy views
    OGPlugin_getBoolPref('OGPlugin.settings.handlegalaxyviews', true, 'OGPlugin-handlegalaxyviews');

    // handle proper ally stats
    OGPlugin_getBoolPref('OGPlugin.settings.handleallystats', true, 'OGPlugin-handleallystats');

    
    // Envois automatiques

    OGPlugin_getBoolPref('OGPlugin.settings.autosendoverviewpage', true, 'OGPlugin-autosendoverviewpage');
    OGPlugin_getBoolPref('OGPlugin.settings.autosendbuildingpage', true, 'OGPlugin-autosendbuildingpage');
    OGPlugin_getBoolPref('OGPlugin.settings.autosendresourcespage', true, 'OGPlugin-autosendresourcespage');
    OGPlugin_getBoolPref('OGPlugin.settings.autosendtechnopage', true, 'OGPlugin-autosendtechnopage');
    OGPlugin_getBoolPref('OGPlugin.settings.autosendshipyardpage', true, 'OGPlugin-autosendshipyardpage');
    OGPlugin_getBoolPref('OGPlugin.settings.autosendfleetpage', true, 'OGPlugin-autosendfleetpage');
    OGPlugin_getBoolPref('OGPlugin.settings.autosenddefencepage', true, 'OGPlugin-autosenddefencepage');
    OGPlugin_getBoolPref('OGPlugin.settings.autosendempirepage', true, 'OGPlugin-autosendempirepage');
    
    // OPTIONS SPECIALES 
     // show general stats page scroll buttons
    OGPlugin_getBoolPref('OGPlugin.settings.genstatsbuttons', false, 'OGPlugin-genstatsbuttons');    
    // Dsactivation surbrillance
    OGPlugin_getBoolPref('OGPlugin.settings.enablehighlighting', false, 'OGPlugin-enablehighlighting')
    // dsactivation raccourci ouverture nouvelle page Ogame
    OGPlugin_getBoolPref('OGPlugin.settings.enableogamespeedlink', false, 'OGPlugin-enableogamespeedlink')
    
    // Read NotifyMode int
    if(prefs.prefHasUserValue("OGPlugin.settings.notifymode")) {
        var notifymode = prefs.getIntPref("OGPlugin.settings.notifymode");
        document.getElementById("OGPlugin-notifymodes").selectedIndex = notifymode;
    }
    
    // Read OGPlugin-multisserversend boolean
    /* if(prefs.prefHasUserValue("OGPlugin.settings.multisserversend")) {
        var multisserversend = prefs.getBoolPref("OGPlugin.settings.multisserversend");
        document.getElementById("OGPlugin-multisserversend").checked = multisserversend;
    } */
    OGPlugin_getBoolPref('OGPlugin.settings.multisserversend', false, 'OGPlugin-multisserversend')
    
    /********************
    // OPTIONS RAPPORTS
    *********************/
    
    // automatic report
    OGPlugin_getBoolPref('OGPlugin.settings.autoreporten', false, 'OGPlugin-autoreport');
    OGPlugin_getBoolPref('OGPlugin.settings.handlespyreports', true, 'OGPlugin-handlespyreports')
    OGPlugin_getBoolPref('OGPlugin.settings.handleenemyspy', true, 'OGPlugin-handleenemyspy')
    // handlerecyreports
    OGPlugin_getBoolPref('OGPlugin.settings.handlerecyreports', true, 'OGPlugin-handlerecyreports')    
    OGPlugin_getBoolPref('OGPlugin.settings.filterspyreportressource', false, 'OGPlugin-reportcleanressource')
    OGPlugin_getBoolPref('OGPlugin.settings.filterspyreportfleet', false, 'OGPlugin-reportcleanfleet')
    OGPlugin_getBoolPref('OGPlugin.settings.autosendrcreport', false, 'OGPlugin-autosendrcreport')    
    
    /********************
    // ANALYSE, INDICES DE TABLES
    *********************/
    
    // Donnes Ogame
    
    // Donnes E-Univers
    OGPlugin_getIntPref("OGPlugin.settings.eunivgalaxytablerank", eun_GalaxyPageRankTab, 'OGPlugin-eunivgalaxytablerank');
    OGPlugin_getCharPref("OGPlugin.settings.eunivgalaxypath", eun_PathtoGalaxyTable, 'OGPlugin-eunivgalaxypath');

    OGPlugin_getIntPref("OGPlugin.settings.eunivstatspagetablerank", eun_StatsPageRankTab, 'OGPlugin-eunivstatspagetablerank');
    OGPlugin_getCharPref("OGPlugin.settings.eunivstatspath", eun_PathtoStatsTable, 'OGPlugin-eunivstatspath');

    OGPlugin_getIntPref("OGPlugin.settings.eunivmessagestablerank", eun_MsgPageRankTab, 'OGPlugin-eunivmessagestablerank');
    OGPlugin_getCharPref("OGPlugin.settings.eunivreportspath", eun_PathtoMessageTable, 'OGPlugin-eunivreportspath');


    OGPlugin_getIntPref("OGPlugin.settings.eunivallyhisttablerank", eun_AllyHistRankTab, 'OGPlugin-eunivallyhisttablerank');
    OGPlugin_getCharPref("OGPlugin.settings.eunivallyhistpath", eun_PathtoAllyHistTable, 'OGPlugin-eunivallyhistpath');

    OGPlugin_getIntPref("OGPlugin.settings.eunivbuildingpagetablerank", eun_BuildingPageRankTab, 'OGPlugin-eunivbuildingpagetablerank');
    OGPlugin_getCharPref("OGPlugin.settings.eunivbuidlingpath", eun_PathtoBuildingTable, 'OGPlugin-eunivbuidlingpath');

    OGPlugin_getIntPref("OGPlugin.settings.eunivtechnopagetablerank", eun_TechnoPageRankTab, 'OGPlugin-eunivtechnopagetablerank');
    OGPlugin_getCharPref("OGPlugin.settings.eunivlabopath", eun_PathtoLaboTable, 'OGPlugin-eunivlabopath');

    OGPlugin_getIntPref("OGPlugin.settings.eunivfleetpagetablerank", eun_FleetPageRankTab, 'OGPlugin-eunivfleetpagetablerank');
    OGPlugin_getCharPref("OGPlugin.settings.eunivfleetpath", eun_PathtoFleetVoyaging, 'OGPlugin-eunivfleetpath');

    OGPlugin_getIntPref("OGPlugin.settings.eunivdefencepagetablerank", eun_DefencePageRankTab, 'OGPlugin-eunivdefencepagetablerank');
    OGPlugin_getCharPref("OGPlugin.settings.eunivdefencepath", eun_PathtodefenceTable, 'OGPlugin-eunivdefencepath');

    OGPlugin_getIntPref("OGPlugin.settings.eunivplanempiretablerank", eun_GlobalViewRankTab, 'OGPlugin-eunivplanempiretablerank');
    OGPlugin_getCharPref("OGPlugin.settings.eunivplanempirepath", eun_PathtoGlobalViewTable, 'OGPlugin-eunivplanempirepath');
    
    
    /*******************
    ** ONGLET FILTRES **
    ********************/
    
    // filtrage des ids de session
    OGPlugin_getBoolPref('OGPlugin.settings.securesessionid', true, 'OGPlugin-securesessionid');

    // filtrage des points des nombres  sparateur
    OGPlugin_getBoolPref('OGPlugin.settings.filterpointsnumber', true, 'OGPlugin-filterpointsnumber');

    // filtrage des donnes de champs de ruines (galaxie)
    OGPlugin_getBoolPref('OGPlugin.settings.filterdebrisfield', false, 'OGPlugin-filterdebrisfield');

    // filtrage infos missiles/dfense
    OGPlugin_getBoolPref('OGPlugin.settings.filtermissiblenumber', true, 'OGPlugin-filtermissiblenumber');

    // filtrage des messages de progression recherche
    OGPlugin_getBoolPref('OGPlugin.settings.filtertechnoprogress', true, 'OGPlugin-filtertechnoprogress');

    // filtrage des incrment de recherche pour le compte technocrate
    OGPlugin_getBoolPref('OGPlugin.settings.filtertechincrements', true, 'OGPlugin-filtertechincrements');
    
    // Mise en tampon, Read Buffering Options

    //OGPlugin-enablegalviewbuffering    
    OGPlugin_getBoolPref('OGPlugin.settings.enablegalviewbuffering', false, 'OGPlugin-enablegalviewbuffering');
        
    // OGPlugin-enablestatbuffering
    //prefs.setBoolPref("OGPlugin.settings.enablestatbuffering", document.getElementById("OGPlugin-enablestatbuffering").checked); // set a pref
    OGPlugin_getBoolPref('OGPlugin.settings.enablestatbuffering', false, 'OGPlugin-enablestatbuffering');
    
    // OGPlugin-buffer_numgalview
    //prefs.setIntPref("OGPlugin.settings.buffer_numgalview", document.getElementById("OGPlugin-buffer_numgalview").value);
    if(prefs.prefHasUserValue("OGPlugin.settings.buffer_numgalview")) {
        var buffer_numgalview = prefs.getIntPref("OGPlugin.settings.buffer_numgalview");
        document.getElementById("OGPlugin-buffer_numgalview").value = buffer_numgalview;
    }    
    // OGPlugin-buffer_numstatstabs
    //prefs.setIntPref("OGPlugin.settings.buffer_numstatstabs", document.getElementById("OGPlugin-buffer_numstatstabs").value);
    if(prefs.prefHasUserValue("OGPlugin.settings.buffer_numstatstabs")) {
        var buffer_numstatstabs = prefs.getIntPref("OGPlugin.settings.buffer_numstatstabs");
        document.getElementById("OGPlugin-buffer_numstatstabs").value = buffer_numstatstabs;
    }


    OGPlugin_getBoolPref('OGPlugin.settings.flushbufwhenswitching', false, 'OGPlugin-flushbufwhenswitching');

    //alert("options onglet mise  jour!");
    // ONGLET MISE A JOUR
    
    OGPlugin_getBoolPref('OGPlugin.settings.modresponseaskupdatecheck', true, 'OGPlugin-modresponseaskupdatecheck')
    OGPlugin_getBoolPref('OGPlugin.settings.modresponseinstallupdate', true, 'OGPlugin-modresponseinstallupdate')            
    OGPlugin_getBoolPref('OGPlugin.settings.modresponseaskforrestart', true, 'OGPlugin-modresponseaskforrestart')        
    OGPlugin_getBoolPref('OGPlugin.settings.autoupdateaskforrestart', true, 'OGPlugin-autoupdateaskforrestart')
  
    if (ogs_debug_mode==true)  alert("fin affichage option!");
}

/**
 * Sauvegarde des proprit du panneau d'options
 **/
function OGPlugin_SaveOptsValues() {
    var prefs = OGPlugin_getPrefs();
    var callingurl;
    var DlgSendGetCommandtext="";
    var gotservername="";
    var gotserverversion="",gotserverversion1="",gotserverversion2="",rawserverversion="";
    var notifymode=0;
    var catsalliestabs = new Array("","","","");

    // 8 -> 7 lements de saisies
    // alert("debut boucle");
    for (cpt=1; cpt<=7; cpt++) { // sauvegarde des paramtres de tous les serveurs(saisis ou pas)
        // paramtres de serveurs pris en compte si url ogspy modifie
        if (serverurlchanged[cpt-1]==true) {
           //===================================================================
           callingurl = decodeURIComponent(OGPlugin_getValue('OGPlugin-url'+cpt));

           // dtection d'un code UID OGS for All
           var is_ofa_uid = (callingurl.length==10 && callingurl.match(UIDRegExp)!=null);

           // traduction d'un code UID OFA en adresse url
           if (is_ofa_uid) callingurl = 'http://www.ogsforall.com/'+callingurl+'/ogsplugin.php';
           // vrification si terminaison par non(ogsplugin.php)
           //===================================================================
           // compatibilit sur chemin Xtense ajout, le fichier cibl doit seulement correspondre  un script module compatible
           if (OGPlugin_TrimString(callingurl)!="" &&
              !(OGPlugin_IsNCSStringEquals(callingurl.substr(0,7) , 'http://')==true // doit commencer par ...
              ||callingurl.search(/^.+?ogsplugin\d?\.php$/)>-1
              || callingurl.search(/^.+?xtense_plugin\d?\.php$/)>-1)) {
                // url plugin incorrecte - doit se terminer par ogsplugin.pgp
                alert(OGPlugin_GetLocString("error.configurlmismatch.prefix")+cpt+OGPlugin_GetLocString("error.configurlmismatch.suffix"));
                return;
           } // else alert(OGPlugin_GetLocString("optdlg.urlreaderror" )+"("+cpt+" : "+callingurl+")"+callingurl.search(/^.+?ogsplugin\d?\.php$/));

           // rcupration des infos serveur via le script ogsplugin?.php
           if (OGPlugin_TrimString(callingurl)!="" /* && callingurl.search(/^.+?ogsplugin\d?\.php$/)>-1 */) {

              // Rcupration nom et version de serveur
              OGPlugin_GetServerNameVer(cpt, callingurl);

              // enregistrement no d'univers si lecture serveur ofa et mise en tampon
              if (ogs_numuniv_tab[cpt-1]>0) {
                  OGPlugin_setIntPref("OGPlugin.settings.ofanumuniv"+cpt , ogs_numuniv_tab[cpt-1] ,'')
                  //if (callingurl.match(UIDRegExp)!=null) // ligne en cours: UID OGS for All
              }

              //Sauvegarde du pseudo de jeu si dfini saisie surgissante
              if (ogs_playernicks_tab[cpt-1]!=null)
                  OGPlugin_setCharPref("OGPlugin.settings.playernick"+cpt , ogs_playernicks_tab[cpt-1] ,'')

              // rcupration tag alliances
              var res_GetServerCatAllies = OGPlugin_GetServerCatAllies(cpt, callingurl);

              // enregistrement dans les proprits
              OGPlugin_setCharPref("OGPlugin.settings.srvfriendlyallies"+cpt, res_GetServerCatAllies[2], '');
              OGPlugin_setCharPref("OGPlugin.settings.srvpnaallies"+cpt, res_GetServerCatAllies[3], '');
              OGPlugin_setCharPref("OGPlugin.settings.srvenemyallies"+cpt, res_GetServerCatAllies[4], '');
              OGPlugin_setCharPref("OGPlugin.settings.srvtradingallies"+cpt, res_GetServerCatAllies[5], '');

              OGPlugin_SaveAutoConfigOptions(cpt); // enregistrement des options par dfaut

              //-------------------------------------------------------------------------------------
              // detection mode notification
              notifymode = OGPlugin_DlgSendGetCommand(callingurl,"probenotifymode", true, true);
              prefs.setIntPref("OGPlugin.settings.notifymode"+cpt, notifymode);
              //-------------------------------------------------------------------------------------


           } else
           {
                // champ url serveur vide, rinitialisation des paramtres
                //OGPlugin_setCharPref('OGPlugin.settings.password'+cpt, '', '');

                prefs.setCharPref("OGPlugin.settings.password"+cpt, "");
                prefs.setCharPref("OGPlugin.settings.serverversion"+cpt, "");
                prefs.setCharPref("OGPlugin.settings.srvfriendlyallies"+cpt, '', '');
                OGPlugin_setCharPref("OGPlugin.settings.srvpnaallies"+cpt, '', '');
                OGPlugin_setCharPref("OGPlugin.settings.srvenemyallies"+cpt, '', '');
                OGPlugin_setCharPref("OGPlugin.settings.srvtradingallies"+cpt, '', '');
           }
        }

        // cas serveur stat(bool)
        OGPlugin_setBoolPref('OGPlugin.settings.isstatserver'+cpt, false, 'OGPlugin-isstatserver'+cpt);

        //alert("le mot de passe n"+cpt+" est crypt!("+crypted+")");

        // usernames
        // pas d'encodage
        prefs.setCharPref("OGPlugin.settings.username"+cpt, OGPlugin_getValue("OGPlugin-username"+cpt)); // set a pref

        //////////////////////////////////
        // GESTION DU HASH MOT DE PASSE //**************************************
        //////////////////////////////////

        // rcupration de l'tat du cryptage pour la ligne mdp en cours
        callingurl = decodeURIComponent(OGPlugin_getValue('OGPlugin-url'+cpt));
        if (callingurl.search(/^.+?xtense_plugin\d?\.php$/)>-1) {// Cas Xtense, cryptage non pris en charge
           crypted = OGPlugin_setBoolPref('OGPlugin.settings.iscryptedpass'+cpt, false, ''); // pas de cryptage
        } else crypted = OGPlugin_setBoolPref('OGPlugin.settings.iscryptedpass'+cpt, false, 'OGPlugin-iscryptedpass'+cpt);

        if (ogs_passwordman_debugmode==true) alert("cryptage pour server "+cpt+" : "+crypted+'-'+passwordchangedtab[cpt-1]);

        // on ne peut qu'activer le hashage du mdp sans changer le mdp
        // pour dsactiver le hashage, il faut renouveler le mdp pour pouvoir dcocher l'option de hash
        // n'enregistrer mot de pass que si non cryptage sinon dtecter modifications
        // passwords
        passworstring=OGPlugin_getValue("OGPlugin-password"+cpt);
        if (passwordchangedtab[cpt-1]==true && OGPlugin_TrimString(passworstring)!="") {  // mot de passe a chang, hashage ou pas seulement dans ce cas

            if (crypted==true) {
              if (ogs_passwordman_debugmode==true) alert("mot de passe chang ("+cpt+"):cryptage - "+passworstring);

              if (passworstring!="") cryptedpass=hex_md5(hex_sha1(passworstring)); // hashage identique  celui d'ogspy
              else cryptedpass="";
            } else cryptedpass=passworstring;
            // enregistrement qqsoit codage puisque le mot de pass a t chang
            prefs.setCharPref("OGPlugin.settings.password"+cpt, cryptedpass); // set a pref
            if (ogs_passwordman_debugmode==true) alert("mot de passe  changer ("+cpt+"): "+passworstring);

        }  else {
           if (pwdcryptoptchangedtab[cpt]==true) { // le tableau pwdcryptoptchangedtab indique si l'option  t coche ou dcoche
              // si option cryptage chang => mot de pass chang
              // si mot de pass n'a pas chang, il n'est pas crypt(cach)
              if (crypted==true && OGPlugin_TrimString(passworstring)!="") cryptedpass=hex_md5(hex_sha1(passworstring));
              else cryptedpass=OGPlugin_TrimString(passworstring);
              // enregistrement qqsoit codage
              prefs.setCharPref("OGPlugin.settings.password"+cpt, cryptedpass); // set a pref
           }
        }  //*********************************************************************

        //
        // tool urls
        //prefs.setCharPref("OGPlugin.settings.url"+cpt, decodeURIComponent(OGPlugin_getValue("OGPlugin-url"+cpt))); // set a pref
        OGPlugin_setCharPref('OGPlugin.settings.url'+cpt, '', 'OGPlugin-url'+cpt);
        // ogame urls
        //prefs.setCharPref("OGPlugin.settings.ogameurl"+cpt, decodeURIComponent(OGPlugin_getValue("OGPlugin-ogameurl"+cpt))); // set a pref
        OGPlugin_setCharPref('OGPlugin.settings.ogameurl'+cpt, '', 'OGPlugin-ogameurl'+cpt);

    } // fin boucle for

    /////////////
    // GENERAL //---------------------------------------------------------------------------------------------------
    /////////////

    // option dialog check boxes
    // ONGLET GENERAL

    // automatic start
    OGPlugin_setBoolPref('OGPlugin.settings.autostarten', true, 'OGPlugin-autostart');

    // recherche des mises  jour au dmarrage
    OGPlugin_setBoolPref('OGPlugin.settings.checkupdtonstart', false, 'OGPlugin-checkupdtonstart');

    // vrification de la diplomatie distante au dmarrage
    OGPlugin_setBoolPref('OGPlugin.settings.checkdiplomatyonstart', false, 'OGPlugin-checkdiplomatyonstart');

    // affichage options foxgame si ncessaire
    OGPlugin_setBoolPref('OGPlugin.settings.autoshowfgoptions', true, 'OGPlugin-autoshowfgoptions'); // set a pref

    // automaticly hide tool bar
    OGPlugin_setBoolPref('OGPlugin.settings.autohide', false, 'OGPlugin-autohide');

    // copier les galaxies et rapports d'espionnage vers le presse-papier
    OGPlugin_setBoolPref('OGPlugin.settings.autocopytoclpbrd', false, 'OGPlugin-autocopytoclpbrd');
    
    // mode autonome sans module - pages galaxie, messages, statistiques gnrales
    OGPlugin_setBoolPref('OGPlugin.settings.gatesendmod', false, 'OGPlugin-gatesendmod');

    // wrong config popup
    OGPlugin_setBoolPref('OGPlugin.settings.showfalseconfigpopups', true, 'OGPlugin-options-showfalseconfigpopups');

    // show option panel if needed
    OGPlugin_setBoolPref('OGPlugin.settings.showoptionpanelonerror', true, 'OGPlugin-options-showoptionpanelonerror');

    // Nombre d'entre du journal
    OGPlugin_setIntPref('OGPlugin.settings.logsize', 50, 'OGPlugin-logsize');

    // traiter les pages du jeu Ogame
    OGPlugin_setBoolPref('OGPlugin.settings.handleogame', true, 'OGPlugin-handleogame');

    // traiter les pages du jeu E-Univers
    OGPlugin_setBoolPref('OGPlugin.settings.handleeunivers', true, 'OGPlugin-handleeunivers');
    
    // traiter les pages du jeu Exile
    //OGPlugin_setBoolPref('OGPlugin.settings.handleexile', true, 'OGPlugin-handleexile');

    // traiter les pages du jeu Travian
    //OGPlugin_setBoolPref('OGPlugin.settings.handletravian', true, 'OGPlugin-handletravian');

    ///////////////////////
    // GESTION DES PAGES //
    ///////////////////////

    // prefs.setBoolPref("OGPlugin.settings.onlycheckedreports", document.getElementById("OGPlugin-onlycheckedreports").checked); // set a pref

    OGPlugin_setBoolPref('OGPlugin.settings.handlegalaxyviews', true, 'OGPlugin-handlegalaxyviews');
    OGPlugin_setBoolPref('OGPlugin.settings.handlegeneralstats', true, 'OGPlugin-handlegeneralstats');
    OGPlugin_setBoolPref('OGPlugin.settings.handleallystats', true, 'OGPlugin-handleallystats');

    // Envois automatiques

    OGPlugin_setBoolPref('OGPlugin.settings.autosendoverviewpage', true, 'OGPlugin-autosendoverviewpage');
    OGPlugin_setBoolPref('OGPlugin.settings.autosendbuildingpage', true, 'OGPlugin-autosendbuildingpage');
    OGPlugin_setBoolPref('OGPlugin.settings.autosendresourcespage', true, 'OGPlugin-autosendresourcespage');
    OGPlugin_setBoolPref('OGPlugin.settings.autosendtechnopage', true, 'OGPlugin-autosendtechnopage');
    OGPlugin_setBoolPref('OGPlugin.settings.autosendshipyardpage', true, 'OGPlugin-autosendshipyardpage');
    OGPlugin_setBoolPref('OGPlugin.settings.autosendfleetpage', true, 'OGPlugin-autosendfleetpage');
    OGPlugin_setBoolPref('OGPlugin.settings.autosenddefencepage', true, 'OGPlugin-autosenddefencepage');
    OGPlugin_setBoolPref('OGPlugin.settings.autosendempirepage', true, 'OGPlugin-autosendempirepage');

    // ident server stat - boite obsolte
    //prefs.setIntPref("OGPlugin.settings.serverstatrank", document.getElementById("OGPlugin-options-serverstatrank").selectedIndex);

    // OPTIONS SPECIALES //

    //genstatsbuttons
    prefs.setBoolPref("OGPlugin.settings.genstatsbuttons", document.getElementById("OGPlugin-genstatsbuttons").checked); // set a pref

    // dsactivation globale surbrillance
    OGPlugin_setBoolPref('OGPlugin.settings.enablehighlighting', false, 'OGPlugin-enablehighlighting')

    // dsactivation raccourci ouverture nouvelle page Ogame
    if (OGPlugin_setBoolPref('OGPlugin.settings.enableogamespeedlink', false, 'OGPlugin-enableogamespeedlink')==false)
       OGPlugin_UnsetNewOgamePageSpeedlink();

    // criture bote droulante notifymode
    prefs.setIntPref("OGPlugin.settings.notifymode", document.getElementById("OGPlugin-notifymodes").selectedIndex);

    // criture boolean multisserversend
    prefs.setBoolPref("OGPlugin.settings.multisserversend", document.getElementById("OGPlugin-multisserversend").checked); // set a pref

    // OPTIONS RAPPORTS
    OGPlugin_setBoolPref('OGPlugin.settings.autoreporten', false, 'OGPlugin-autoreport');
    //---- dcocher cases grises

    /* if (document.getElementById("OGPlugin-autoreport").disabled == true) // dcocher si gris
       prefs.setBoolPref("OGPlugin.settings.autoreporten", false); */

    OGPlugin_setBoolPref('OGPlugin.settings.handlespyreports', false, 'OGPlugin-handlespyreports')
    OGPlugin_setBoolPref('OGPlugin.settings.handleenemyspy', false, 'OGPlugin-handleenemyspy')
    OGPlugin_setBoolPref('OGPlugin.settings.handlerecyreports', true, 'OGPlugin-handlerecyreports')

    // nom objet/proprit diffrents!
    OGPlugin_setBoolPref('OGPlugin.settings.filterspyreportressource', false, 'OGPlugin-reportcleanressource')
    OGPlugin_setBoolPref('OGPlugin.settings.filterspyreportfleet', false, 'OGPlugin-reportcleanfleet')

    OGPlugin_setBoolPref('OGPlugin.settings.autosendrcreport', false, 'OGPlugin-autosendrcreport')


    // ANALYSE, INDICES DE TABLES

   // Donnes Ogame

    // Donnes E-Univers
    OGPlugin_setIntPref("OGPlugin.settings.eunivgalaxytablerank", 1, 'OGPlugin-eunivgalaxytablerank');
    OGPlugin_setCharPref("OGPlugin.settings.eunivgalaxypath", '', 'OGPlugin-eunivgalaxypath');

    OGPlugin_setIntPref("OGPlugin.settings.eunivstatspagetablerank", 1, 'OGPlugin-eunivstatspagetablerank');
    OGPlugin_setCharPref("OGPlugin.settings.eunivstatspath", '', 'OGPlugin-eunivstatspath');

    OGPlugin_setIntPref("OGPlugin.settings.eunivmessagestablerank", 1, 'OGPlugin-eunivmessagestablerank');
    OGPlugin_setCharPref("OGPlugin.settings.eunivreportspath", '', 'OGPlugin-eunivreportspath');


    OGPlugin_setIntPref("OGPlugin.settings.eunivallyhisttablerank", 1, 'OGPlugin-eunivallyhisttablerank');
    OGPlugin_setCharPref("OGPlugin.settings.eunivallyhistpath", '', 'OGPlugin-eunivallyhistpath');

    OGPlugin_setIntPref("OGPlugin.settings.eunivbuildingpagetablerank", 1, 'OGPlugin-eunivbuildingpagetablerank');
    OGPlugin_setCharPref("OGPlugin.settings.eunivbuidlingpath", '', 'OGPlugin-eunivbuidlingpath');

    OGPlugin_setIntPref("OGPlugin.settings.eunivtechnopagetablerank", 1, 'OGPlugin-eunivtechnopagetablerank');
    OGPlugin_setCharPref("OGPlugin.settings.eunivlabopath", '', 'OGPlugin-eunivlabopath');

    OGPlugin_setIntPref("OGPlugin.settings.eunivfleetpagetablerank", 1, 'OGPlugin-eunivfleetpagetablerank');
    OGPlugin_setCharPref("OGPlugin.settings.eunivfleetpath", '', 'OGPlugin-eunivfleetpath');

    OGPlugin_setIntPref("OGPlugin.settings.eunivdefencepagetablerank", 1, 'OGPlugin-eunivdefencepagetablerank');
    OGPlugin_setCharPref("OGPlugin.settings.eunivdefencepath", '', 'OGPlugin-eunivdefencepath');
    
    OGPlugin_setIntPref("OGPlugin.settings.eunivcombreptablerank", 1, 'OGPlugin-eunivcombreptablerank');
    OGPlugin_setCharPref("OGPlugin.settings.eunivcombreppath", '', 'OGPlugin-eunivcombreppath');

    OGPlugin_setIntPref("OGPlugin.settings.eunivpopupreporttablerank", 1, 'OGPlugin-eunivpopupreporttablerank');
    OGPlugin_setCharPref("OGPlugin.settings.eunivpopupreportpath", '', 'OGPlugin-eunivpopupreportpath');

    OGPlugin_setIntPref("OGPlugin.settings.eunivplanempiretablerank", 1, 'OGPlugin-eunivplanempiretablerank');
    OGPlugin_setCharPref("OGPlugin.settings.eunivplanempirepath", '', 'OGPlugin-eunivplanempirepath');


    // FILTRES
    
    // filtrage des ids de session
    OGPlugin_setBoolPref('OGPlugin.settings.securesessionid', true, 'OGPlugin-securesessionid');

    // filtrage des points des nombres  sparateur
    OGPlugin_setBoolPref('OGPlugin.settings.filterpointsnumber', true, 'OGPlugin-filterpointsnumber');

    // filtrage des donnes de champs de ruines (galaxie)
    OGPlugin_setBoolPref('OGPlugin.settings.filterdebrisfield', true, 'OGPlugin-filterdebrisfield');

    // filtrage infos missiles/dfense
    OGPlugin_setBoolPref('OGPlugin.settings.filtermissiblenumber', true, 'OGPlugin-filtermissiblenumber');

    // filtrage des messages de progression recherche
    OGPlugin_setBoolPref('OGPlugin.settings.filtertechnoprogress', true, 'OGPlugin-filtertechnoprogress');

    // filtrage des incrment de recherche pour le compte technocrate
    OGPlugin_setBoolPref('OGPlugin.settings.filtertechincrements', true, 'OGPlugin-filtertechincrements');

    // MISE EN TAMPON

    // criture groupobox mise en tampon galaxie
    //OGPlugin-enablegalviewbuffering
    BufferGalViewsEnabled = document.getElementById("OGPlugin-enablegalviewbuffering").checked;
    prefs.setBoolPref("OGPlugin.settings.enablegalviewbuffering", BufferGalViewsEnabled); // set a pref


    // OGPlugin-enablestatbuffering
    prefs.setBoolPref("OGPlugin.settings.enablestatbuffering", document.getElementById("OGPlugin-enablestatbuffering").checked); // set a pref
    // OGPlugin-buffer_numgalview
    prefs.setIntPref("OGPlugin.settings.buffer_numgalview", document.getElementById("OGPlugin-buffer_numgalview").value);
    // OGPlugin-buffer_numstatstabs
    prefs.setIntPref("OGPlugin.settings.buffer_numstatstabs", document.getElementById("OGPlugin-buffer_numstatstabs").value);

    // Vidage tampon stats au changement de catgorie,
    OGPlugin_setBoolPref('OGPlugin.settings.flushbufwhenswitching', false, 'OGPlugin-flushbufwhenswitching');


    // sauvegarde params diplomatiques serveur en cours
    if (currentserveridopts>0) OGPlugin_SaveServerIdFormatsParams(currentserveridopts);



    // ONGLET MISE A JOUR

    OGPlugin_setBoolPref('OGPlugin.settings.modresponseaskupdatecheck', true, 'OGPlugin-modresponseaskupdatecheck');
    OGPlugin_setBoolPref('OGPlugin.settings.modresponseinstallupdate', true, 'OGPlugin-modresponseinstallupdate') ;
    OGPlugin_setBoolPref('OGPlugin.settings.modresponseaskforrestart', true, 'OGPlugin-modresponseaskforrestart');
    OGPlugin_setBoolPref('OGPlugin.settings.autoupdateaskforrestart', true, 'OGPlugin-autoupdateaskforrestart');

    window.close();
}

/**
 * Chargement les couleurs choisies et leurs indices correspondant  un compte slectionn
 **/
function OGPlugin_LoadAccountCatsColorsOptions(paraccountrank) { // paraccountrank de 1  7

    //alert('OGPlugin_LoadAccountCatsColorsOptions');
    // Chargement des codes couleurs, surbrillance - spcifique par compte !!!
    var ltopNformatcolor = OGPlugin_getCharPref("OGPlugin.settings.topNformatcolor"+paraccountrank, "olive", 'OGPlugin-topNformatcolor');

    var lfriendlyformatcolor = OGPlugin_getCharPref("OGPlugin.settings.friendlyformatcolor"+paraccountrank, "limegreen", 'friendlyformatcolor');

    var lenemyformatcolor = OGPlugin_getCharPref("OGPlugin.settings.enemyformatcolor"+paraccountrank, "red", 'OGPlugin-enemyformatcolor');
    
    var lpnaformatcolor = OGPlugin_getCharPref("OGPlugin.settings.pnaformatcolor"+paraccountrank, "deepskyblue", 'OGPlugin-pnaformatcolor');

    var ltradingformatcolor = OGPlugin_getCharPref("OGPlugin.settings.tradingformatcolor"+paraccountrank, "gold", 'OGPlugin-tradingformatcolor');
    
    var ldebrisfieldcolor = OGPlugin_getCharPref("OGPlugin.settings.debrisfieldcolor"+paraccountrank, "gold", 'OGPlugin-debrisfieldcolor');

    // Chargement des indices de couleur
    var ltopNformatindex = OGPlugin_getIntPref("OGPlugin.settings.topNformatindex"+paraccountrank, 83, '');
    document.getElementById("OGPlugin-topNformatcolor").selectedIndex = ltopNformatindex;

    var lfriendlyformatindex = OGPlugin_getIntPref("OGPlugin.settings.friendlyformatindex"+paraccountrank, 74, '');
    document.getElementById("OGPlugin-friendlyformatcolor").selectedIndex = lfriendlyformatindex;
        
    var lenemyformatindex = OGPlugin_getIntPref("OGPlugin.settings.enemyformatindex"+paraccountrank, 35, '');
    document.getElementById("OGPlugin-enemyformatcolor").selectedIndex = lenemyformatindex;

    var lpnaformatindex = OGPlugin_getIntPref("OGPlugin.settings.pnaformatindex"+paraccountrank, 100, '');
    document.getElementById("OGPlugin-pnaformatcolor").selectedIndex = lpnaformatindex;

    var ltradingformatindex = OGPlugin_getIntPref("OGPlugin.settings.tradingformatindex"+paraccountrank, 60, '');
    document.getElementById("OGPlugin-tradingformatcolor").selectedIndex = ltradingformatindex;
    
    var ldebrisfieldcolorindex = OGPlugin_getIntPref("OGPlugin.settings.debrisfieldcolorindex"+paraccountrank, 60, '');
    document.getElementById("OGPlugin-debrisfieldcolor").selectedIndex = ldebrisfieldcolorindex;
    
    // Ajustement des couleurs de contrles
    OGPlugin_SetGroupControlsColor( ltopNformatcolor, 'topN', ltopNformatindex);
    OGPlugin_SetGroupControlsColor( lfriendlyformatcolor, 'friendly', lfriendlyformatindex);
    OGPlugin_SetGroupControlsColor( lenemyformatcolor, 'enemy', lenemyformatindex);
    OGPlugin_SetGroupControlsColor( lpnaformatcolor, 'pna', lpnaformatindex);
    OGPlugin_SetGroupControlsColor( ltradingformatcolor, 'trading', ltradingformatindex);

    OGPlugin_SetGroupControlsColor( ldebrisfieldcolor, 'debris', ldebrisfieldcolorindex);

}

/**
 * Sauvegarde les couleurs choisies et leurs indices correspondant  un compte slectionn
 **/
function OGPlugin_SaveAccountCatsColorsOptions(paraccountrank) { // paraccountrank de 1  7
    var prefs = OGPlugin_getPrefs();

    // sauvegarde des codes couleurs, surbrillance - spcifique par compte !!!
    if (document.getElementById("OGPlugin-topNformatcolor").selectedIndex>-1)
       prefs.setCharPref("OGPlugin.settings.topNformatcolor"+paraccountrank, document.getElementById("OGPlugin-topNformatcolor").value);
    else prefs.setCharPref("OGPlugin.settings.topNformatcolor"+paraccountrank,"olive");
    
    if (document.getElementById("OGPlugin-friendlyformatcolor").selectedIndex>-1)
        prefs.setCharPref("OGPlugin.settings.friendlyformatcolor"+paraccountrank, document.getElementById("OGPlugin-friendlyformatcolor").value);
    else prefs.setCharPref("OGPlugin.settings.friendlyformatcolor"+paraccountrank,"limegreen");
    
    if (document.getElementById("OGPlugin-enemyformatcolor").selectedIndex>-1)
        prefs.setCharPref("OGPlugin.settings.enemyformatcolor"+paraccountrank, document.getElementById("OGPlugin-enemyformatcolor").value);
    else prefs.setCharPref("OGPlugin.settings.enemyformatcolor"+paraccountrank,"red");
    
    if (document.getElementById("OGPlugin-pnaformatcolor").selectedIndex>-1)
        prefs.setCharPref("OGPlugin.settings.pnaformatcolor"+paraccountrank, document.getElementById("OGPlugin-pnaformatcolor").value);
    else prefs.setCharPref("OGPlugin.settings.pnaformatcolor"+paraccountrank,"deepskyblue");
    
    if (document.getElementById("OGPlugin-tradingformatcolor").selectedIndex>-1)
        prefs.setCharPref("OGPlugin.settings.tradingformatcolor"+paraccountrank, document.getElementById("OGPlugin-tradingformatcolor").value);
    else prefs.setCharPref("OGPlugin.settings.tradingformatcolor"+paraccountrank,"gold");

    if (document.getElementById("OGPlugin-debrisfieldcolor").selectedIndex>-1)
        prefs.setCharPref("OGPlugin.settings.debrisfieldcolor"+paraccountrank, document.getElementById("OGPlugin-debrisfieldcolor").value);
    else prefs.setCharPref("OGPlugin.settings.debrisfieldcolor"+paraccountrank,"gold");

    // Sauvegarde des indices de couleur
    /* pas de OGPlugin_setIntPref, selectedindex != value !!!!    */
    if (document.getElementById("OGPlugin-topNformatcolor").selectedIndex>-1)
        prefs.setIntPref("OGPlugin.settings.topNformatindex"+paraccountrank, document.getElementById("OGPlugin-topNformatcolor").selectedIndex);
        //OGPlugin_setIntPref("OGPlugin.settings.topNformatindex"+paraccountrank, 83, 'OGPlugin-topNformatcolor');
        
    if (document.getElementById("OGPlugin-friendlyformatcolor").selectedIndex>-1)
        prefs.setIntPref("OGPlugin.settings.friendlyformatindex"+paraccountrank, document.getElementById("OGPlugin-friendlyformatcolor").selectedIndex);
        //OGPlugin_setIntPref("OGPlugin.settings.friendlyformatindex"+paraccountrank, 74, 'OGPlugin-friendlyformatcolor');
        
    if (document.getElementById("OGPlugin-enemyformatcolor").selectedIndex>-1)
        prefs.setIntPref("OGPlugin.settings.enemyformatindex"+paraccountrank, document.getElementById("OGPlugin-enemyformatcolor").selectedIndex);
        //OGPlugin_setIntPref("OGPlugin.settings.enemyformatindex"+paraccountrank, 35, 'OGPlugin-enemyformatcolor');
        
    if (document.getElementById("OGPlugin-pnaformatcolor").selectedIndex>-1)
        prefs.setIntPref("OGPlugin.settings.pnaformatindex"+paraccountrank, document.getElementById("OGPlugin-pnaformatcolor").selectedIndex); // set a pref
        //OGPlugin_setIntPref("OGPlugin.settings.pnaformatindex"+paraccountrank, 100, 'OGPlugin-pnaformatcolor');
        
    if (document.getElementById("OGPlugin-tradingformatcolor").selectedIndex>-1)
        prefs.setIntPref("OGPlugin.settings.tradingformatindex"+paraccountrank, document.getElementById("OGPlugin-tradingformatcolor").selectedIndex); // set a pref
        //OGPlugin_setIntPref("OGPlugin.settings.tradingformatindex"+paraccountrank, 60, 'OGPlugin-tradingformatcolor');

    if (document.getElementById("OGPlugin-debrisfieldcolor").selectedIndex>-1)
        prefs.setIntPref("OGPlugin.settings.debrisfieldcolorindex"+paraccountrank, document.getElementById("OGPlugin-debrisfieldcolor").selectedIndex); // set a pref

}

/**
 * Panneau Options / Onglet Surbrillance
 * Charge et affiche en bloc toutes les paramtres de surbrillance associ au compte choisi,
 * options boolennes et chanes listes.
 * @param serverid entier reprsente l'indice du compte choisi
 **/
function OGPlugin_LoadServerIdFormatsParams(serverid) { // serverid de 1  7, ajust dans onclick OGPlugin-chooseserveridformats
    if (serverid<1 || serverid>7) return -1;
    currentserveridopts=serverid;
    var prefs = OGPlugin_getPrefs();
    //alert("OGPlugin_LoadServerIdFormatsParams: "+serverid);

    //Pages galaxies, options gnrales
    // Joueurs
    //prefs.setBoolPref("OGPlugin.settings.brighuntilrankplayer"+paraccountrank, document.getElementById("OGPlugin-brighuntilrankplayer").checked);
    OGPlugin_getBoolPref("OGPlugin.settings.brighuntilrankplayer"+serverid, true, 'OGPlugin-brighuntilrankplayer');
    //prefs.setIntPref("OGPlugin.settings.playerranklimit"+paraccountrank, document.getElementById("OGPlugin-playerranklimit").value);
    OGPlugin_getIntPref("OGPlugin.settings.playerranklimit"+serverid, 100, 'OGPlugin-playerranklimit');
    //prefs.setBoolPref("OGPlugin.settings.echorankplayer"+paraccountrank, document.getElementById("OGPlugin-echorankplayer").checked);
    OGPlugin_getBoolPref("OGPlugin.settings.echorankplayer"+serverid, true, 'OGPlugin-echorankplayer');

    // Alliances
    //prefs.setBoolPref("OGPlugin.settings.brighuntilrankally"+paraccountrank, document.getElementById("OGPlugin-brighuntilrankally").checked);
    OGPlugin_getBoolPref("OGPlugin.settings.brighuntilrankally"+serverid, true, 'OGPlugin-brighuntilrankally');
    //prefs.setIntPref("OGPlugin.settings.allyranklimit"+paraccountrank, document.getElementById("OGPlugin-allyranklimit").value);
    OGPlugin_getIntPref("OGPlugin.settings.allyranklimit"+serverid, 20, 'OGPlugin-allyranklimit');
    //prefs.setBoolPref("OGPlugin.settings.echorankally"+paraccountrank, document.getElementById("OGPlugin-echorankally").checked);
    OGPlugin_getBoolPref("OGPlugin.settings.echorankally"+serverid, true, 'OGPlugin-echorankally');

    // Ogame Galaxy Pages
    // Joueurs amis
    OGPlugin_getBoolPref("OGPlugin.settings.brightfriendlyplayer"+serverid, true, 'OGPlugin-brightfriendlyplayer');
    OGPlugin_getCharPref("OGPlugin.settings.friendlyplayerslist"+serverid, '', 'OGPlugin-friendlyplayerslist');

    // joueurs enemis
    OGPlugin_getBoolPref("OGPlugin.settings.brightenemyplayer"+serverid, true, 'OGPlugin-brightenemyplayer');
    OGPlugin_getCharPref("OGPlugin.settings.enemyplayerslist"+serverid, '', 'OGPlugin-enemyplayerslist');

    // joueurs commerciaux
    OGPlugin_getBoolPref("OGPlugin.settings.brighttradingplayer"+serverid, true, 'OGPlugin-brighttradingplayer');
    OGPlugin_getCharPref("OGPlugin.settings.tradingplayerslist"+serverid, '', 'OGPlugin-tradingplayerslist');

    // Surbrillance par classement et affichage de rang
    OGPlugin_getBoolPref("OGPlugin.settings.brighttopNplayers"+serverid, true, 'OGPlugin-brighttopNplayers');

    // options consultation serveur - obsolte
    OGPlugin_getBoolPref("OGPlugin.settings.brightogspyfriendlyally"+serverid, true, 'OGPlugin-brightogspyfriendlyally');
    OGPlugin_getBoolPref("OGPlugin.settings.brightogspypnaally"+serverid, true, 'OGPlugin-brightogspypnaally');
    OGPlugin_getBoolPref("OGPlugin.settings.brightogspyenemyally"+serverid, true, 'OGPlugin-brightogspyenemyally');
    OGPlugin_getBoolPref("OGPlugin.settings.brightogspytradingally"+serverid, true, 'OGPlugin-brightogspytradingally');

    // alliances amis
    OGPlugin_getBoolPref("OGPlugin.settings.brightfriendlyally"+serverid, true, 'OGPlugin-brightfriendlyally');
    OGPlugin_getCharPref("OGPlugin.settings.friendlyallyslist"+serverid, '', 'OGPlugin-friendlyallyslist');

    // alliances enemies
    OGPlugin_getBoolPref("OGPlugin.settings.brightenemyally"+serverid, true, 'OGPlugin-brightenemyally');
    OGPlugin_getCharPref("OGPlugin.settings.enemyallyslist"+serverid, '', 'OGPlugin-enemyallyslist');

    // alliances tradings
    OGPlugin_getBoolPref("OGPlugin.settings.brighttradingally"+serverid, true, 'OGPlugin-brighttradingally');
    OGPlugin_getCharPref("OGPlugin.settings.tradingallyslist"+serverid, '', 'OGPlugin-tradingallyslist');

    // paramtres champs de ruine
    OGPlugin_getBoolPref("OGPlugin.settings.docolordebrisfield"+serverid, false, 'OGPlugin-docolordebrisfield');
    OGPlugin_getCharPref("OGPlugin.settings.debrisfieldminvalue"+serverid, 20000, 'OGPlugin-debrisfieldminvalue');
    OGPlugin_getCharPref("OGPlugin.settings.debrisfieldcolor"+serverid, 'red', 'OGPlugin-debrisfieldcolor');
    
    // Chargement des noms et indices de couleur
    OGPlugin_LoadAccountCatsColorsOptions(serverid);
}

/**
 * Panneau Options / Onglet Surbrillance
 * Enregistre en bloc toutes les paramtres de surbrillance associ au compte choisi,
 * options boolennes et chanes listes.
 * @param serverid entier reprsente l'indice du compte choisi
 **/
function OGPlugin_SaveServerIdFormatsParams(serverid) { // serverid de 1  7
    if (serverid<1 || serverid>7) return -1; // si aucun choix valable, on quitte

    var prefs = OGPlugin_getPrefs();
    //alert("OGPlugin_SaveServerIdFormatsParams: "+serverid);

    //Pages galaxies, options gnrales
    // Joueurs - couleur par rang, rang
    prefs.setBoolPref("OGPlugin.settings.brighuntilrankplayer"+serverid, document.getElementById("OGPlugin-brighuntilrankplayer").checked);
    prefs.setIntPref("OGPlugin.settings.playerranklimit"+serverid, document.getElementById("OGPlugin-playerranklimit").value);
    prefs.setBoolPref("OGPlugin.settings.echorankplayer"+serverid, document.getElementById("OGPlugin-echorankplayer").checked);

    // Alliances - couleur par rang, rang
    prefs.setBoolPref("OGPlugin.settings.brighuntilrankally"+serverid, document.getElementById("OGPlugin-brighuntilrankally").checked);
    prefs.setIntPref("OGPlugin.settings.allyranklimit"+serverid, document.getElementById("OGPlugin-allyranklimit").value);
    prefs.setBoolPref("OGPlugin.settings.echorankally"+serverid, document.getElementById("OGPlugin-echorankally").checked);

    //Ogame Galaxy Pages
    // "friendly" players data - mettre en couleur? et liste des noms de joueurs
    prefs.setBoolPref("OGPlugin.settings.brightfriendlyplayer"+serverid, document.getElementById("OGPlugin-brightfriendlyplayer").checked);
    prefs.setCharPref("OGPlugin.settings.friendlyplayerslist"+serverid, decodeURIComponent(OGPlugin_getValue("OGPlugin-friendlyplayerslist"))); // set a pref

    // "enemy" players data - mettre en couleur? et liste des noms de joueurs
    prefs.setBoolPref("OGPlugin.settings.brightenemyplayer"+serverid, document.getElementById("OGPlugin-brightenemyplayer").checked);
    prefs.setCharPref("OGPlugin.settings.enemyplayerslist"+serverid, decodeURIComponent(OGPlugin_getValue("OGPlugin-enemyplayerslist"))); // set a pref

    // "trading" players data - mettre en couleur? et liste des noms de joueurs
    prefs.setBoolPref("OGPlugin.settings.brighttradingplayer"+serverid, document.getElementById("OGPlugin-brighttradingplayer").checked);
    prefs.setCharPref("OGPlugin.settings.tradingplayerslist"+serverid, decodeURIComponent(OGPlugin_getValue("OGPlugin-tradingplayerslist"))); // set a pref


    // options mise en surbrillance tags centraliss ?
    prefs.setBoolPref("OGPlugin.settings.brightogspyfriendlyally"+serverid, document.getElementById("OGPlugin-brightogspyfriendlyally").checked);
    prefs.setBoolPref("OGPlugin.settings.brightogspypnaally"+serverid, document.getElementById("OGPlugin-brightogspypnaally").checked);
    prefs.setBoolPref("OGPlugin.settings.brightogspyenemyally"+serverid, document.getElementById("OGPlugin-brightogspyenemyally").checked);
    prefs.setBoolPref("OGPlugin.settings.brightogspytradingally"+serverid, document.getElementById("OGPlugin-brightogspytradingally").checked);

    // "friendly" alliance data - mettre en couleur? et liste des tags d'alliance
    prefs.setBoolPref("OGPlugin.settings.brightfriendlyally"+serverid, document.getElementById("OGPlugin-brightfriendlyally").checked);
    prefs.setCharPref("OGPlugin.settings.friendlyallyslist"+serverid, decodeURIComponent(OGPlugin_getValue("OGPlugin-friendlyallyslist"))); // set a pref

    // "enemy" alliance data - mettre en couleur? et liste des tags d'alliance
    prefs.setBoolPref("OGPlugin.settings.brightenemyally"+serverid, document.getElementById("OGPlugin-brightenemyally").checked);
    prefs.setCharPref("OGPlugin.settings.enemyallyslist"+serverid, decodeURIComponent(OGPlugin_getValue("OGPlugin-enemyallyslist"))); // set a pref

    // "trading" alliance data - mettre en couleur? et liste des tags d'alliance
    prefs.setBoolPref("OGPlugin.settings.brighttradingally"+serverid, document.getElementById("OGPlugin-brighttradingally").checked);
    prefs.setCharPref("OGPlugin.settings.tradingallyslist"+serverid, decodeURIComponent(OGPlugin_getValue("OGPlugin-tradingallyslist"))); // set a pref

    // paramtres champs de ruine
    OGPlugin_setBoolPref("OGPlugin.settings.docolordebrisfield"+serverid, false, 'OGPlugin-docolordebrisfield');
    OGPlugin_setCharPref("OGPlugin.settings.debrisfieldminvalue"+serverid, 20000, 'OGPlugin-debrisfieldminvalue');
    OGPlugin_setCharPref("OGPlugin.settings.debrisfieldcolor"+serverid, 'red', 'OGPlugin-debrisfieldcolor');


    // Sauvegarde des noms et indices de couleur
    OGPlugin_SaveAccountCatsColorsOptions(serverid);

    currentserveridopts = -1; // permet de ne pas sauvegarder en cliquant sur le bouton OK du panneau options
}

/**
 * Rinitialise les proprit de l'onglet Analyse'
 **/
function OGPlugin_ResetAnalysisOptions_OnClick(pargameid) {
    /*if (pargameid == 'ogame') {
        // Donnes galaxie
        document.getElementById("OGPlugin-galpagetablerank").value = ogs_GalaxyPageRankTab;
        document.getElementById("OGPlugin-ogamegalaxypath").value = ogs_PathtoGalaxyTable;
        
        // Donnes statistiques
        document.getElementById("OGPlugin-statspagetablerank").value = ogs_StatsPageRankTab;
        document.getElementById("OGPlugin-ogamestatspath").value = ogs_PathtoStatsTable;
        
        // Donnes messages
        document.getElementById("OGPlugin-messagestablerank").value = ogs_MsgPageRankTab;
        document.getElementById("OGPlugin-ogamereportspath").value = ogs_PathtoMessageTable;
        
        // Donnes historique alliance
        document.getElementById("OGPlugin-allyhisttablerank").value = ogs_AllyHistRankTab;
        document.getElementById("OGPlugin-ogameallyhistpath").value = ogs_PathtoAllyHistTable;
        
        // Donnes btiments
        document.getElementById("OGPlugin-buildingpagetablerank").value = ogs_BuildingPageRankTab;
        document.getElementById("OGPlugin-ogamebuidlingpath").value = ogs_PathtoBuildingTable;

        // Donnes Laboratoire
        document.getElementById("OGPlugin-technopagetablerank").value = ogs_TechnoPageRankTab;
        document.getElementById("OGPlugin-ogamelabopath").value = ogs_PathtoLaboTable;
        
        // Donnes Flotte
        document.getElementById("OGPlugin-fleetpagetablerank").value = ogs_FleetPageRankTab;
        document.getElementById("OGPlugin-ogamefleetpath").value = ogs_PathtoFleetVoyaging;
        
        // Donnes Dfense
        document.getElementById("OGPlugin-defencepagetablerank").value = ogs_defencePageRankTab;
        document.getElementById("OGPlugin-ogamedefencepath").value = ogs_PathtodefenceTable;
        
        // Donnes Empire PLantes
        document.getElementById("OGPlugin-planempiretablerank").value = ogs_PlanetEmpireRankTab;
        document.getElementById("OGPlugin-ogameplanempirepath").value = ogs_PathtoEmpireTable;
        
        // Donnes Empire Lunes
        document.getElementById("OGPlugin-moonempiretablerank").value = ogs_MoonEmpireRankTab;
        document.getElementById("OGPlugin-ogamemoonempirepath").value = ogs_PathtoEmpireTable;


    } else */if (pargameid == 'eunivers') {
        // Donnes galaxie
        document.getElementById("OGPlugin-eunivgalaxytablerank").value = eun_GalaxyPageRankTab;
        document.getElementById("OGPlugin-eunivgalaxypath").value = eun_PathtoGalaxyTable;

        // Donnes statistiques
        document.getElementById("OGPlugin-eunivstatspagetablerank").value = eun_StatsPageRankTab;
        document.getElementById("OGPlugin-eunivstatspath").value = eun_PathtoStatsTable;

        // Donnes messages
        document.getElementById("OGPlugin-eunivmessagestablerank").value = eun_MsgPageRankTab;
        document.getElementById("OGPlugin-eunivreportspath").value = eun_PathtoMessageTable;

        // Donnes historique alliance
        document.getElementById("OGPlugin-eunivallyhisttablerank").value = eun_AllyHistRankTab;
        document.getElementById("OGPlugin-eunivallyhistpath").value = eun_PathtoAllyHistTable;

        // Donnes vue globale empire
        document.getElementById("OGPlugin-eunivplanempiretablerank").value = eun_GlobalViewRankTab;
        document.getElementById("OGPlugin-eunivplanempirepath").value = eun_PathtoGlobalViewTable;
    }

}

/**
 * Rcupre le contenu de la proprit value d'un objet XUL de l'interface
 **/
function OGPlugin_getValue(elementID) {
    // Rcupre un descripteur sur l'lment "elementID"
    var textfield = document.getElementById(elementID);
    // Rcupre la valeur en retirant les espaces de dbut et fin
    var string = OGPlugin_TrimString(textfield.value);
    
    // Si aucune url, retourn ""
    // sinon on retourne la valeur convertie pour passage en paramtre
    if(string.length == 0) { return ""; }
    else { return encodeURIComponent(string); }
}


/**
 * fonction affichage pseudo joueur suivant choix compte ogspy
 **/
function OGPlugin_LoadPlayerNick() {
        var accountnumber = document.getElementById("OGPlugin-playernickbox").selectedIndex+1;        
        document.getElementById("OGPlugin-playernickedit").disabled=false;
        // indice de 1  7
        OGPlugin_getCharPref('OGPlugin.settings.playernick'+accountnumber, '', 'OGPlugin-playernickedit');
}

/**
 * fonction sauvegarde pseudo joueur suivant choix compte ogspy
 **/
function OGPlugin_SavePlayerNick() {
        var accountnumber = document.getElementById("OGPlugin-playernickbox").selectedIndex+1;
        var playernick = document.getElementById("OGPlugin-playernickedit").value;
        // indice de 1  7
        OGPlugin_setCharPref('OGPlugin.settings.playernick'+accountnumber, playernick, '');
}

/**
 * Interprte textuellement les rponses au commandes envoyes  une adresse ogspy(mod ogsplugin)
 **/
function OGPlugin_NotifyOgspyURLResponse(parresp_str) {
        if (parresp_str == '') {
            alert("Le serveur n'a retourn\u00e9 aucune r\u00e9ponse!\nVeuillez v\u00e9rifier l'adresse.");
            return false;
        } else if (parresp_str == '750' || parresp_str == '!750') {
            alert("Le serveur n'\u00e9tait pas disponible et n'a pas r\u00e9pondu!\nVeuillez v\u00e9rifier l'adresse.");
            return false;
        } else if (parresp_str == '!404') {
            alert("L'adresse du serveur ou son UID OGS for All est incorrecte!\nVeuillez v\u00e9rifier l'adresse.");
            return false;
        } else if (parresp_str == '!!!!!' ) {
            alert("Une erreur est survenue lors de l'interrogation du serveur!\nLe serveur est peut-\u00eatre hors ligne ou son adresse est incorrecte.");
            return false;
        } else if (parresp_str == 'X' || parresp_str == '!405') {
            alert("L'adresse du serveur  n'est pas celle d'un serveur OGSPY!\nVeuillez v\u00e9rifier l'adresse.");
            return false;
        }
        return true;
}

/**
 * mthode vnement de rponse au changement d'adresse ogspy et entre d'un code UID OGS for All
 **/
function OGPlugin_ServerUrls_Onchange(parnumservernum) {
        askforogameserverinfo = false;
        askforplayernick = false;
        isaccountvalid = true;
        isogsforallaccount = false;
        var ogameserver_prompt = "Veuillez saisir le nom de serveur Ogame\n(demandez  votre administrateur on consulter le tutoriel):";
        
        // dtection UID OGS for All
        var UIDtotest = document.getElementById("OGPlugin-url"+parnumservernum).value;
        
        if (UIDtotest.length==10 && UIDtotest.match(UIDRegExp) != null) {
            document.getElementById("OGPlugin-ogameurl"+parnumservernum).value = '';
        
            if (confirm('Un code de type UID OGSPY For All a \u00e9t\u00e9 d\u00e9tect\u00e9.\nValider par OK si c\'est exact,\nou cliquer sur annuler pour entrer une adresse correcte \u00abhttp://...\u00bb')) {
                isogsforallaccount = true;
                callingurl = 'http://www.ogsforall.com/'+UIDtotest+'/ogsplugin.php';
                askforplayernick = true; // demande de saisie du nom de jeu Ogame
            } else { // erreur de saisie de l'utilisateur
                document.getElementById("OGPlugin-url"+parnumservernum).value = '';
                OGPlugin_HideOgameParControls(parnumservernum, false, true);
                return -1; // quitte, l'utilisateur l'a choisi
            }
        } else if (UIDtotest.match(RegExpOGSPYStdUrl) != null) {
            alert("Une adresse standard de portail OGSpy/UniSPy semble avoir \u00e9t\u00e9 saisie.\nCelle-ci sera modifi\u00e9e pour se terminer par ogsplugin.php.");
            lnewurl = UIDtotest.replace('index', 'ogsplugin');
            callingurl = lnewurl;
            document.getElementById("OGPlugin-url"+parnumservernum).value = lnewurl;
        } else if (UIDtotest.match(RegExpOGSPYUrl) != null) {
              //alert("L'adresse du serveur(module OGS/Xtense) est correcte!");
              callingurl = UIDtotest;
        } else isaccountvalid = false;
        //if (ogs_ogspyforallconfig_debugmode==true) alert(UIDtotest);
        //======================================================================

        if (isaccountvalid == true) {
            serverurlchanged[parnumservernum-1]=true; // voir numserverurl -> numserverurl-1 pour array
            respcode_msg = "";
            if (isogsforallaccount)
                OGPlugin_SetAutoConfigOptions(); // positionnement des options par dfaut recommandes
            
            // rcuprer le nom serveuur ogame et numro:
            // module ogs pas  jour sur ofa, utiliser http://localhost/Ogame/OGSPY/ogsplugin.php

            res_OgameServerNameNum = OGPlugin_GetOgameServerNameNum(parnumservernum, callingurl );
            // var resp_servername = OGPlugin_DlgSendGetCommand(callingurl, 'getogameserver' , true, true); // adresse de test
            
            // vrifier les rponses du serveur!
            while (callingurl!=null && res_OgameServerNameNum[3]=='!404') {
                    if (isogsforallaccount) {
                        UIDtoget = prompt("Le code saisi est incorrect ou le compte O.f.A n'existe pas/plus\nou le module OGS Plugin est corrompu ou absent sur ce serveur.\n\nEntrer de nouveau le code UID OGS for All.","");
                        if (UIDtoget!=null) {
                            document.getElementById("OGPlugin-url"+parnumservernum).value = UIDtoget;
                            callingurl = 'http://www.ogsforall.com/'+UIDtoget+'/ogsplugin.php';
                        } else callingurl = null;
                    } else {
                          callingurl = prompt("Aucun serveur OGSPY n'a \u00e9t\u00e9 trouv\u00e9 \u00e0 cette adresse.\n"+
                                                  "L'adresse est incorrecte ou le module OGS Plugin n'est pas install\u00e9/activ\u00e9!\n"+
                                                  "\nVeuillez la saisir de nouveau dans la zone pr\u00e9vue \u00e0 cet effet.","");
                          if (callingurl!=null) document.getElementById("OGPlugin-url"+parnumservernum).value = callingurl;
                    }
                    // rappel du serveur pour demande de nom de serveur ogame
                    if (callingurl==null) return false; // l'utilisateur a annul
                    else res_OgameServerNameNum = OGPlugin_GetOgameServerNameNum(parnumservernum, callingurl );
            }
            
            // vrifier autres codes rponse
            if (res_OgameServerNameNum[3].substring(0,3)=='750') {
                //document.getElementById("OGPlugin-ogameurl"+parnumservernum).value='????????';
                respcode_msg = "Les informations sur l'univers de jeu n'ont pu \u00eatre r\u00e9cup\u00e9r\u00e9es\ncar le serveur OGSPY/O.f.A n'\u00e9tait pas disponible.\n\n";
            } else if (res_OgameServerNameNum[3]=='') {
                respcode_msg = "Le serveur contact\u00e9 n'a retourn\u00e9 aucune r\u00e9ponse!\n\n";
            }
            

            resp_code = res_OgameServerNameNum[3];

            if (res_OgameServerNameNum[0]==true) { // rsultat principal traitement auto ok
                ogameservernum = res_OgameServerNameNum[1];
                ogameservername = res_OgameServerNameNum[2];
            
                // rcupration ok, on intervertit l'affichage des contrle bote univers
                OGPlugin_HideOgameParControls(parnumservernum, true, false);
                
                askforogameserverinfo = false;
            } else { // recup auto choue, demande de saisie manuelle
                // rcupration choue, on intervertit l'affichage des contrle bote univers
                OGPlugin_HideOgameParControls(parnumservernum, false, true);
                askforogameserverinfo = true;
            }

            // Rcupration du nom du serveur et de sa version (automatique)
            var res_tab = OGPlugin_GetServerNameVer(parnumservernum, callingurl);
            if (ogs_optionpopups_debugmode==true) alert("Rponse: "+res_tab[0]);
            if (res_tab[0]==true) {
                document.getElementById("OGPlugin-url"+parnumservernum).setAttribute("tooltiptext", res_tab[1]+" ("+res_tab[2]+")");
                document.getElementById("OGPlugin-version"+parnumservernum).value = res_tab[2];
            }

            if (askforogameserverinfo==true) {
                // mmesages de boite  revoir
                respcode_failure_msg="\nLa configuration automatique avec le serveur a \u00e9chou\u00e9";
                if (res_OgameServerNameNum[3]=='!!!!') respcode_failure_msg += " parce que le serveur n'a pas r\u00e9pondu.\nL'adresse pourrait ne pas exister, veuillez v\u00e9rifier l'adresse avant de poursuivre(Annuler).\n\n";
                else if (res_OgameServerNameNum[3].substr(0,1)=='X') respcode_failure_msg += " parce que l'adresse est incomplte ou fausse.\n\n";
                else if (res_OgameServerNameNum[3].substr(0,4)=='!404' || res_OgameServerNameNum[3].substr(0,4)=='!405') respcode_failure_msg += " parce que l'adresse du serveur semble incorrecte.\n\n";
                else if (res_OgameServerNameNum[3].substr(0,3)=='796') respcode_failure_msg += " parce que le module de liaison OGS Plugin n'est pas install\u00e9 ou inactif.\n\n";
                else respcode_failure_msg += ".\n"+res_OgameServerNameNum[3]+"\n";
                //respcode_msg = respcode_failure_msg;
                var pleasefillin_manually = "Veuillez saisir le nom de serveur Ogame ou contactez votre administrateur,\nou consultez la liste des univers en fin de tutoriel.";

                ogameserver_prompt = respcode_msg+pleasefillin_manually;
            
                // demande de saisie du nom de serveur Ogame
                ogameservername = prompt(respcode_failure_msg+ogameserver_prompt,"");
                // vrifier que le serveur ogame saisi est correct
                while (ogameservername!=null && OGPlugin_CheckGameServerSyntax(ogameservername)===false)
                    ogameservername = prompt("Le serveur Ogame saisi n'est pas correct.\n\n"+ogameserver_prompt,"");
                if (ogameservername!=null) {
                    document.getElementById("OGPlugin-ogameurl"+parnumservernum).value=ogameservername;
                    //demande de saisie du numro d'univers Ogame
                    ogameservernum = prompt("Veuillez saisir le num\u00e9ro d'univers associ\u00e9 \u00e0 "+ogameservername,"");
                    if (ogameservernum!=null) { // rponse correcte
                        ogs_numuniv_tab[parnumservernum-1] = parseInt(ogameservernum);
                    }
                }
            }
            
            // affichage des infos serveur ogame + numro univers
            if (ogameservername==null) ogameservername='????????';
            if (ogameservernum==null) ogameservernum='??';
            document.getElementById("OGPlugin-ogameurl"+parnumservernum).value = ogameservername;
            if (isogsforallaccount)
                document.getElementById("OGPlugin-ogspyforall"+parnumservernum).value = "OGS for All: U"+ogameservernum;
            else document.getElementById("OGPlugin-ogspyforall"+parnumservernum).value = "Univers: "+ogameservernum;
            ogs_numuniv_tab[parnumservernum-1] = parseInt(res_OgameServerNameNum[1]); // mise de ct du no d'univers
            
            // saisie nom utilisateur ogspy et mot de passe
            username = prompt("Veuillez saisir votre identifiant OGSPY ou O.f.A:", document.getElementById("OGPlugin-username"+parnumservernum).value);
            if (username!=null) {
                document.getElementById("OGPlugin-username"+parnumservernum).value = username;
                userpassword = prompt("Veuillez saisir votre mot de passe:\n(Respectez la distinction MAJUSCULE/minuscule et\nv\u00e9rifiez apr\u00e8s validation que vous souhaitez crypter cette donn\u00e9e)", "");
                if (userpassword!=null) {
                    document.getElementById("OGPlugin-password"+parnumservernum).value = userpassword;
                    passwordchangedtab[parnumservernum-1]=true; // ajuster la valeur pour l'enregistrement final
                    cryptedcheckbox = document.getElementById("OGPlugin-iscryptedpass"+parnumservernum);
                    cryptedcheckbox.setAttribute("disabled", false);
                    cryptedcheckbox.checked = false;
                }
            }
            
            if (askforplayernick==true) OGPlugin_AskPlayerNick_OnClick(parnumservernum);
            
            // config surbrillance?
            if (confirm("A ce stade, la configuration principale du compte est termin\u00e9e!\n\n"+
                "Souhaitez-vous acc\u00e9der \u00e0 l'onglet surbrillance de ce compte\nafin de configurer les options par d\u00e9faut?")) {
                OGPlugin_DoHighlightingConfigForAccount_OnClick(parnumservernum);
            }
        } // fin isaccountvalid == true;
}

/**
 * Slectionne le compte correspondant  l'indice et affiche l'onglet Surbrillance
 * @param paraccountnum entier court naturel : reprsente l'incide d'une ligne de compte
 **/
function OGPlugin_DoHighlightingConfigForAccount_OnClick(paraccountnum) {

        if (OGPlugin_setBoolPref('OGPlugin.settings.enablehighlighting', true, 'OGPlugin-enablehighlighting')) {
            document.getElementById('OGPlugin-tabbox_options').selectedIndex = 7;
            document.getElementById('OGPlugin-chooseserveridformats').selectedIndex = paraccountnum-1;
            OGPlugin_LoadServerIdFormatsParams(paraccountnum);
        } else alert("La surbrillance n'est pas activ\u00e9e!\nVeuillez cocher l'option correspondante dans l'onglet G\u00e9n\u00e9ral.");

}

/**
 * Modifie le nom de serveur Ogame pour activer/dsactiver le compte
 * ajoute deux pour dsactiver, les enlve pour activer
 **/
function OGPlugin_SetAccountState_OnClick(parnumservernum, parenable) {

          // dfinir  vrai pour empcher la demande de pseudo si nom serveur correcte(ractivation)
          ogs_changingaccountstate = true; 
          logameserver = document.getElementById('OGPlugin-ogameurl'+parnumservernum).value;
          lofaservernum_caption = document.getElementById('OGPlugin-ogspyforall'+parnumservernum).value;
          
          if (parenable==true) {
              gameserver_extrachars = logameserver.match(/^(?:[\w,\d,\.,\-,_]+[a-z,A-Z]+)([_,\+,\-]+)$/);
              if (gameserver_extrachars!=null)
                  logameserver = logameserver.replace(gameserver_extrachars[1], '');
              // else alert("erreur  OGPlugin_SetAccountState_OnClick:"+gameserver_extrachars[1]); // ligne debug

              lofaservernum_caption = lofaservernum_caption.replace(/\(X\)/g, '');
              
              document.getElementById("OGPlugin-ogameurl"+parnumservernum).value = logameserver;
              document.getElementById("OGPlugin-ogspyforall"+parnumservernum).value = lofaservernum_caption;
              if (OGPlugin_CheckGameServerSyntax(logameserver)===false) {
                  OGPlugin_HideOgameParControls(parnumservernum, false, true);
                  alert("OGPlugin_SetAccountState_OnClick: erreur "+logameserver);
                  alert("Le serveur de jeu (Ogame/E-Univers) n'est pas reconnu.\nVerifier la zone de saisie n\u00b0"+parnumservernum+"!");
              }
          } else {
              lofaservernum_caption = lofaservernum_caption.replace(/\(\X\)/g, ''); // filtre au cas o
              document.getElementById("OGPlugin-ogspyforall"+parnumservernum).value = lofaservernum_caption + '(X)';

              logameserver = document.getElementById("OGPlugin-ogameurl"+parnumservernum).value;
              document.getElementById("OGPlugin-ogameurl"+parnumservernum).value = logameserver+'__';
          }
          ogs_changingaccountstate=false;
}

function OGPlugin_SetAllAccountsState_OnClick(parenable) {
          for (cpt=1;cpt<8;cpt++) OGPlugin_SetAccountState_OnClick(cpt, parenable);
}

/**
 * dsactive des comptes prcdents associs  un mme serveur ogame afin de rendre le compte indic principal
 **/
function OGPlugin_SetAccountPrimary_OnClick(parnumservernum) {

        OGPlugin_SetAccountState_OnClick(parnumservernum, true);
        logameserver = document.getElementById("OGPlugin-ogameurl"+parnumservernum).value;
        
        if (logameserver == '') {
            alert("L'adresse du serveur OGSPY n\u00b0"+parnumservernum+" n'est pas renseign\u00e9e!");
            return false;
        }
        
        for (cpt=parnumservernum-1;cpt>0;cpt--) {
            curogameserver = document.getElementById("OGPlugin-ogameurl"+cpt).value;
            if (OGPlugin_IsNCSStringEquals(logameserver , curogameserver)) OGPlugin_SetAccountState_OnClick(cpt, false);
        }

}

/**
 * effacer une ligne de compte entire en dcochant et en effaant les donnes
 **/
function OGPlugin_ClearAccountLine_OnClick(parnumservernum) {
        document.getElementById("OGPlugin-isstatserver"+parnumservernum).checked = false;
        document.getElementById("OGPlugin-isstatserver"+parnumservernum).setAttribute("disabled", false);
        document.getElementById("OGPlugin-iscryptedpass"+parnumservernum).checked = false;
        document.getElementById("OGPlugin-iscryptedpass"+parnumservernum).setAttribute("disabled", false);
        
        document.getElementById("OGPlugin-ogameurl"+parnumservernum).value = '';
        document.getElementById("OGPlugin-url"+parnumservernum).value = '';
        document.getElementById("OGPlugin-url"+parnumservernum).setAttribute('tooltiptext', '');
        document.getElementById("OGPlugin-username"+parnumservernum).value = '';
        document.getElementById("OGPlugin-password"+parnumservernum).value = '';
        document.getElementById("OGPlugin-version"+parnumservernum).value = '';
        OGPlugin_HideOgameParControls(parnumservernum, false, true);

}

/**
 *  efface toutes les lignes de compte et les donnes associes.
 **/
function OGPlugin_ClearAllAccounts_OnClick() {
        for (cpt=1;cpt<8;cpt++) OGPlugin_ClearAccountLine_OnClick(cpt);
}

/**
 * mthode d'vnement: demander  l'utilisateur de saisir son pseudo de jeu pour la ligne en cours.
 **/
function OGPlugin_AskPlayerNick_OnClick(parnumservernum) {
         playernick = prompt("Compte n\u00b0"+parnumservernum+",\n Saisissez votre pseudo de jeu Ogame ou E-Univers:", "");
         if (playernick != null) {
         ogs_playernicks_tab[parnumservernum-1] = playernick;
         document.getElementById("OGPlugin-username"+parnumservernum).setAttribute("tooltiptext", 'Pseudo de jeu: '+ playernick);
         }
}

/**
 * Change le numro d'tiquette au dessus de la bote de saisie de serveur de jeu.
 **/
function OGPlugin_UniverseLabelChange(paraccountnum, parnewservernum, pargameservername) {
         targetlabel = document.getElementById("OGPlugin-ogspyforall"+paraccountnum).value;
         targetlabel = targetlabel.replace(/\d+/, parnewservernum);
         document.getElementById("OGPlugin-ogspyforall"+paraccountnum).value = targetlabel;
}

/**
 * mthode d'vnement: demander  l'utilisateur de saisir le numro d'univers associ
 **/
function OGPlugin_AskOgameServerNum_OnClick(parnumservernum, parcaption) {
         if (parcaption==null) parcaption = '\n\n';
         else parcaption += '\n\n';

         ogameservernum = parseInt(prompt(parcaption+"Saisissez le num\u00e9ro d'univers associ\u00e9:", ""));
         ogs_numuniv_tab[parnumservernum-1] = ogameservernum;
         serverurlchanged[parnumservernum-1] = true;
         
         OGPlugin_UniverseLabelChange(parnumservernum, ogameservernum, '');

         
         OGPlugin_HideOgameParControls(parnumservernum, true, false);
}

/**
 * action popup: interroger serveur pour nom serveur ogame (mthode popup)
 **/
function OGPlugin_GetGameServerName_OnClick(parnumservernum) {
        if (ogs_optionpopups_debugmode==true) alert("OGPlugin_GetGameServerName_OnClick: "+parnumservernum);
        
        callingurl = OGPlugin_GetOGSPYUrl(parnumservernum, true);
        if (callingurl == '') {
            alert("L'adresse du serveur OGSPY n\u00b0"+parnumservernum+" n'est pas renseign\u00e9e!");
            return false;
        }
        var res_OgameServerNameNum =  OGPlugin_GetOgameServerNameNum(parnumservernum, callingurl);
        if (res_OgameServerNameNum[0]==true) {
            ogs_numuniv_tab[parnumservernum-1] = parseInt(res_OgameServerNameNum[1]);
            document.getElementById("OGPlugin-ogameurl"+parnumservernum).value = res_OgameServerNameNum[2];
            
            // change l'tiquette de numro d'univers
            OGPlugin_UniverseLabelChange(parnumservernum, ogs_numuniv_tab[parnumservernum-1], '');
            
        } else alert("Le serveur contact\u00e9 ("+parnumservernum+") n'a retourn\u00e9 aucune information valide sur l'univers Ogame choisi.");
}

/**
 * Mthode vnementielle en rponse au click sur le menu contextuel
 * Vrifie la syntaxe du nom de serveur de jeu indic.
 * @param parnumservernum entier indiquant l'indice du compte dont le serveur est  vrifier
 **/
function OGPlugin_CheckGameServerSyntax_OnClick(parnumservernum) {

        // executer ssi ne fait pas suite  ractivation compte
        // rtablissement nom serveur Ogame
        if (ogs_changingaccountstate==false) { 
            lservername = document.getElementById("OGPlugin-ogameurl"+parnumservernum).value;
            res_CheckOgameServerSyntax = OGPlugin_CheckGameServerSyntax(lservername);
            if (res_CheckOgameServerSyntax==1) {
                //alert("Serveur Ogame correct!");
                OGPlugin_AskOgameServerNum_OnClick(parnumservernum, 'Serveur Ogame correct!');
            } else if (res_CheckOgameServerSyntax==2) {
                OGPlugin_AskOgameServerNum_OnClick(parnumservernum, 'Serveur E-Univers correct!');
            }
        }
}

/**
 * action popup: mettre  jour les infos du serveur dsign (mthode popup)
 * @param parnumservernum entier indiquant l'indice du compte dont les infos serveur sont  mettre  jour
 **/
function OGPlugin_UpdateServerInfos_OnClick(parnumservernum) {
        if (ogs_optionpopups_debugmode==true) alert("OGPlugin_UpdateServerInfos_OnClick: "+parnumservernum);

        callingurl = OGPlugin_GetOGSPYUrl(parnumservernum, true);
        if (callingurl == '') {
            alert("L'adresse du serveur OGSPY n\u00b0"+parnumservernum+" n'est pas renseign\u00e9e!");
            return false;
        }
        if (ogs_optionpopups_debugmode==true) alert('OGPlugin_UpdateServerInfos_OnClick: '+callingurl);
        var res_tab = OGPlugin_GetServerNameVer(parnumservernum, callingurl);
        
        // Analyse des rsultats de commande (url ogspy) et notifications
        if (OGPlugin_NotifyOgspyURLResponse(res_tab[1])==false) return false;
        
        ServerNameVer_msg = "Le nom du serveur ogspy est \""+res_tab[1]+"\" et sa version est \""+res_tab[2]+"\"";
        
        var res_GetServerCatAllies = OGPlugin_GetServerCatAllies(parnumservernum, callingurl);
        if (res_GetServerCatAllies[0]==true) ServerCatAllies_msg = "Infos highlighting mises \u00e0 jour\n\n"+res_GetServerCatAllies[0];
        else ServerCatAllies_msg ="Pas de mise \u00e0 jour n\u00e9c\u00e9ssaire de la surbrillance(diplomatie).";

        alert(ServerNameVer_msg+"\n\n"+ServerCatAllies_msg)
}
/**
 * rcuprer le nom et la version du serveur ogspy (mthode popup)
 **/
function OGPlugin_GetServerNameVer_OnClick(parnumservernum) {

        if (ogs_optionpopups_debugmode==true) alert("OGPlugin_GetServerNameVer_OnClick: "+parnumservernum);
        callingurl = OGPlugin_GetOGSPYUrl(parnumservernum, true);
        var res_tab = OGPlugin_GetServerNameVer(parnumservernum, callingurl);
        if (ogs_optionpopups_debugmode==true) alert("Rponse: "+res_tab[0]);
        if (res_tab[0]==true) {
        
            // Analyse des rsultats de commande (url ogspy) et notifications
            if (OGPlugin_NotifyOgspyURLResponse(res_tab[1])==false) return false;
        
            if (confirm("Le nom du serveur ogspy est \""+res_tab[1]+"\" et sa version est \""+res_tab[2]+"\"\n\nSouhaitez-vous mettre \u00e0 jour ces informations?")) {
                var prefs = OGPlugin_getPrefs();
                prefs.setCharPref("OGPlugin.settings.serverversion"+parnumservernum, res_tab[2]);
                document.getElementById("OGPlugin-url"+parnumservernum).setAttribute("tooltiptext", res_tab[1]+'('+res_tab[2]+')');
            }
            
        } else alert("Le serveur n'a pas r\u00e9pondu correctement \u00e0 l'identification ou n'\u00e9tait pas disponible!\n"+
               "V\u00e9rifiez l'adresse du serveur saisie, que le module OGS Plugin est bien install\u00e9 et actif!");
        
        // mettre  jour, tiquette droite version + tooltips serveurs
        document.getElementById("OGPlugin-version"+parnumservernum).value = res_tab[2];
}

/**
 * rcuprer les infos de surbrillance du serveur(diplomatie) (mthode popup)
 **/
function OGPlugin_GetServerHighlighting_OnClick(parnumserverurl) {
        if (ogs_optionpopups_debugmode==true) alert("OGPlugin_GetServerHighlighting_OnClick: "+parnumserverurl);
        callingurl = OGPlugin_GetOGSPYUrl(parnumserverurl, true);
        var res_GetServerCatAllies = OGPlugin_GetServerCatAllies(parnumserverurl, callingurl);
        
        catalliesenum_msg = "Donn\u00e9es diplomatiques du serveur n\u00b0 "+parnumserverurl+":\n_ Alliances amies: "+res_GetServerCatAllies[2]+"\n_ Alliances en pacte total: "+res_GetServerCatAllies[3]+"\n_ Alliances ennemies: "+res_GetServerCatAllies[4]+"\n_ Alliances commerciales: "+res_GetServerCatAllies[5];
        
        if (res_GetServerCatAllies[0]==true) {
            if (confirm(catalliesenum_msg+"\n\nInfos highlighting mises \u00e0 jour sur le serveur.\n\nVoulez-vous enregistrer les informations dans les propri\u00e9t\u00e9s?")) {
               // enregistrement dans les proprits
               OGPlugin_setCharPref("OGPlugin.settings.srvfriendlyallies"+parnumserverurl, res_GetServerCatAllies[2], '');
               OGPlugin_setCharPref("OGPlugin.settings.srvpnaallies"+parnumserverurl, res_GetServerCatAllies[3], '');
               OGPlugin_setCharPref("OGPlugin.settings.srvenemyallies"+parnumserverurl, res_GetServerCatAllies[4], '');
               OGPlugin_setCharPref("OGPlugin.settings.srvtradingallies"+parnumserverurl, res_GetServerCatAllies[5], '');
            }
        } else {
            if (res_GetServerCatAllies[0]==false)
                alert(catalliesenum_msg+"\n\nPas de mise \u00e0 jour n\u00e9c\u00e9ssaire de la surbrillance(diplomatie).");
            else
                alert("Les infos de surbrillance(diplomatie) de sont pas disponibles sur ce serveur.");
        }
}

//==============================================================================

function OGPlugin_CrypCheckBox_Onchange(numserverurl) 
{        
        if (OGPlugin_getBoolPref('OGPlugin.settings.iscryptedpass'+numserverurl, false, '')==true && pwdcryptoptchangedtab[numserverurl]==false && passwordchangedtab[numserverurl]==false) {
            alert("Le cryptage du mot de passe n'est pas r\u00e9versible!\nVeuillez le saisir de nouveau.");
            var targetpassedit = document.getElementById("OGPlugin-password"+numserverurl);
            targetpassedit.value="";            
        }
        
        pwdcryptoptchangedtab[numserverurl]=true;
        var targetpasscryptopt = document.getElementById("OGPlugin-iscryptedpass"+numserverurl);
        // obsolte: le mot de passe est hash  la sortie du panneau
        /* if (targetpasscryptopt.checked==false && passwordchangedtab[numserverurl]==false) {
            alert("Le cryptage n'est pas reversible,\nveuillez entrer de nouveau un mot de passe!");
            var targetpassedit = document.getElementById("OGPlugin-password"+numserverurl);
            targetpassedit.value="";
        } */
               
}

function OGPlugin_HideHighlightingTab(parHideTab) {
      
      var target_tabpanel = document.getElementById("OGPlugin-page_highlighting");
      var target_tab = document.getElementById("OGPlugin-tab_highlighting");

      if (parHideTab==true) {
          target_tab.setAttribute("hidden", "true");
          //target_tabpanel.setAttribute("hidden", true); // chang
          
      } else {
          //target_tabpanel.setAttribute("hidden", false); // chang
          target_tab.setAttribute("hidden", "false");
          // norm dj xcute si parHideTab
          // OGPlugin_InitColorComboBoxes(); // rgnre les listes de botes      
      }  
}

function OGPlugin_DisableHighlighting_Onchange() { // mthode vnementielle
      // OGPlugin-disablehighlighting;
      var targetenahighlight_checkbox = document.getElementById("OGPlugin-enablehighlighting");
      
      //targetdishighlight_checkbox.setAttribute("disabled","true");
      if (targetenahighlight_checkbox.checked==false) {
          OGPlugin_HideHighlightingTab(true);
          alert("L'onglet surbrillance est maintenant cach\u00e9 mais sera de nouveau disponible apr\u00e8s avoir cocher cette option et r\u00e9ouvert le panneau Options!");
      } else {
          alert("L'onglet surbrillance ne peut etre restaur\u00e9 maintenant et sera de nouveau disponible \u00e0 la prochaine ouverture du panneau options!");
      }
}


function OGPlugin_Password_OnKeyPress(numserverurl, parkeyStroke) {

        keypress_buffer[numserverurl-1]=null;
        
        // cas premire modification et cryptage actif enregistr
        if (passwordchangedtab[numserverurl-1]==false) {
           var targetcryptcheckbox = document.getElementById("OGPlugin-iscryptedpass"+numserverurl);
           if (targetcryptcheckbox!=null) {
              targetcryptcheckbox.setAttribute("disabled", false);
              targetcryptcheckbox.checked=false;
           }           
           // si modification bote mot de passe, on efface pour viter les erreurs ventuelles de l'utilisateur
           var targetpasswordedit = document.getElementById("OGPlugin-password"+numserverurl);
           
          code_eventChooser = (!document.all) ? parkeyStroke.which : parkeyStroke.keyCode;
          keypress_buffer[numserverurl-1] = code_eventChooser;
          targetpasswordedit.setAttribute("type", "text");
        }

        //if (ogs_passwordman_debugmode==true) alert("Boite pass: "+numserverurl);
        passwordchangedtab[numserverurl-1]=true;
}

function OGPlugin_Password_OnKeyUp(numserverurl, parkeyStroke) { // obsolte

        if (keypress_buffer[numserverurl-1]!=null) {
            var code_which = String.fromCharCode(keypress_buffer[numserverurl-1]);
             var targetpasswordedit = document.getElementById("OGPlugin-password"+numserverurl);
            targetpasswordedit.value = code_which;
        }
}

function OGPlugin_ogspyforallLabel_OnClick(numserverurl, parmousevent) { // obsolte

        
        ogs_ogameurl_id=numserverurl;
        
        if (parmousevent.button ==0) OGPlugin_HideOgameParControls(numserverurl, false, true);
        else if ( parmousevent.button==2) {
           var lcontextmenu = document.getElementById("ogameurl-popup");
           var poselement = document.getElementById('OGPlugin-ogspyforall'+numserverurl);
           lcontextmenu.showPopup(poselement, -1, -1, 'bottomleft', 'bottomleft');
        }
}

function GetTestUrlServer(numserverurl) {
        testurlserver = document.getElementById("OGPlugin-url"+numserverurl).value;
        testnumserverurl = numserverurl;
        targetbutton = document.getElementById("OGPlugin-testnotifymodebutton"); 
        targetbutton.setAttribute("tooltiptext", OGPlugin_GetLocString("optdlg.testnotificationmode")+testurlserver );                
        
}

function OGPlugin_AllServerParamsReset() {
        // 8 -> 7 lements de saisies
        for (cpt=1; cpt<8; cpt++) // ok
           serverurlchanged[cpt-1]=true;

        alert(OGPlugin_GetLocString("resetallserverparams_alert"));
}

/**
 * rcupre les infos sur les droits utilisateurs depuis le serveur de rang donn
 **/
function OGPlugin_GetUserRights_OnClick(parnumserver) {

        // testnumserverurl
        ltesturlserver = OGPlugin_GetOGSPYUrl(parnumserver, true);
        if (ltesturlserver == '') {
            alert("L'adresse du serveur OGSPY n\u00b0"+parnumserver+" n'est pas renseign\u00e9e!");
            return false;
        }
        lusername = document.getElementById("OGPlugin-username"+parnumserver).value;
        lservername = OGPlugin_getCharPref("OGPlugin.settings.servername"+(parnumserver), '', '');
        if (OGPlugin_TrimString(lservername)!="") lservername_label =  " sur\n"+lservername+"\n("+ltesturlserver+")!";
        else lservername_label = '!';
        
        if (OGPlugin_TrimString(lusername)!="") lusername_label = " pour "+lusername;
        else lusername_label = "";

        res_userrights = OGPlugin_DlgSendGetCommand(ltesturlserver,'getuserrights&user='+lusername, true, true);
        
        if (ogs_getcommand_debugmode==true) alert(res_userrights);
        if (res_userrights=='750') serverfailure_msg="\nLe serveur contact\u00e9 ("+parnumserver+") n'\u00e9tait pas disponible!";
        else serverfailure_msg = "";
        
        if (res_userrights[0]!='!' && OGPlugin_TrimString(res_userrights)!='')
            var userrights_caption = "Affichage des permissions pour "+lusername+" sur "+lservername+"("+parnumserver+"):\n"
                                +ltesturlserver+"\n\nDroits individuels:\n_ Compte actif: "+OGPlugin_GetOuiNon(res_userrights[22])+"\n_ Administrateur : "+OGPlugin_GetOuiNon(res_userrights[0])+"\n_ Coadministrateur: "+OGPlugin_GetOuiNon(res_userrights[2])
                                +"\n_ Gestion utilisateurs: "+OGPlugin_GetOuiNon(res_userrights[4])+"\n_ Gestion classements: "+OGPlugin_GetOuiNon(res_userrights[6])+"\n\nDroits de groupe:\n_ Connexion OGS: "+OGPlugin_GetOuiNon(res_userrights[8])
                                +"\n_ Importer galaxies: "+OGPlugin_GetOuiNon(res_userrights[10])+"\n_ Exporter galaxies: "+OGPlugin_GetOuiNon(res_userrights[12])+"\n_ Importer rapports: "+OGPlugin_GetOuiNon(res_userrights[14])
                                +"\n_ Exporter rapports: "+OGPlugin_GetOuiNon(res_userrights[16])+"\n_ Importer classements: "+OGPlugin_GetOuiNon(res_userrights[18])+"\n_ Exporter classements: "+OGPlugin_GetOuiNon(res_userrights[20]);
        else var userrights_caption = "Aucune info de droits ne peut \u00eatre r\u00e9cup\u00e9r\u00e9e"+lusername_label+lservername_label;
        alert(userrights_caption);
}

/**
 * rcupre les version du script ogsplugin.php ainsi que la version du module OGS Plugin
 * @param parnumserver entier
 **/
function OGPlugin_GetModOGSVer(parnumserver) {
        // testnumserverurl
        ltesturlserver = OGPlugin_GetOGSPYUrl(parnumserver, true);
        if (ltesturlserver == '') {
            alert("L'adresse du serveur OGSPY n\u00b0"+parnumserver+" n'est pas renseign\u00e9e!");
            return false;
        }
        lusername = document.getElementById("OGPlugin-username"+parnumserver).value;
        lservername = OGPlugin_getCharPref("OGPlugin.settings.servername"+(parnumserver), '', '');
        if (OGPlugin_TrimString(lservername)!="") lservername_label =  " sur\n"+lservername+"\n("+ltesturlserver+")!";
        else lservername_label = '!';

        if (OGPlugin_TrimString(lusername)!="") lusername_label = " pour "+lusername;
        else lusername_label = "";

        res_modogsver = OGPlugin_DlgSendGetCommand(ltesturlserver,'getogspluginmodversion', true, true);

        if (ogs_getcommand_debugmode==true) alert(res_modogsver);
        if (res_modogsver=='750') serverfailure_msg="\nLe serveur contact\u00e9 ("+parnumserver+") n'\u00e9tait pas disponible!";
        else serverfailure_msg = "";
        res_modogsver_tab = res_modogsver.match(/^([\d,\.]+)\|([\d,\.]+)$/);
        if (res_modogsver_tab) {
                    alert("Le serveur a retourn\u00e9 les versions suivantes:\n_ version du script: "+res_modogsver_tab[1]+"\n_ version du module OGS Plugin: "+res_modogsver_tab[2]);
        } else alert("Le serveur n'a retourn\u00e9 aucune donne valide sur la version du module.");
        
}

/**
 * Mthode vnement, rception du focus par le contrle Onglets
 **/
function OGPlugin_OptionsPanel_OnTabFocus() {

    // Test conflit options foxgame
    if (ogs_testfoxgameoptions && OGPlugin_getBoolPref('OGPlugin.settings.showfalseconfigpopups', true, 'OGPlugin-options-showfalseconfigpopups')) {
        ogs_testfoxgameoptions = false;
        OGPlugin_CheckFoxgameConflict();
    }

    // code plus appropri ici, le popup doit apparatre aprs l'affichage du panneau option
    if (document.getElementById('OGPlugin-tabbox_options').selectedIndex == ogs_accounttab_pos &&
        !document.getElementById('OGPlugin-tab_ogspyaccounts').collapsed) {
        if ( OGPlugin_getCharPref("OGPlugin.settings.url"+1, '', "") == '' &&
             OGPlugin_getCharPref("OGPlugin.settings.url"+2, '', "") == '' && ogs_firsttime_accountset &&
             OGPlugin_getBoolPref('OGPlugin.settings.showfalseconfigpopups', true, '')) {
            alert("Si c'est votre premi\u00e8re cr\u00e9ation de compte, veuillez commencer par entrer\n"
            +"une adresse de plugin/portail (bo\u00eetes URL plugin web) afin d'engager l'assistant de param\u00e9trage.\n\n"
            +"Une adresse peut se terminer par index.php, ogsplugin.php ou xtense.php/xtense_plugin.php .\n"
            +"\nDe ce premier param\u00e9trage d\u00e9pendent la configuration des autres options et la reconnaissance des pages de jeu.")
        }
        ogs_firsttime_accountset = false;
    };

}

/**
 * Mthode vnement, choix d'un onglet du panneau Options
 **/
function OGPlugin_OptionsPanel_OnTabSelect() {




    if (document.getElementById('OGPlugin-tabbox_options').selectedIndex == ogs_highlightingtab_pos && !document.getElementById('OGPlugin-tab_highlighting').collapsed  )
    {
        //if (!ogs_highlightingtab_set) alert("onglet surbrillance");
        if (ogs_highlightingtab_set==false) {
            OGPlugin_InitColorComboBoxes();
            ogs_highlightingtab_set = true;
        }

    }

    OGPlugin_InitServerIdChoiceMenuList(); 

}

/**
 * analyse des options foxgame potentiellement conflictuelles
 **/
function OGPlugin_CheckFoxgameConflict() {

        var foxgameoptionscheckup = "Les options Foxgame suivantes ont \u00e9t\u00e9 d\u00e9tect\u00e9e:\n";
        var onefoxgameoptionfound = false;
        // foxgame.userprefs.foxgameAddMilosButtons
        if (OGPlugin_getBoolPref('foxgame.userprefs.foxgameAddMilosButtons', false, '')) {
            foxgameoptionscheckup += "_ Ajouter des boutons dans la page galaxie\n";
            onefoxgameoptionfound = true;
        }
            
        // foxgame.userprefs.foxgameAddStatButtons
        if (OGPlugin_getBoolPref('foxgame.userprefs.foxgameAddStatButtons', false, '')) {
            foxgameoptionscheckup += "_ Ajouter des boutons dans la page statistiques\n";
            onefoxgameoptionfound = true;
        }
        
        // foxgame.userprefs.foxgameAddReportButtons
        if (OGPlugin_getBoolPref('foxgame.userprefs.foxgameAddReportButtons', false, '')) {
            foxgameoptionscheckup += "_ Ajouter des boutons dans la page messages\n";
            onefoxgameoptionfound = true;
        }
        foxgameoptionscheckup += "\nSouhaitez-vous annuler ces options par pr\u00e9caution? (risque de conflit)";
            
        if (onefoxgameoptionfound && confirm(foxgameoptionscheckup)) {
            OGPlugin_setBoolPref('foxgame.userprefs.foxgameAddMilosButtons', false, '');
            OGPlugin_setBoolPref('foxgame.userprefs.foxgameAddStatButtons', false, '');
            OGPlugin_setBoolPref('foxgame.userprefs.foxgameAddReportButtons', false, '');
        }

}

/**
 * Affichage  la vole de la bote des choix de comptes pour la surbrillance
 *  // anc. menu raccourci de la barre d'outils: bouton "OGSPY"
 **/
function OGPlugin_InitServerIdChoiceMenuList() {
        var prefs = OGPlugin_getPrefs();
        var lnewmenuitem;
        var ltargetmenulist = document.getElementById("OGPlugin-chooseserveridformats");        
        ltargetmenulist.removeAllItems();        
        // 8 -> 7 lements de saisies
        for (cpt=1; cpt<8; cpt++) {
             lnewmenuitem = null;
             if (prefs.prefHasUserValue("OGPlugin.settings.servername"+cpt)) {
                lservername=cpt+". "+prefs.getCharPref("OGPlugin.settings.servername"+cpt);
                if(lservername=="") {
                    lservername="----------------"
                    lnewmenuitem.setAttribute('disabled', true);
                }
                lnewmenuitem = ltargetmenulist.appendItem ( lservername, cpt, "" );
                lnewmenuitem.setAttribute('onclick', "OGPlugin_LoadServerIdFormatsParams("+cpt+");")
               // lnewmenuitem.setAttribute('crop', 'end');
                //lnewmenuitem.setAttribute('style', 'width: 180px');
             }
        }
}


/**
 * Initialisation du contenu des liste de couleurs des botes de choix(surbrillance)
 **/
function OGPlugin_InitColorComboBoxes() {
      ltopNformatcolorbox = document.getElementById("OGPlugin-topNformatcolor");
      lfriendlyformatcolorbox = document.getElementById("OGPlugin-friendlyformatcolor");
      lenemyformatcolorbox = document.getElementById("OGPlugin-enemyformatcolor");
      lpnaformatcolorbox = document.getElementById("OGPlugin-pnaformatcolor");
      ltradingformatcolorbox = document.getElementById("OGPlugin-tradingformatcolor");
      ldebrisfieldcolorbox = document.getElementById("OGPlugin-debrisfieldcolor")// debrisfieldcolor
      //------------------------
      var lcommonstyleparams ="font-weight:bold; text-align: left; color:";
      var lcommonfontcolor = "black;",  lcommonbackgroundtext = " background-color: ";
      var lnewmenuitem=null;
      
      ltopNformatcolorbox.removeAllItems();
      lfriendlyformatcolorbox.removeAllItems();
      lenemyformatcolorbox.removeAllItems();
      lpnaformatcolorbox.removeAllItems();
      ltradingformatcolorbox.removeAllItems();        
      ldebrisfieldcolorbox.removeAllItems();
      
      for (cpt=0; cpt<BasicColorNames.length; cpt++) {           
           //-- 
           lnewmenuitem=ltradingformatcolorbox.appendItem (cpt+". "+ BasicColorNames[cpt], BasicColorNames[cpt], "" );
           lnewmenuitem.setAttribute("style",lcommonstyleparams+(OGPlugin_IsDarkBackGroundColor(cpt)? 'white;' : 'black;')+lcommonbackgroundtext+BasicColorNames[cpt]+";");
           lnewmenuitem.setAttribute("onclick","OGPlugin_SetGroupControlsColor('"+BasicColorNames[cpt]+"', 'trading', "+cpt+");");
      }      

      for (cpt=0; cpt<BasicColorNames.length; cpt++) {           
           //-- 
           lnewmenuitem=ltopNformatcolorbox.appendItem ( cpt+". "+BasicColorNames[cpt], BasicColorNames[cpt], "" );
           lnewmenuitem.setAttribute("style",lcommonstyleparams+(OGPlugin_IsDarkBackGroundColor(cpt)? 'white;' : 'black;')+lcommonbackgroundtext+BasicColorNames[cpt]+";");
           lnewmenuitem.setAttribute("onclick","OGPlugin_SetGroupControlsColor('"+BasicColorNames[cpt]+"', 'topN', "+cpt+");");

      }
       
      for (cpt=0; cpt<BasicColorNames.length; cpt++) {           
           //-- 
           lnewmenuitem=lfriendlyformatcolorbox.appendItem ( cpt+". "+BasicColorNames[cpt], BasicColorNames[cpt], "" );
           lnewmenuitem.setAttribute("style",lcommonstyleparams+(OGPlugin_IsDarkBackGroundColor(cpt)? 'white;' : 'black;')+lcommonbackgroundtext+BasicColorNames[cpt]+";");
           lnewmenuitem.setAttribute("onclick","OGPlugin_SetGroupControlsColor('"+BasicColorNames[cpt]+"', 'friendly', "+cpt+");");
      } 
      
      for (cpt=0; cpt<BasicColorNames.length; cpt++) {           
           //-- 
           lnewmenuitem=lenemyformatcolorbox.appendItem (cpt+". "+ BasicColorNames[cpt], BasicColorNames[cpt], "" );
           lnewmenuitem.setAttribute("style",lcommonstyleparams+(OGPlugin_IsDarkBackGroundColor(cpt)? 'white;' : 'black;')+lcommonbackgroundtext+BasicColorNames[cpt]+";");
           lnewmenuitem.setAttribute("onclick","OGPlugin_SetGroupControlsColor('"+BasicColorNames[cpt]+"', 'enemy', "+cpt+");");
      } 
      
      for (cpt=0; cpt<BasicColorNames.length; cpt++) {           
           //-- 
           lnewmenuitem=lpnaformatcolorbox.appendItem (cpt+". "+ BasicColorNames[cpt], BasicColorNames[cpt], "" );
           lnewmenuitem.setAttribute("style",lcommonstyleparams+(OGPlugin_IsDarkBackGroundColor(cpt)? 'white;' : 'black;')+lcommonbackgroundtext+BasicColorNames[cpt]+";");
           lnewmenuitem.setAttribute("onclick","OGPlugin_SetGroupControlsColor('"+BasicColorNames[cpt]+"', 'pna', "+cpt+");");
      }

      // Gnration des couleur de la bote choix - Champ de Ruine
      for (cpt=0; cpt<BasicColorNames.length; cpt++) {
           //--
           lnewmenuitem=ldebrisfieldcolorbox.appendItem (cpt+". "+ BasicColorNames[cpt], BasicColorNames[cpt], "" );
           lnewmenuitem.setAttribute("style",lcommonstyleparams+(OGPlugin_IsDarkBackGroundColor(cpt)? 'white;' : 'black;')+lcommonbackgroundtext+BasicColorNames[cpt]+";");
           //lnewmenuitem.setAttribute("onclick","OGPlugin_SetGroupControlsColor('"+BasicColorNames[cpt]+"', 'debris', "+cpt+");");
           lnewmenuitem.setAttribute("onclick","OGPlugin_SetGroupControlsColor('"+BasicColorNames[cpt]+"', 'debris', "+cpt+");");
      }
}

/**
 * Dtermine si l'indice d'une couleu de fond correspond  une couleur sombre
 * cf OGPlugin_InitColorComboBoxes: colorindex est l'indice de la boucle for
 **/
function OGPlugin_IsDarkBackGroundColor(colorindex) {
     var result = false;
     if ((colorindex>=19 && colorindex<=23)
          || (colorindex>=38 && colorindex<=43)
          || (colorindex>=80 && colorindex<=87)
          || (colorindex>=105 && colorindex<120)
          || (colorindex>=131 && colorindex<=133))
        result = true;
     return result;
}


/**
 * Ajuste les attribut de style par couleur suivant les contrle impliqus
 **/
function OGPlugin_SetGroupControlsColor( colorname, groupname, parcolorindex) {
      //alert("mise en couleur topN: "+colorname+" de "+itemindex);
      var lcommonstyleparams ="padding-top:5px; font-weight:bold; text-align: center; width: 100px; color: ";
      if (parcolorindex==null || !( parcolorindex>=0 && parcolorindex<=300)) var lcommonstyleparamsfontcolor = "white;";
      else var lcommonstyleparamsfontcolor= (OGPlugin_IsDarkBackGroundColor(parcolorindex) ? 'white;' : 'black;')
      //alert(lcommonstyleparamsfontcolor+"-"+parcolorindex);
      var lcommonstyleparamsbackgroundstyle = " background-color: ";
      
      var lcommonstyletextparams = "width: 100px; font-weight:bold; color: ";
      var ltargettextbox;
      
      // Changement de couleur de la police quantit de champ minimum
      if (groupname=="debris") { // seulement alliance amies, ennemies, comerantes et pna
          ltargettextbox = document.getElementById("OGPlugin-debrisfieldminvalue");
          ltargettextbox.setAttribute("style","width: 50px; font-weight:bold; color: "+colorname+";");
          return;
      }
      
      // Mise  jour des tiquette tmoin de couleur par catgorie
      var ltargetcaption = document.getElementById("OGPlugin-"+groupname+"label");
      ltargetcaption.setAttribute("style",lcommonstyleparams+lcommonstyleparamsfontcolor+lcommonstyleparamsbackgroundstyle+colorname+";");
      //{ // revoir exceptions

      //-------------
      // Mise  jour des contrle "amis","ennemis","commerant"
      if (groupname!="pna" && groupname!="topN" ) {
          // Liste de joueurs
          ltargettextbox = document.getElementById("OGPlugin-"+groupname+"playerslist");
          ltargettextbox.setAttribute("style",lcommonstyletextparams+colorname+";");
          //------------- 
          // Liste d'alliances
          ltargettextbox = document.getElementById("OGPlugin-"+groupname+"allyslist");
          ltargettextbox.setAttribute("style",lcommonstyletextparams+colorname+";");
      }               
      //-------------
      // Mise  jour des led tmoins pour la couleur: surbrillance centralise(diplomatie)
      if (groupname!="topN") { // seulement alliance amies, ennemies, comerantes et pna
          ltargetcaption = document.getElementById("OGPlugin-ogspy"+groupname+"allyled");
          ltargetcaption.setAttribute("style","background-color: "+colorname+";");
      }      
      //-------------

}

/**
 * inusit
 **/
function OGPlugin_ProbeServerNotifyMode() {
}
