 /*
Barre d'Outils OGSPY, extension firefox d'aide aux mise  jour de serveurs OGSPY

OGSPY Toolbar, a firefox plugin for helping players in updating OGSPY servers game datas

Copyright (C) 2006 Naqdazar (ajdr@free.fr)

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
au titre des clauses de la Licence Publique Gnrale GNU, telle que publie par la
Free Software Foundation ; soit la version 2 de la Licence.
Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ;
 sans mme une garantie implicite de COMMERCIABILITE ou DE CONFORMITE A UNE UTILISATION PARTICULIERE. 
 
 Voir la Licence Publique Gnrale GNU pour plus de dtails. 
 
 Vous devriez avoir reu un exemplaire de la Licence Publique Gnrale GNU avec ce programme ;
  si ce n'est pas le cas, crivez  la Free Software Foundation Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

This program is free software; you can redistribute it and/or modify it under the
terms of the GNU General Public licence as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details.

You should have received a copy of the GNU General Public licence along with this program;
 if not, write to the Free Software Foundation, Inc., 
 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
 /*
 ** pour plus d'infos
 ** cf. extensions.js qui se trouve dans  chrome/toolkit.jar!/content/mozapps/extensions
 */
 
 const ogs_debug_autoupdate_mode=false; 
 
  // GUID Extension barre d'outils firefox
 // {B2DA00A7-44EC-4EE0-BCAF-202DF33AB878}
 
 function UpdateCheckListener() {  
    this._addons = [];
 }
 
/**
 * @class UpdateCheckListener
 * classe destine  piloter le gstionnaire d'extension et de mise  jour.
 *  @brief descripion brief .
 *
 **/
 UpdateCheckListener.prototype = {
    _dolog: false,
    _extmanager: null,
    _askrestartfirefox: false,
    _checksilentupdate: false,
    // _OGPlugin_SetStatusViewLabel(statetext, labeltext)
    // _setstatusviewlabel: function(statetext, labeltext),
    _addons: [],


    /**
     * @fcn InitExtManager
     * Initialisation du gestionnaire d'extensions.
     * @param ExtMan
     **/
    InitExtManager: function(ExtMan) {
       this._extmanager = ExtMan;
    },    
    
    doLogAction: function(pdoLog) {
       this._dolog = pdoLog;
    },
    
    /* SetStatusViewLabelFunc: function(pStatusViewLabelFunc) {
       this.setstatusviewlabel = pStatusViewLabelFunc;
    },  */   
    
    AskRestartFirefox: function(paskrestartfirefox) {
       this._askrestartfirefox = paskrestartfirefox;
    },  
    
    CheckSilentUpdate: function(pchecksilentupdate) {
       this._checksilentupdate = pchecksilentupdate;
    },
  

    onUpdateStarted: function() {
        // if (this._dolog==true) OGPlugin_SetStatusViewLabel("notify", "onUpdateStarted");
     },

    onUpdateEnded: function() {
     
       //alert("onUpdateEnded: "+this._addons[0].name+"("+this._addons.length+")");
       // if (this._dolog==true) OGPlugin_SetStatusViewLabel("notify", "onUpdateEnded");

       if (this._addons.length > 0) {
       if (this._extmanager!=null) {
          if (OGPlugin_getBoolPref('OGPlugin.settings.modresponseinstallupdate', true, 'OGPlugin-modresponseinstallupdate')==true)
              this._extmanager.addDownloads(this._addons, this._addons.length, true);
       }
         //alert("add download");
       // if (this._dolog==true) OGPlugin_SetStatusViewLabel("notify", "Ajout du t\u00e9l\u00e9chargement de "+this._addons[0].name);
       if (this._askrestartfirefox==true)       
          if (confirm("Red\u00e9marrer Firefox?")==true) OGPlugin_RestartFirefox();    
       }  
  
    },

    onAddonUpdateStarted: function(addon) {
    //if (addon.id=='{B2DA00A7-44EC-4EE0-BCAF-202DF33AB878}' && this._dolog==true) OGPlugin_SetStatusViewLabel("notify", "onAddonUpdateStarted"); 
     },

    onAddonUpdateEnded: function(addon, status) {
     switch (status)
     {
     // cf httphttp://xulplanet.com/references/xpcomref/ifaces/nsIAddonUpdateCheckListener.html
     case Components.interfaces.nsIAddonUpdateCheckListener.STATUS_UPDATE:

         // choix utilisateur pour installation mise  jour 
         if (OGPlugin_getBoolPref('OGPlugin.settings.modresponseinstallupdate', true, 'OGPlugin-modresponseinstallupdate')==true && this._checksilentupdate==false) {
            if (confirm("Barre d'Outils OGSPY,\nInstaller la mise \u00e0 jour trouv\u00e9e?")==true) this._addons.push(addon);  // ajout dans la liste  tlcharger
         }
         
         if (addon.id=='{B2DA00A7-44EC-4EE0-BCAF-202DF33AB878}' && this._dolog==true) OGPlugin_SetStatusViewLabel("notify", "Mise \u00e0 jour de la barre d'outils disponible");
         OGPlugin_DoAlertTooltip('Mise \u00e0 jour pour Firefox', "Une mise \u00e0 jour de la Barre d'Outils OGSPY pour Firefox est disponible en t\u00e9l\u00e9chargement!");         
         break;
         
     case Components.interfaces.nsIAddonUpdateCheckListener.STATUS_FAILURE:
         // ouch :)
         if (addon.id=='{B2DA00A7-44EC-4EE0-BCAF-202DF33AB878}' && this._dolog==true) OGPlugin_SetStatusViewLabel("notify", "Echec de mise \u00e0 jour de la barre d'outils");
         break;
     case Components.interfaces.nsIAddonUpdateCheckListener.STATUS_NO_UPDATE:
         // 
         if (addon.id=='{B2DA00A7-44EC-4EE0-BCAF-202DF33AB878}' && this._dolog==true) OGPlugin_SetStatusViewLabel("notify", "Aucune mise \u00e0 jour disponible pour la barre d'outils!");
         if (document.getElementById("OGPlugin-autoupdate_button")!=null) // est-on sur le panneau options?
            alert("Aucune mise \u00e0 jour de l'extension disponible.");
         break;
     case Components.interfaces.nsIAddonUpdateCheckListener.STATUS_PENDING_OP:
         //        
         if (addon.id=='{B2DA00A7-44EC-4EE0-BCAF-202DF33AB878}' && this._dolog==true) OGPlugin_SetStatusViewLabel("notify", "Mise \u00e0 jour de l'extension Barre d'Outils pour OGSPY en attente!");
         OGPlugin_DoAlertTooltip('Mise \u00e0 jour pour Firefox', "Mise \u00e0 jour de l'extension Barre d'Outils pour OGSPY en attente!")
         if (this._askrestartfirefox==true && this._checksilentupdate==false)
            if (confirm("Red\u00e9marrer Firefox?")==true) OGPlugin_RestartFirefox();           
         break;              
     default :
     if (addon.id=='{B2DA00A7-44EC-4EE0-BCAF-202DF33AB878}' && this._dolog==true) OGPlugin_SetStatusViewLabel("notify", "Autre status "+status);
       break;
     }
    },

    QueryInterface: function(iid) {
     if (!iid.equals(Components.interfaces.nsIAddonUpdateCheckListener) &&
        !iid.equals(Components.interfaces.nsISupports)) {
         throw gComponents.results.NS_ERROR_NO_INTERFACE;
       }
     return this;
    }
 };
 
 
function OGPlugin_UpdateToolbar(parAskRestart, parlogAction, parCheckSilentUpdate) {
        // on instancie un composant type extension manager
       var em = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
       
       // on l'utilise pour recuperer la liste des extensions
       var items = em.getItemList(Components.interfaces.nsIUpdateItem.TYPE_ADDON, { });
       
       // on instancie le listener tel que dcrit dans le code ci dessus.
       var listener = new UpdateCheckListener(true);
       
       // activation de la journalisation
       listener.CheckSilentUpdate(parCheckSilentUpdate);
       listener.doLogAction(parlogAction);
       listener.InitExtManager(em);
       //listener.AskRestartFirefox(parAskRestart);
       
       //listener.SetStatusViewLabelFunc(OGPlugin_SetStatusViewLabel);       // filtrage de la liste des extenions rcupres pour ne garder que les infos de la barre d'outils 
       var extlist = new Array();
       
       extlist[0]=em.getItemForID('{B2DA00A7-44EC-4EE0-BCAF-202DF33AB878}');
       
       // mise  jour de la barre
       em.update(extlist, extlist.length, false, listener);       
       
       /* if (window!=null && window.arguments.length>0) {
           var nsCommandLine = window.arguments[0];
           alert("Automaj: \n"+nsCommandLine);
           nsCommandLine = nsCommandLine.QueryInterface(Components.interfaces.nsICommandLine);
       } else var nsCommandLine="";
       
       // validation du tlchargement
       em.start(nsCommandLine);  */
 
 }
 
